import 'package:hotech_flutter_utilities/model/ResModel.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsGallery.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsGalleryItem.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsSlider.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsSliderItem.dart';
import 'package:hotech_flutter_utilities/model/cms/Faq.dart';
import 'package:hotech_flutter_utilities/model/cms/surveyScore.dart';
import 'package:hotech_flutter_utilities/model/crm/Bonustrans.dart';
import 'package:hotech_flutter_utilities/model/crm/BonustransGift.dart';
import 'package:hotech_flutter_utilities/model/crm/BonustransGiftSent.dart';
import 'package:hotech_flutter_utilities/model/crm/Memcard.dart';
import 'package:hotech_flutter_utilities/model/crm/Survey.dart';
import 'package:hotech_flutter_utilities/model/crm/Surveyanswer.dart';
import 'package:hotech_flutter_utilities/model/crm/Surveytree.dart';
import 'package:hotech_flutter_utilities/model/event/Eventloc.dart';
import 'package:hotech_flutter_utilities/model/event/Eventype.dart';
import 'package:hotech_flutter_utilities/model/event/Resevent.dart';
import 'package:hotech_flutter_utilities/model/login/Loginfo.dart';
import 'package:hotech_flutter_utilities/model/pos/Posline.dart';
import 'package:hotech_flutter_utilities/model/pos/Posmain.dart';
import 'package:hotech_flutter_utilities/model/sales/Agency.dart';
import 'package:hotech_flutter_utilities/model/sales/Salegrp.dart';
import 'package:hotech_flutter_utilities/model/stock/Sproduct.dart';
import 'package:hotech_flutter_utilities/model/sysdefs/Currency.dart';
import 'package:hotech_flutter_utilities/model/sysdefs/Depart.dart';
import 'package:hotech_flutter_utilities/model/task/TsDesc.dart';
import 'package:hotech_flutter_utilities/model/task/TsStatus.dart';
import 'package:hotech_flutter_utilities/model/task/Tstrans.dart';
import 'package:hotech_flutter_utilities/model/task/Tstype.dart';
import 'package:hotech_flutter_utilities/model/tools/Geoloc.dart';
import 'package:hotech_flutter_utilities/model/tools/rafile.dart';

import 'cms/Surveytrans.dart';

dynamic listConverter<M>(List input) {
  try {
    return input.map((f) => objectConverter<M>(f)).toList();
  } on Exception catch (exce) {
    print('exce $exce');
    return null;
  }
}

dynamic objectConverter<M>(dynamic input) {
  if (M == Loginfo) {
    return Loginfo.fromJson(input);
  } else if (M == Tstrans) {
    return Tstrans.fromJson(input);
  } else if (M == TsDesc) {
    return TsDesc.fromJson(input);
  } else if (M == Tstype) {
    return Tstype.fromJson(input);
  } else if (M == TsStatus) {
    return TsStatus.fromJson(input);
  } else if (M == Rafile) {
    return Rafile.fromJson(input);
  } else if (M == CmsSlider) {
    return CmsSlider.fromJson(input);
  } else if (M == CmsSliderItem) {
    return CmsSliderItem.fromJson(input);
  } else if (M == CmsGallery) {
    return CmsGallery.fromJson(input);
  } else if (M == CmsGalleryItem) {
    return CmsGalleryItem.fromJson(input);
  } else if (M == Resevent) {
    return Resevent.fromJson(input);
  } else if (M == Eventype) {
    return Eventype.fromJson(input);
  } else if (M == Agency) {
    return Agency.fromJson(input);
  } else if (M == Eventloc) {
    return Eventloc.fromJson(input);
  } else if (M == Geoloc) {
    return Geoloc.fromJson(input);
  } else if (M == ResModel) {
    return ResModel.fromJson(input);
  } else if (M == Bonustrans) {
    return Bonustrans.fromJson(input);
  } else if (M == Memcard) {
    return Memcard.fromJson(input);
  } else if (M == Posline) {
    return Posline.fromJson(input);
  } else if (M == Posmain) {
    return Posmain.fromJson(input);
  } else if (M == Sproduct) {
    return Sproduct.fromJson(input);
  } else if (M == BonustransGift) {
    return BonustransGift.fromJson(input);
  } else if (M == BonustransGiftSent) {
    return BonustransGiftSent.fromJson(input);
  } else if (M == Faq) {
    return Faq.fromJson(input);
  } else if (M == Survey) {
    return Survey.fromJson(input);
  } else if (M == Surveytree) {
    return Surveytree.fromJson(input);
  } else if (M == Surveyanswer) {
    return Surveyanswer.fromJson(input);
  } else if (M == Salegrp) {
    return Salegrp.fromJson(input);
  } else if (M == Surveytrans) {
    return Surveytrans.fromJson(input);
  } else if (M == Depart) {
    return Depart.fromJson(input);
  } else if (M == Currency) {
    return Currency.fromJson(input);
  } else if (M == SurveyScore) {
    return SurveyScore.fromJson(input);
  } else {
    throw Exception("Unknown type");
  }
}
