class HotelInfoItem {
  String code;
  String name;
  String location;
  String content;
  String url;

  HotelInfoItem({this.code, this.name, this.location, this.content, this.url});

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is HotelInfoItem &&
          runtimeType == other.runtimeType &&
          code == other.code &&
          name == other.name &&
          location == other.location &&
          content == other.content &&
          url == other.url;

  @override
  int get hashCode => code.hashCode ^ name.hashCode ^ location.hashCode ^ content.hashCode ^ url.hashCode;

  @override
  String toString() {
    return 'HotelInfoItem{code: $code, name: $name, location: $location, content: $content, url: $url}';
  }
}
