import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Surveytrans extends BaseModelSync {
  String agency;
  String clientcode;
  int clientid;
  String clientname;
  String email;
  String firstname;
  int foliono;
  String gidstr;
  String hotelname;
  bool isactive;
  bool isvalid;
  int langid;
  String lastname;
  String locationcode;
  String locationdesc;
  int locationid;
  String nation;
  String note;
  String peeraddr;
  String portalcode;
  int portalid;
  int refid;
  int refno;
  int revid;
  String roomno;
  int scorefull;
  double scoreper;
  double scoretotal;
  String sourcecode;
  String sourcedesc;
  int sourceid;
  String surveydesc;
  String surveyhash;
  int surveyid;
  String transdate;

  Map<String, dynamic> jsonMap;

  Surveytrans({
    this.agency,
    this.clientcode,
    this.clientid,
    this.clientname,
    this.email,
    this.firstname,
    this.foliono,
    this.gidstr,
    this.hotelname,
    this.isactive,
    this.isvalid,
    this.langid,
    this.lastname,
    this.locationcode,
    this.locationdesc,
    this.locationid,
    this.nation,
    this.note,
    this.peeraddr,
    this.portalcode,
    this.portalid,
    this.refid,
    this.refno,
    this.revid,
    this.roomno,
    this.scorefull,
    this.scoreper,
    this.scoretotal,
    this.sourcecode,
    this.sourcedesc,
    this.sourceid,
    this.surveydesc,
    this.surveyhash,
    this.surveyid,
    this.transdate,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Surveytrans.fromJson(Map<String, dynamic> json) => new Surveytrans(
      agency: json[DBConst.FDN_AGENCY],
      clientcode: json[DBConst.FDN_CLIENTCODE],
      clientid: json[DBConst.FDN_CLIENTID],
      clientname: json[DBConst.FDN_CLIENTNAME],
      email: json[DBConst.FDN_EMAIL],
      firstname: json[DBConst.FDN_FIRSTNAME],
      foliono: json[DBConst.FDN_FOLIONO],
      gidstr: json[DBConst.FDN_GIDSTR],
      hotelname: json[DBConst.FDN_HOTELNAME],
      isactive: json[DBConst.FDN_ISACTIVE],
      isvalid: json[DBConst.FDN_ISVALID],
      langid: json[DBConst.FDN_LANGID],
      lastname: json[DBConst.FDN_LASTNAME],
      locationcode: json[DBConst.FDN_LOCATIONCODE],
      locationdesc: json[DBConst.FDN_LOCATIONDESC],
      locationid: json[DBConst.FDN_LOCATIONID],
      nation: json[DBConst.FDN_NATION],
      note: json[DBConst.FDN_NOTE],
      peeraddr: json[DBConst.FDN_PEERADDR],
      portalcode: json[DBConst.FDN_PORTALCODE],
      portalid: json[DBConst.FDN_PORTALID],
      refid: json[DBConst.FDN_REFID],
      refno: json[DBConst.FDN_REFNO],
      revid: json[DBConst.FDN_REVID],
      roomno: json[DBConst.FDN_ROOMNO],
      scorefull: json[DBConst.FDN_SCOREFULL],
      scoreper: json[DBConst.FDN_SCOREPER],
      scoretotal: json[DBConst.FDN_SCORETOTAL],
      sourcecode: json[DBConst.FDN_SOURCECODE],
      sourcedesc: json[DBConst.FDN_SOURCEDESC],
      sourceid: json[DBConst.FDN_SOURCEID],
      surveydesc: json[DBConst.FDN_SURVEYDESC],
      surveyhash: json[DBConst.FDN_SURVEYHASH],
      surveyid: json[DBConst.FDN_SURVEYID],
      transdate: json[DBConst.FDN_TRANSDATE],
      jsonMap: json);

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_AGENCY: agency,
      DBConst.FDN_CLIENTCODE: clientcode,
      DBConst.FDN_CLIENTID: clientid,
      DBConst.FDN_CLIENTNAME: clientname,
      DBConst.FDN_EMAIL: email,
      DBConst.FDN_FIRSTNAME: firstname,
      DBConst.FDN_FOLIONO: foliono,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_ISVALID: isvalid,
      DBConst.FDN_LANGID: langid,
      DBConst.FDN_LASTNAME: lastname,
      DBConst.FDN_LOCATIONCODE: locationcode,
      DBConst.FDN_LOCATIONDESC: locationdesc,
      DBConst.FDN_LOCATIONID: locationid,
      DBConst.FDN_NATION: nation,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_PEERADDR: peeraddr,
      DBConst.FDN_PORTALCODE: portalcode,
      DBConst.FDN_PORTALID: portalid,
      DBConst.FDN_REFID: refid,
      DBConst.FDN_REFNO: refno,
      DBConst.FDN_REVID: revid,
      DBConst.FDN_ROOMNO: roomno,
      DBConst.FDN_SCOREFULL: scorefull,
      DBConst.FDN_SCOREPER: scoreper,
      DBConst.FDN_SCORETOTAL: scoretotal,
      DBConst.FDN_SOURCECODE: sourcecode,
      DBConst.FDN_SOURCEDESC: sourcedesc,
      DBConst.FDN_SOURCEID: sourceid,
      DBConst.FDN_SURVEYDESC: surveydesc,
      DBConst.FDN_SURVEYHASH: surveyhash,
      DBConst.FDN_SURVEYID: surveyid,
      DBConst.FDN_TRANSDATE: transdate,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Surveytrans &&
          runtimeType == other.runtimeType &&
          agency == other.agency &&
          clientcode == other.clientcode &&
          clientid == other.clientid &&
          clientname == other.clientname &&
          email == other.email &&
          firstname == other.firstname &&
          foliono == other.foliono &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          isactive == other.isactive &&
          isvalid == other.isvalid &&
          langid == other.langid &&
          lastname == other.lastname &&
          locationcode == other.locationcode &&
          locationdesc == other.locationdesc &&
          locationid == other.locationid &&
          nation == other.nation &&
          note == other.note &&
          peeraddr == other.peeraddr &&
          portalcode == other.portalcode &&
          portalid == other.portalid &&
          refid == other.refid &&
          refno == other.refno &&
          revid == other.revid &&
          roomno == other.roomno &&
          scorefull == other.scorefull &&
          scoreper == other.scoreper &&
          scoretotal == other.scoretotal &&
          sourcecode == other.sourcecode &&
          sourcedesc == other.sourcedesc &&
          sourceid == other.sourceid &&
          surveydesc == other.surveydesc &&
          surveyhash == other.surveyhash &&
          surveyid == other.surveyid &&
          transdate == other.transdate &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      agency.hashCode ^
      clientcode.hashCode ^
      clientid.hashCode ^
      clientname.hashCode ^
      email.hashCode ^
      firstname.hashCode ^
      foliono.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      isactive.hashCode ^
      isvalid.hashCode ^
      langid.hashCode ^
      lastname.hashCode ^
      locationcode.hashCode ^
      locationdesc.hashCode ^
      locationid.hashCode ^
      nation.hashCode ^
      note.hashCode ^
      peeraddr.hashCode ^
      portalcode.hashCode ^
      portalid.hashCode ^
      refid.hashCode ^
      refno.hashCode ^
      revid.hashCode ^
      roomno.hashCode ^
      scorefull.hashCode ^
      scoreper.hashCode ^
      scoretotal.hashCode ^
      sourcecode.hashCode ^
      sourcedesc.hashCode ^
      sourceid.hashCode ^
      surveydesc.hashCode ^
      surveyhash.hashCode ^
      surveyid.hashCode ^
      transdate.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Surveytrans{${super.toString()}, agency: $agency, clientcode: $clientcode, clientid: $clientid, clientname: $clientname, email: $email, firstname: $firstname, foliono: $foliono, gidstr: $gidstr, hotelname: $hotelname, isactive: $isactive, isvalid: $isvalid, langid: $langid, lastname: $lastname, locationcode: $locationcode, locationdesc: $locationdesc, locationid: $locationid, nation: $nation, note: $note, peeraddr: $peeraddr, portalcode: $portalcode, portalid: $portalid, refid: $refid, refno: $refno, revid: $revid, roomno: $roomno, scorefull: $scorefull, scoreper: $scoreper, scoretotal: $scoretotal, sourcecode: $sourcecode, sourcedesc: $sourcedesc, sourceid: $sourceid, surveydesc: $surveydesc, surveyhash: $surveyhash, surveyid: $surveyid, transdate: $transdate, jsonMap: $jsonMap}';
  }
}
