import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Surveytree extends BaseModelSync {
  int align;
  int answeralign;
  int chartheight;
  int chartstyle;
  bool chartvisible;
  int chartwidth;
  String customvalue;
  String description;
  String fieldname;
  int fileid;
  String gidstr;
  bool hasnote;
  bool haspb;
  String hotelname;
  int inputwidth;
  bool isactive;
  bool isdef;
  bool isreq;
  bool isweb;
  int itemindex;
  bool itemlabelvisible;
  String langwordcode;
  int maxqs;
  String note;
  int orderno;
  int parentid;
  String path;
  String pathid;
  String qstype;
  int refqsid;
  int resulttableheight;
  bool resulttablevisible;
  String resulttablewidth;
  int rootid;
  double score;
  String surveydesc;
  int surveyid;
  double targetsucc;
  int treelevel;
  int treeorderno;
  String typ;

  Map<String, dynamic> jsonMap;

  Surveytree({
    this.align,
    this.answeralign,
    this.chartheight,
    this.chartstyle,
    this.chartvisible,
    this.chartwidth,
    this.customvalue,
    this.description,
    this.fieldname,
    this.fileid,
    this.gidstr,
    this.hasnote,
    this.haspb,
    this.hotelname,
    this.inputwidth,
    this.isactive,
    this.isdef,
    this.isreq,
    this.isweb,
    this.itemindex,
    this.itemlabelvisible,
    this.langwordcode,
    this.maxqs,
    this.note,
    this.orderno,
    this.parentid,
    this.path,
    this.pathid,
    this.qstype,
    this.refqsid,
    this.resulttableheight,
    this.resulttablevisible,
    this.resulttablewidth,
    this.rootid,
    this.score,
    this.surveydesc,
    this.surveyid,
    this.targetsucc,
    this.treelevel,
    this.treeorderno,
    this.typ,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Surveytree.fromJson(Map<String, dynamic> json) => new Surveytree(
        align: json[DBConst.FDN_ALIGN],
        answeralign: json[DBConst.FDN_ANSWERALIGN],
        chartheight: json[DBConst.FDN_CHARTHEIGHT],
        chartstyle: json[DBConst.FDN_CHARTSTYLE],
        chartvisible: json[DBConst.FDN_CHARTVISIBLE],
        chartwidth: json[DBConst.FDN_CHARTWIDTH],
        customvalue: json[DBConst.FDN_CUSTOMVALUE],
        description: json[DBConst.FDN_DESCRIPTION],
        fieldname: json[DBConst.FDN_FIELDNAME],
        fileid: json[DBConst.FDN_FILEID],
        gidstr: json[DBConst.FDN_GIDSTR],
        hasnote: json[DBConst.FDN_HASNOTE],
        haspb: json[DBConst.FDN_HASPB],
        hotelname: json[DBConst.FDN_HOTELNAME],
        inputwidth: json[DBConst.FDN_INPUTWIDTH],
        isactive: json[DBConst.FDN_ISACTIVE],
        isdef: json[DBConst.FDN_ISDEF],
        isreq: json[DBConst.FDN_ISREQ],
        isweb: json[DBConst.FDN_ISWEB],
        itemindex: json[DBConst.FDN_ITEMINDEX],
        itemlabelvisible: json[DBConst.FDN_ITEMLABELVISIBLE],
        langwordcode: json[DBConst.FDN_LANGWORDCODE],
        maxqs: json[DBConst.FDN_MAXQS],
        note: json[DBConst.FDN_NOTE],
        orderno: json[DBConst.FDN_ORDERNO],
        parentid: json[DBConst.FDN_PARENTID],
        path: json[DBConst.FDN_PATH],
        pathid: json[DBConst.FDN_PATHID],
        qstype: json[DBConst.FDN_QSTYPE],
        refqsid: json[DBConst.FDN_REFQSID],
        resulttableheight: json[DBConst.FDN_RESULTTABLEHEIGHT],
        resulttablevisible: json[DBConst.FDN_RESULTTABLEVISIBLE],
        resulttablewidth: json[DBConst.FDN_RESULTTABLEWIDTH],
        rootid: json[DBConst.FDN_ROOTID],
        score: json[DBConst.FDN_SCORE],
        surveydesc: json[DBConst.FDN_SURVEYDESC],
        surveyid: json[DBConst.FDN_SURVEYID],
        targetsucc: json[DBConst.FDN_TARGETSUCC],
        treelevel: json[DBConst.FDN_TREELEVEL],
        treeorderno: json[DBConst.FDN_TREEORDERNO],
        typ: json[DBConst.FDN_TYP],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ALIGN: align,
      DBConst.FDN_ANSWERALIGN: answeralign,
      DBConst.FDN_CHARTHEIGHT: chartheight,
      DBConst.FDN_CHARTSTYLE: chartstyle,
      DBConst.FDN_CHARTVISIBLE: chartvisible,
      DBConst.FDN_CHARTWIDTH: chartwidth,
      DBConst.FDN_CUSTOMVALUE: customvalue,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_FIELDNAME: fieldname,
      DBConst.FDN_FILEID: fileid,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HASNOTE: hasnote,
      DBConst.FDN_HASPB: haspb,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_INPUTWIDTH: inputwidth,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_ISDEF: isdef,
      DBConst.FDN_ISREQ: isreq,
      DBConst.FDN_ISWEB: isweb,
      DBConst.FDN_ITEMINDEX: itemindex,
      DBConst.FDN_ITEMLABELVISIBLE: itemlabelvisible,
      DBConst.FDN_LANGWORDCODE: langwordcode,
      DBConst.FDN_MAXQS: maxqs,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_ORDERNO: orderno,
      DBConst.FDN_PARENTID: parentid,
      DBConst.FDN_PATH: path,
      DBConst.FDN_PATHID: pathid,
      DBConst.FDN_QSTYPE: qstype,
      DBConst.FDN_REFQSID: refqsid,
      DBConst.FDN_RESULTTABLEHEIGHT: resulttableheight,
      DBConst.FDN_RESULTTABLEVISIBLE: resulttablevisible,
      DBConst.FDN_RESULTTABLEWIDTH: resulttablewidth,
      DBConst.FDN_ROOTID: rootid,
      DBConst.FDN_SCORE: score,
      DBConst.FDN_SURVEYDESC: surveydesc,
      DBConst.FDN_SURVEYID: surveyid,
      DBConst.FDN_TARGETSUCC: targetsucc,
      DBConst.FDN_TREELEVEL: treelevel,
      DBConst.FDN_TREEORDERNO: treeorderno,
      DBConst.FDN_TYP: typ,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Surveytree &&
          runtimeType == other.runtimeType &&
          align == other.align &&
          answeralign == other.answeralign &&
          chartheight == other.chartheight &&
          chartstyle == other.chartstyle &&
          chartvisible == other.chartvisible &&
          chartwidth == other.chartwidth &&
          customvalue == other.customvalue &&
          description == other.description &&
          fieldname == other.fieldname &&
          fileid == other.fileid &&
          gidstr == other.gidstr &&
          hasnote == other.hasnote &&
          haspb == other.haspb &&
          hotelname == other.hotelname &&
          inputwidth == other.inputwidth &&
          isactive == other.isactive &&
          isdef == other.isdef &&
          isreq == other.isreq &&
          isweb == other.isweb &&
          itemindex == other.itemindex &&
          itemlabelvisible == other.itemlabelvisible &&
          langwordcode == other.langwordcode &&
          maxqs == other.maxqs &&
          note == other.note &&
          orderno == other.orderno &&
          parentid == other.parentid &&
          path == other.path &&
          pathid == other.pathid &&
          qstype == other.qstype &&
          refqsid == other.refqsid &&
          resulttableheight == other.resulttableheight &&
          resulttablevisible == other.resulttablevisible &&
          resulttablewidth == other.resulttablewidth &&
          rootid == other.rootid &&
          score == other.score &&
          surveydesc == other.surveydesc &&
          surveyid == other.surveyid &&
          targetsucc == other.targetsucc &&
          treelevel == other.treelevel &&
          treeorderno == other.treeorderno &&
          typ == other.typ &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      align.hashCode ^
      answeralign.hashCode ^
      chartheight.hashCode ^
      chartstyle.hashCode ^
      chartvisible.hashCode ^
      chartwidth.hashCode ^
      customvalue.hashCode ^
      description.hashCode ^
      fieldname.hashCode ^
      fileid.hashCode ^
      gidstr.hashCode ^
      hasnote.hashCode ^
      haspb.hashCode ^
      hotelname.hashCode ^
      inputwidth.hashCode ^
      isactive.hashCode ^
      isdef.hashCode ^
      isreq.hashCode ^
      isweb.hashCode ^
      itemindex.hashCode ^
      itemlabelvisible.hashCode ^
      langwordcode.hashCode ^
      maxqs.hashCode ^
      note.hashCode ^
      orderno.hashCode ^
      parentid.hashCode ^
      path.hashCode ^
      pathid.hashCode ^
      qstype.hashCode ^
      refqsid.hashCode ^
      resulttableheight.hashCode ^
      resulttablevisible.hashCode ^
      resulttablewidth.hashCode ^
      rootid.hashCode ^
      score.hashCode ^
      surveydesc.hashCode ^
      surveyid.hashCode ^
      targetsucc.hashCode ^
      treelevel.hashCode ^
      treeorderno.hashCode ^
      typ.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'SurveyTree{align: $align, answeralign: $answeralign, chartheight: $chartheight, chartstyle: $chartstyle, chartvisible: $chartvisible, chartwidth: $chartwidth, customvalue: $customvalue, description: $description, fieldname: $fieldname, fileid: $fileid, gidstr: $gidstr, hasnote: $hasnote, haspb: $haspb, hotelname: $hotelname, inputwidth: $inputwidth, isactive: $isactive, isdef: $isdef, isreq: $isreq, isweb: $isweb, itemindex: $itemindex, itemlabelvisible: $itemlabelvisible, langwordcode: $langwordcode, maxqs: $maxqs, note: $note, orderno: $orderno, parentid: $parentid, path: $path, pathid: $pathid, qstype: $qstype, refqsid: $refqsid, resulttableheight: $resulttableheight, resulttablevisible: $resulttablevisible, resulttablewidth: $resulttablewidth, rootid: $rootid, score: $score, surveydesc: $surveydesc, surveyid: $surveyid, targetsucc: $targetsucc, treelevel: $treelevel, treeorderno: $treeorderno, typ: $typ, jsonMap: $jsonMap}';
  }
}
