import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

//TODO add new service variables (mainly language related ones)
class Resevent extends BaseModelSync {
  int reservno;
  String startdate;
  String starttime;
  String enddate;
  String endtime;
  String description;
  int totalpax;
  double totalprice;
  String note;
  String pricecurr;
  double excrate;
  String advpaydate;
  int paytype;
  bool needinvoice;
  String advpaycurr;
  String advpaynote;
  String transdate;
  String transtime;
  int agencyid;
  String contact;
  int resmasterno;
  int eventtypeid;
  double advpayamount;
  int advpaytype;
  int empid;
  int eventserviceid;
  int foliono;
  int locationid;
  int eventtimeid;
  int totalchd;
  int totalbaby;
  int exppax;
  int expchd;
  int expbaby;
  String tel;
  int locplanid;
  String bridename;
  String groomname;
  bool haswedding;
  bool eventlocstd;
  String weddingtime;
  int eventmusicid;
  int animintroid;
  int animfirstdanceid;
  int eventdecorid;
  int clientid;
  int brideclientid;
  int groomclientid;
  String animintronote;
  String animfirstdancenote;
  String animnote;
  String musicnote;
  String decornote;
  double subtotal;
  double freeamount;
  double discrate;
  bool ispricelocked;
  int animcakeid;
  String animcakenote;
  double serviceprice;
  double locprice;
  double empprice;
  double menuprice;
  double saleprprice;
  double consumpitemprice;
  double rentitemprice;
  int eventrestype;
  int saleempid;
  int infoempid;
  String status;
  String excratetype;
  String tableno;
  String lastchange;
  String firstuser;
  int contactclientid;
  String remarknote;
  String resdate;
  int sourceid;
  int ressegmentid;
  bool useextprice;
  String citime;
  int lockuserid;
  int resdefinitid;
  int marketid;
  int agencysubid;
  int rescountryid;
  String invtransdate;
  String invtranstime;
  String invoiceno;
  int invuserid;
  bool isemplocked;
  String cotime;
  int emplockuserid;
  String menucode;
  double pkgfreeamount;
  bool warnnote;
  int memshipid;
  String optiondate;
  int advpaycurrid;
  int excratetypeid;
  int menucodeid;
  int pricecurrid;
  bool isprivate;

  //View Fields

  String statusdesc;
  String startdt;
  String enddt;
  double discamount;
  double netprice;
  double netpricehomecurr;
  double balance;
  double balancehomecurr;
  String eventtype;
  String eventloc;
  int eventlocid;
  String location;
  String locplancode;
  String empcode;
  String empname;
  String duration;
  String eventservice;
  String eventservicedesc;
  int eventmenuid;
  String eventmenu;
  String eventmenudesc;
  String setuptime;
  String setdowntime;
  String roomno;
  String agency;
  bool isbanquet;
  bool isdefbanquet;
  bool isdef;
  bool isspares;
  bool isdefspa;
  bool islocres;
  bool isdeflocres;
  String saleempcode;
  String saleempname;
  String infoempcode;
  String infoempname;
  int producttypeid;
  String producttype;
  String agencysub;
  String resmarket;
  String ressource;
  String ressegment;
  String resdefinit;
  String rescountry;
  int totalminstd;
  int totalmin;
  bool iscustomenu;
  double foliodebit;
  double foliocredit;
  String hotelname;
  String advpaycurrcode;
  String agencycode;
  String agencysubcode;
  String clientcode;
  String clientname;
  String eventdecorcode;
  String eventmusiccode;
  String excratetypecode;
  String pricecurrcode;
  String resdefinitcode;
  String ressegmentcode;
  int transno;
  int langid;
  String pricecurrdesc;
  String excratetypedesc;
  String langcode;
  String langdesc;
  String ressegmentdesc;
  int blockid;
  String blockcode;
  String blockdesc;
  String prvtypecode;
  String prvtypedesc;
  String agencydesc;
  String loccode;
  String locdesc;
  String advpaycurrdesc;
  String locplandesc;
  String agencysubdesc;
  String resdefinitdesc;
  String eventdecordesc;
  String eventmusicdesc;
  String menucodedesc;
  int locid;
  int prvtypeid;

  Map<String, dynamic> jsonMap;

  Resevent({
    this.reservno,
    this.startdate,
    this.starttime,
    this.enddate,
    this.endtime,
    this.description,
    this.totalpax,
    this.totalprice,
    this.note,
    this.pricecurr,
    this.excrate,
    this.advpaydate,
    this.paytype,
    this.needinvoice,
    this.advpaycurr,
    this.advpaynote,
    this.transdate,
    this.transtime,
    this.agencyid,
    this.contact,
    this.resmasterno,
    this.eventtypeid,
    this.advpayamount,
    this.advpaytype,
    this.empid,
    this.eventserviceid,
    this.foliono,
    this.locationid,
    this.eventtimeid,
    this.totalchd,
    this.totalbaby,
    this.exppax,
    this.expchd,
    this.expbaby,
    this.tel,
    this.locplanid,
    this.bridename,
    this.groomname,
    this.haswedding,
    this.eventlocstd,
    this.weddingtime,
    this.eventmusicid,
    this.animintroid,
    this.animfirstdanceid,
    this.eventdecorid,
    this.clientid,
    this.brideclientid,
    this.groomclientid,
    this.animintronote,
    this.animfirstdancenote,
    this.animnote,
    this.musicnote,
    this.decornote,
    this.subtotal,
    this.freeamount,
    this.discrate,
    this.ispricelocked,
    this.animcakeid,
    this.animcakenote,
    this.serviceprice,
    this.locprice,
    this.empprice,
    this.menuprice,
    this.saleprprice,
    this.consumpitemprice,
    this.rentitemprice,
    this.eventrestype,
    this.saleempid,
    this.infoempid,
    this.status,
    this.excratetype,
    this.tableno,
    this.lastchange,
    this.firstuser,
    this.contactclientid,
    this.remarknote,
    this.resdate,
    this.sourceid,
    this.ressegmentid,
    this.useextprice,
    this.citime,
    this.lockuserid,
    this.resdefinitid,
    this.marketid,
    this.agencysubid,
    this.rescountryid,
    this.invtransdate,
    this.invtranstime,
    this.invoiceno,
    this.invuserid,
    this.isemplocked,
    this.cotime,
    this.emplockuserid,
    this.menucode,
    this.pkgfreeamount,
    this.warnnote,
    this.memshipid,
    this.optiondate,
    this.advpaycurrid,
    this.excratetypeid,
    this.menucodeid,
    this.pricecurrid,
    this.isprivate,
    this.statusdesc,
    this.startdt,
    this.enddt,
    this.discamount,
    this.netprice,
    this.netpricehomecurr,
    this.balance,
    this.balancehomecurr,
    this.eventtype,
    this.eventloc,
    this.eventlocid,
    this.location,
    this.locplancode,
    this.empcode,
    this.empname,
    this.duration,
    this.eventservice,
    this.eventservicedesc,
    this.eventmenuid,
    this.eventmenu,
    this.eventmenudesc,
    this.setuptime,
    this.setdowntime,
    this.roomno,
    this.agency,
    this.isbanquet,
    this.isdefbanquet,
    this.isdef,
    this.isspares,
    this.isdefspa,
    this.islocres,
    this.isdeflocres,
    this.saleempcode,
    this.saleempname,
    this.infoempcode,
    this.infoempname,
    this.producttypeid,
    this.producttype,
    this.agencysub,
    this.resmarket,
    this.ressource,
    this.ressegment,
    this.resdefinit,
    this.rescountry,
    this.totalminstd,
    this.totalmin,
    this.iscustomenu,
    this.foliodebit,
    this.foliocredit,
    this.hotelname,
    this.advpaycurrcode,
    this.agencycode,
    this.agencysubcode,
    this.clientcode,
    this.clientname,
    this.eventdecorcode,
    this.eventmusiccode,
    this.excratetypecode,
    this.pricecurrcode,
    this.resdefinitcode,
    this.ressegmentcode,
    this.transno,
    this.langid,
    this.pricecurrdesc,
    this.excratetypedesc,
    this.langcode,
    this.langdesc,
    this.ressegmentdesc,
    this.blockid,
    this.blockcode,
    this.blockdesc,
    this.prvtypecode,
    this.prvtypedesc,
    this.agencydesc,
    this.loccode,
    this.locdesc,
    this.advpaycurrdesc,
    this.locplandesc,
    this.agencysubdesc,
    this.resdefinitdesc,
    this.jsonMap,
    this.eventdecordesc,
    this.eventmusicdesc,
    this.menucodedesc,
    this.locid,
    this.prvtypeid,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Resevent.fromJson(Map<String, dynamic> json) {
    return Resevent(
      reservno: json[DBConst.FDN_RESERVNO],
      startdate: json[DBConst.FDN_STARTDATE],
      starttime: json[DBConst.FDN_STARTTIME],
      enddate: json[DBConst.FDN_ENDDATE],
      endtime: json[DBConst.FDN_ENDTIME],
      description: json[DBConst.FDN_DESCRIPTION],
      totalpax: json[DBConst.FDN_TOTALPAX],
      totalprice: json[DBConst.FDN_TOTALPRICE],
      note: json[DBConst.FDN_NOTE],
      pricecurr: json[DBConst.FDN_PRICECURR],
      excrate: json[DBConst.FDN_EXCRATE],
      advpaydate: json[DBConst.FDN_ADVPAYDATE],
      paytype: json[DBConst.FDN_PAYTYPE],
      needinvoice: json[DBConst.FDN_NEEDINVOICE],
      advpaycurr: json[DBConst.FDN_ADVPAYCURR],
      advpaynote: json[DBConst.FDN_ADVPAYNOTE],
      transdate: json[DBConst.FDN_TRANSDATE],
      transtime: json[DBConst.FDN_TRANSTIME],
      agencyid: json[DBConst.FDN_AGENCYID],
      contact: json[DBConst.FDN_CONTACT],
      resmasterno: json[DBConst.FDN_RESMASTERNO],
      eventtypeid: json[DBConst.FDN_EVENTTYPEID],
      advpayamount: json[DBConst.FDN_ADVPAYAMOUNT],
      advpaytype: json[DBConst.FDN_ADVPAYTYPE],
      empid: json[DBConst.FDN_EMPID],
      eventserviceid: json[DBConst.FDN_EVENTSERVICEID],
      foliono: json[DBConst.FDN_FOLIONO],
      locationid: json[DBConst.FDN_LOCATIONID],
      eventtimeid: json[DBConst.FDN_EVENTTIMEID],
      totalchd: json[DBConst.FDN_TOTALCHD],
      totalbaby: json[DBConst.FDN_TOTALBABY],
      exppax: json[DBConst.FDN_EXPPAX],
      expchd: json[DBConst.FDN_EXPCHD],
      expbaby: json[DBConst.FDN_EXPBABY],
      tel: json[DBConst.FDN_TEL],
      locplanid: json[DBConst.FDN_LOCPLANID],
      bridename: json[DBConst.FDN_BRIDENAME],
      groomname: json[DBConst.FDN_GROOMNAME],
      haswedding: json[DBConst.FDN_HASWEDDING],
      eventlocstd: json[DBConst.FDN_EVENTLOCSTD],
      weddingtime: json[DBConst.FDN_WEDDINGTIME],
      eventmusicid: json[DBConst.FDN_EVENTMUSICID],
      animintroid: json[DBConst.FDN_ANIMINTROID],
      animfirstdanceid: json[DBConst.FDN_ANIMFIRSTDANCEID],
      eventdecorid: json[DBConst.FDN_EVENTDECORID],
      clientid: json[DBConst.FDN_CLIENTID],
      brideclientid: json[DBConst.FDN_BRIDECLIENTID],
      groomclientid: json[DBConst.FDN_GROOMCLIENTID],
      animintronote: json[DBConst.FDN_ANIMINTRONOTE],
      animfirstdancenote: json[DBConst.FDN_ANIMFIRSTDANCENOTE],
      animnote: json[DBConst.FDN_ANIMNOTE],
      musicnote: json[DBConst.FDN_MUSICNOTE],
      decornote: json[DBConst.FDN_DECORNOTE],
      subtotal: json[DBConst.FDN_SUBTOTAL],
      freeamount: json[DBConst.FDN_FREEAMOUNT],
      discrate: json[DBConst.FDN_DISCRATE],
      ispricelocked: json[DBConst.FDN_ISPRICELOCKED],
      animcakeid: json[DBConst.FDN_ANIMCAKEID],
      animcakenote: json[DBConst.FDN_ANIMCAKENOTE],
      serviceprice: json[DBConst.FDN_SERVICEPRICE],
      locprice: json[DBConst.FDN_LOCPRICE],
      empprice: json[DBConst.FDN_EMPPRICE],
      menuprice: json[DBConst.FDN_MENUPRICE],
      saleprprice: json[DBConst.FDN_SALEPRPRICE],
      consumpitemprice: json[DBConst.FDN_CONSUMPITEMPRICE],
      rentitemprice: json[DBConst.FDN_RENTITEMPRICE],
      eventrestype: json[DBConst.FDN_EVENTRESTYPE],
      saleempid: json[DBConst.FDN_SALEEMPID],
      infoempid: json[DBConst.FDN_INFOEMPID],
      status: json[DBConst.FDN_STATUS],
      excratetype: json[DBConst.FDN_EXCRATETYPE],
      tableno: json[DBConst.FDN_TABLENO],
      lastchange: json[DBConst.FDN_LASTCHANGE],
      firstuser: json[DBConst.FDN_FIRSTUSER],
      contactclientid: json[DBConst.FDN_CONTACTCLIENTID],
      remarknote: json[DBConst.FDN_REMARKNOTE],
      resdate: json[DBConst.FDN_RESDATE],
      sourceid: json[DBConst.FDN_SOURCEID],
      ressegmentid: json[DBConst.FDN_RESSEGMENTID],
      useextprice: json[DBConst.FDN_USEEXTPRICE],
      citime: json[DBConst.FDN_CITIME],
      lockuserid: json[DBConst.FDN_LOCKUSERID],
      resdefinitid: json[DBConst.FDN_RESDEFINITID],
      marketid: json[DBConst.FDN_MARKETID],
      agencysubid: json[DBConst.FDN_AGENCYSUBID],
      rescountryid: json[DBConst.FDN_RESCOUNTRYID],
      invtransdate: json[DBConst.FDN_INVTRANSDATE],
      invtranstime: json[DBConst.FDN_INVTRANSTIME],
      invoiceno: json[DBConst.FDN_INVOICENO],
      invuserid: json[DBConst.FDN_INVUSERID],
      isemplocked: json[DBConst.FDN_ISEMPLOCKED],
      cotime: json[DBConst.FDN_COTIME],
      emplockuserid: json[DBConst.FDN_EMPLOCKUSERID],
      menucode: json[DBConst.FDN_MENUCODE],
      pkgfreeamount: json[DBConst.FDN_PKGFREEAMOUNT],
      warnnote: json[DBConst.FDN_WARNNOTE],
      memshipid: json[DBConst.FDN_MEMSHIPID],
      optiondate: json[DBConst.FDN_OPTIONDATE],
      advpaycurrid: json[DBConst.FDN_ADVPAYCURRID],
      excratetypeid: json[DBConst.FDN_EXCRATETYPEID],
      menucodeid: json[DBConst.FDN_MENUCODEID],
      pricecurrid: json[DBConst.FDN_PRICECURRID],
      isprivate: json[DBConst.FDN_ISPRIVATE],
      statusdesc: json[DBConst.FDN_STATUSDESC],
      startdt: json[DBConst.FDN_STARTDT],
      enddt: json[DBConst.FDN_ENDDT],
      discamount: json[DBConst.FDN_DISCAMOUNT],
      netprice: json[DBConst.FDN_NETPRICE],
      netpricehomecurr: json[DBConst.FDN_NETPRICEHOMECURR],
      balance: json[DBConst.FDN_BALANCE],
      balancehomecurr: json[DBConst.FDN_BALANCEHOMECURR],
      eventtype: json[DBConst.FDN_EVENTTYPE],
      eventloc: json[DBConst.FDN_EVENTLOC],
      eventlocid: json[DBConst.FDN_EVENTLOCID],
      location: json[DBConst.FDN_LOCATION],
      locplancode: json[DBConst.FDN_LOCPLANCODE],
      empcode: json[DBConst.FDN_EMPCODE],
      empname: json[DBConst.FDN_EMPNAME],
      duration: json[DBConst.FDN_DURATION],
      eventservice: json[DBConst.FDN_EVENTSERVICE],
      eventservicedesc: json[DBConst.FDN_EVENTSERVICEDESC],
      eventmenuid: json[DBConst.FDN_EVENTMENUID],
      eventmenu: json[DBConst.FDN_EVENTMENU],
      eventmenudesc: json[DBConst.FDN_EVENTMENUDESC],
      setuptime: json[DBConst.FDN_SETUPTIME],
      setdowntime: json[DBConst.FDN_SETDOWNTIME],
      roomno: json[DBConst.FDN_ROOMNO],
      agency: json[DBConst.FDN_AGENCY],
      isbanquet: json[DBConst.FDN_ISBANQUET],
      isdefbanquet: json[DBConst.FDN_ISDEFBANQUET],
      isdef: json[DBConst.FDN_ISDEF],
      isspares: json[DBConst.FDN_ISSPARES],
      isdefspa: json[DBConst.FDN_ISDEFSPA],
      islocres: json[DBConst.FDN_ISLOCRES],
      isdeflocres: json[DBConst.FDN_ISDEFLOCRES],
      saleempcode: json[DBConst.FDN_SALEEMPCODE],
      saleempname: json[DBConst.FDN_SALEEMPNAME],
      infoempcode: json[DBConst.FDN_INFOEMPCODE],
      infoempname: json[DBConst.FDN_INFOEMPNAME],
      producttypeid: json[DBConst.FDN_PRODUCTTYPEID],
      producttype: json[DBConst.FDN_PRODUCTTYPE],
      agencysub: json[DBConst.FDN_AGENCYSUB],
      resmarket: json[DBConst.FDN_RESMARKET],
      ressource: json[DBConst.FDN_RESSOURCE],
      ressegment: json[DBConst.FDN_RESSEGMENT],
      resdefinit: json[DBConst.FDN_RESDEFINIT],
      rescountry: json[DBConst.FDN_RESCOUNTRY],
      totalminstd: json[DBConst.FDN_TOTALMINSTD],
      totalmin: json[DBConst.FDN_TOTALMIN],
      iscustomenu: json[DBConst.FDN_ISCUSTOMENU],
      foliodebit: json[DBConst.FDN_FOLIODEBIT],
      foliocredit: json[DBConst.FDN_FOLIOCREDIT],
      hotelname: json[DBConst.FDN_HOTELNAME],
      advpaycurrcode: json[DBConst.FDN_ADVPAYCURRCODE],
      agencycode: json[DBConst.FDN_AGENCYCODE],
      agencysubcode: json[DBConst.FDN_AGENCYSUBCODE],
      clientcode: json[DBConst.FDN_CLIENTCODE],
      clientname: json[DBConst.FDN_CLIENTNAME],
      eventdecorcode: json[DBConst.FDN_EVENTDECORCODE],
      eventmusiccode: json[DBConst.FDN_EVENTMUSICCODE],
      excratetypecode: json[DBConst.FDN_EXCRATETYPECODE],
      pricecurrcode: json[DBConst.FDN_PRICECURRCODE],
      resdefinitcode: json[DBConst.FDN_RESDEFINITCODE],
      ressegmentcode: json[DBConst.FDN_RESSEGMENTCODE],
      transno: json[DBConst.FDN_TRANSNO],
      langid: json[DBConst.FDN_LANGID],
      pricecurrdesc: json[DBConst.FDN_PRICECURRDESC],
      excratetypedesc: json[DBConst.FDN_EXCRATETYPEDESC],
      langcode: json[DBConst.FDN_LANGCODE],
      langdesc: json[DBConst.FDN_LANGDESC],
      ressegmentdesc: json[DBConst.FDN_RESSEGMENTDESC],
      blockid: json[DBConst.FDN_BLOCKID],
      blockcode: json[DBConst.FDN_BLOCKCODE],
      blockdesc: json[DBConst.FDN_BLOCKDESC],
      prvtypecode: json[DBConst.FDN_PRVTYPECODE],
      prvtypedesc: json[DBConst.FDN_PRVTYPEDESC],
      agencydesc: json[DBConst.FDN_AGENCYDESC],
      loccode: json[DBConst.FDN_LOCCODE],
      locdesc: json[DBConst.FDN_LOCDESC],
      advpaycurrdesc: json[DBConst.FDN_ADVPAYCURRDESC],
      locplandesc: json[DBConst.FDN_LOCPLANDESC],
      agencysubdesc: json[DBConst.FDN_AGENCYSUBDESC],
      resdefinitdesc: json[DBConst.FDN_RESDEFINITDESC],
      eventdecordesc: json[DBConst.FDN_EVENTDECORDESC],
      eventmusicdesc: json[DBConst.FDN_EVENTMUSICDESC],
      menucodedesc: json[DBConst.FDN_MENUCODEDESC],
      locid: json[DBConst.FDN_LOCID],
      prvtypeid: json[DBConst.FDN_PRVTYPEID],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_RESERVNO: reservno,
      DBConst.FDN_STARTDATE: startdate,
      DBConst.FDN_STARTTIME: starttime,
      DBConst.FDN_ENDDATE: enddate,
      DBConst.FDN_ENDTIME: endtime,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_TOTALPAX: totalpax,
      DBConst.FDN_TOTALPRICE: totalprice,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_PRICECURR: pricecurr,
      DBConst.FDN_EXCRATE: excrate,
      DBConst.FDN_ADVPAYDATE: advpaydate,
      DBConst.FDN_PAYTYPE: paytype,
      DBConst.FDN_NEEDINVOICE: needinvoice,
      DBConst.FDN_ADVPAYCURR: advpaycurr,
      DBConst.FDN_ADVPAYNOTE: advpaynote,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_TRANSTIME: transtime,
      DBConst.FDN_AGENCYID: agencyid,
      DBConst.FDN_CONTACT: contact,
      DBConst.FDN_RESMASTERNO: resmasterno,
      DBConst.FDN_EVENTTYPEID: eventtypeid,
      DBConst.FDN_ADVPAYAMOUNT: advpayamount,
      DBConst.FDN_ADVPAYTYPE: advpaytype,
      DBConst.FDN_EMPID: empid,
      DBConst.FDN_EVENTSERVICEID: eventserviceid,
      DBConst.FDN_FOLIONO: foliono,
      DBConst.FDN_LOCATIONID: locationid,
      DBConst.FDN_EVENTTIMEID: eventtimeid,
      DBConst.FDN_TOTALCHD: totalchd,
      DBConst.FDN_TOTALBABY: totalbaby,
      DBConst.FDN_EXPPAX: exppax,
      DBConst.FDN_EXPCHD: expchd,
      DBConst.FDN_EXPBABY: expbaby,
      DBConst.FDN_TEL: tel,
      DBConst.FDN_LOCPLANID: locplanid,
      DBConst.FDN_BRIDENAME: bridename,
      DBConst.FDN_GROOMNAME: groomname,
      DBConst.FDN_HASWEDDING: haswedding,
      DBConst.FDN_EVENTLOCSTD: eventlocstd,
      DBConst.FDN_WEDDINGTIME: weddingtime,
      DBConst.FDN_EVENTMUSICID: eventmusicid,
      DBConst.FDN_ANIMINTROID: animintroid,
      DBConst.FDN_ANIMFIRSTDANCEID: animfirstdanceid,
      DBConst.FDN_EVENTDECORID: eventdecorid,
      DBConst.FDN_CLIENTID: clientid,
      DBConst.FDN_BRIDECLIENTID: brideclientid,
      DBConst.FDN_GROOMCLIENTID: groomclientid,
      DBConst.FDN_ANIMINTRONOTE: animintronote,
      DBConst.FDN_ANIMFIRSTDANCENOTE: animfirstdancenote,
      DBConst.FDN_ANIMNOTE: animnote,
      DBConst.FDN_MUSICNOTE: musicnote,
      DBConst.FDN_DECORNOTE: decornote,
      DBConst.FDN_SUBTOTAL: subtotal,
      DBConst.FDN_FREEAMOUNT: freeamount,
      DBConst.FDN_DISCRATE: discrate,
      DBConst.FDN_ISPRICELOCKED: ispricelocked,
      DBConst.FDN_ANIMCAKEID: animcakeid,
      DBConst.FDN_ANIMCAKENOTE: animcakenote,
      DBConst.FDN_SERVICEPRICE: serviceprice,
      DBConst.FDN_LOCPRICE: locprice,
      DBConst.FDN_EMPPRICE: empprice,
      DBConst.FDN_MENUPRICE: menuprice,
      DBConst.FDN_SALEPRPRICE: saleprprice,
      DBConst.FDN_CONSUMPITEMPRICE: consumpitemprice,
      DBConst.FDN_RENTITEMPRICE: rentitemprice,
      DBConst.FDN_EVENTRESTYPE: eventrestype,
      DBConst.FDN_SALEEMPID: saleempid,
      DBConst.FDN_INFOEMPID: infoempid,
      DBConst.FDN_STATUS: status,
      DBConst.FDN_EXCRATETYPE: excratetype,
      DBConst.FDN_TABLENO: tableno,
      DBConst.FDN_LASTCHANGE: lastchange,
      DBConst.FDN_FIRSTUSER: firstuser,
      DBConst.FDN_CONTACTCLIENTID: contactclientid,
      DBConst.FDN_REMARKNOTE: remarknote,
      DBConst.FDN_RESDATE: resdate,
      DBConst.FDN_SOURCEID: sourceid,
      DBConst.FDN_RESSEGMENTID: ressegmentid,
      DBConst.FDN_USEEXTPRICE: useextprice,
      DBConst.FDN_CITIME: citime,
      DBConst.FDN_LOCKUSERID: lockuserid,
      DBConst.FDN_RESDEFINITID: resdefinitid,
      DBConst.FDN_MARKETID: marketid,
      DBConst.FDN_AGENCYSUBID: agencysubid,
      DBConst.FDN_RESCOUNTRYID: rescountryid,
      DBConst.FDN_INVTRANSDATE: invtransdate,
      DBConst.FDN_INVTRANSTIME: invtranstime,
      DBConst.FDN_INVOICENO: invoiceno,
      DBConst.FDN_INVUSERID: invuserid,
      DBConst.FDN_ISEMPLOCKED: isemplocked,
      DBConst.FDN_COTIME: cotime,
      DBConst.FDN_EMPLOCKUSERID: emplockuserid,
      DBConst.FDN_MENUCODE: menucode,
      DBConst.FDN_PKGFREEAMOUNT: pkgfreeamount,
      DBConst.FDN_WARNNOTE: warnnote,
      DBConst.FDN_MEMSHIPID: memshipid,
      DBConst.FDN_OPTIONDATE: optiondate,
      DBConst.FDN_ADVPAYCURRID: advpaycurrid,
      DBConst.FDN_EXCRATETYPEID: excratetypeid,
      DBConst.FDN_MENUCODEID: menucodeid,
      DBConst.FDN_PRICECURRID: pricecurrid,
      DBConst.FDN_ISPRIVATE: isprivate,
      DBConst.FDN_STATUSDESC: statusdesc,
      DBConst.FDN_STARTDT: startdt,
      DBConst.FDN_ENDDT: enddt,
      DBConst.FDN_DISCAMOUNT: discamount,
      DBConst.FDN_NETPRICE: netprice,
      DBConst.FDN_NETPRICEHOMECURR: netpricehomecurr,
      DBConst.FDN_BALANCE: balance,
      DBConst.FDN_BALANCEHOMECURR: balancehomecurr,
      DBConst.FDN_EVENTTYPE: eventtype,
      DBConst.FDN_EVENTLOC: eventloc,
      DBConst.FDN_EVENTLOCID: eventlocid,
      DBConst.FDN_LOCATION: location,
      DBConst.FDN_LOCPLANCODE: locplancode,
      DBConst.FDN_EMPCODE: empcode,
      DBConst.FDN_EMPNAME: empname,
      DBConst.FDN_DURATION: duration,
      DBConst.FDN_EVENTSERVICE: eventservice,
      DBConst.FDN_EVENTSERVICEDESC: eventservicedesc,
      DBConst.FDN_EVENTMENUID: eventmenuid,
      DBConst.FDN_EVENTMENU: eventmenu,
      DBConst.FDN_EVENTMENUDESC: eventmenudesc,
      DBConst.FDN_SETUPTIME: setuptime,
      DBConst.FDN_SETDOWNTIME: setdowntime,
      DBConst.FDN_ROOMNO: roomno,
      DBConst.FDN_AGENCY: agency,
      DBConst.FDN_ISBANQUET: isbanquet,
      DBConst.FDN_ISDEFBANQUET: isdefbanquet,
      DBConst.FDN_ISDEF: isdef,
      DBConst.FDN_ISSPARES: isspares,
      DBConst.FDN_ISDEFSPA: isdefspa,
      DBConst.FDN_ISLOCRES: islocres,
      DBConst.FDN_ISDEFLOCRES: isdeflocres,
      DBConst.FDN_SALEEMPCODE: saleempcode,
      DBConst.FDN_SALEEMPNAME: saleempname,
      DBConst.FDN_INFOEMPCODE: infoempcode,
      DBConst.FDN_INFOEMPNAME: infoempname,
      DBConst.FDN_PRODUCTTYPEID: producttypeid,
      DBConst.FDN_PRODUCTTYPE: producttype,
      DBConst.FDN_AGENCYSUB: agencysub,
      DBConst.FDN_RESMARKET: resmarket,
      DBConst.FDN_RESSOURCE: ressource,
      DBConst.FDN_RESSEGMENT: ressegment,
      DBConst.FDN_RESDEFINIT: resdefinit,
      DBConst.FDN_RESCOUNTRY: rescountry,
      DBConst.FDN_TOTALMINSTD: totalminstd,
      DBConst.FDN_TOTALMIN: totalmin,
      DBConst.FDN_ISCUSTOMENU: iscustomenu,
      DBConst.FDN_FOLIODEBIT: foliodebit,
      DBConst.FDN_FOLIOCREDIT: foliocredit,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ADVPAYCURRCODE: advpaycurrcode,
      DBConst.FDN_AGENCYCODE: agencycode,
      DBConst.FDN_AGENCYSUBCODE: agencysubcode,
      DBConst.FDN_CLIENTCODE: clientcode,
      DBConst.FDN_CLIENTNAME: clientname,
      DBConst.FDN_EVENTDECORCODE: eventdecorcode,
      DBConst.FDN_EVENTMUSICCODE: eventmusiccode,
      DBConst.FDN_EXCRATETYPECODE: excratetypecode,
      DBConst.FDN_PRICECURRCODE: pricecurrcode,
      DBConst.FDN_RESDEFINITCODE: resdefinitcode,
      DBConst.FDN_RESSEGMENTCODE: ressegmentcode,
      DBConst.FDN_TRANSNO: transno,
      DBConst.FDN_LANGID: langid,
      DBConst.FDN_PRICECURRDESC: pricecurrdesc,
      DBConst.FDN_EXCRATETYPEDESC: excratetypedesc,
      DBConst.FDN_LANGCODE: langcode,
      DBConst.FDN_LANGDESC: langdesc,
      DBConst.FDN_RESSEGMENTDESC: ressegmentdesc,
      DBConst.FDN_BLOCKID: blockid,
      DBConst.FDN_BLOCKCODE: blockcode,
      DBConst.FDN_BLOCKDESC: blockdesc,
      DBConst.FDN_PRVTYPECODE: prvtypecode,
      DBConst.FDN_PRVTYPEDESC: prvtypedesc,
      DBConst.FDN_AGENCYDESC: agencydesc,
      DBConst.FDN_LOCCODE: loccode,
      DBConst.FDN_LOCDESC: locdesc,
      DBConst.FDN_ADVPAYCURRDESC: advpaycurrdesc,
      DBConst.FDN_LOCPLANDESC: locplandesc,
      DBConst.FDN_AGENCYSUBDESC: agencysubdesc,
      DBConst.FDN_RESDEFINITDESC: resdefinitdesc,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Resevent &&
          runtimeType == other.runtimeType &&
          reservno == other.reservno &&
          startdate == other.startdate &&
          starttime == other.starttime &&
          enddate == other.enddate &&
          endtime == other.endtime &&
          description == other.description &&
          totalpax == other.totalpax &&
          totalprice == other.totalprice &&
          note == other.note &&
          pricecurr == other.pricecurr &&
          excrate == other.excrate &&
          advpaydate == other.advpaydate &&
          paytype == other.paytype &&
          needinvoice == other.needinvoice &&
          advpaycurr == other.advpaycurr &&
          advpaynote == other.advpaynote &&
          transdate == other.transdate &&
          transtime == other.transtime &&
          agencyid == other.agencyid &&
          contact == other.contact &&
          resmasterno == other.resmasterno &&
          eventtypeid == other.eventtypeid &&
          advpayamount == other.advpayamount &&
          advpaytype == other.advpaytype &&
          empid == other.empid &&
          eventserviceid == other.eventserviceid &&
          foliono == other.foliono &&
          locationid == other.locationid &&
          eventtimeid == other.eventtimeid &&
          totalchd == other.totalchd &&
          totalbaby == other.totalbaby &&
          exppax == other.exppax &&
          expchd == other.expchd &&
          expbaby == other.expbaby &&
          tel == other.tel &&
          locplanid == other.locplanid &&
          bridename == other.bridename &&
          groomname == other.groomname &&
          haswedding == other.haswedding &&
          eventlocstd == other.eventlocstd &&
          weddingtime == other.weddingtime &&
          eventmusicid == other.eventmusicid &&
          animintroid == other.animintroid &&
          animfirstdanceid == other.animfirstdanceid &&
          eventdecorid == other.eventdecorid &&
          clientid == other.clientid &&
          brideclientid == other.brideclientid &&
          groomclientid == other.groomclientid &&
          animintronote == other.animintronote &&
          animfirstdancenote == other.animfirstdancenote &&
          animnote == other.animnote &&
          musicnote == other.musicnote &&
          decornote == other.decornote &&
          subtotal == other.subtotal &&
          freeamount == other.freeamount &&
          discrate == other.discrate &&
          ispricelocked == other.ispricelocked &&
          animcakeid == other.animcakeid &&
          animcakenote == other.animcakenote &&
          serviceprice == other.serviceprice &&
          locprice == other.locprice &&
          empprice == other.empprice &&
          menuprice == other.menuprice &&
          saleprprice == other.saleprprice &&
          consumpitemprice == other.consumpitemprice &&
          rentitemprice == other.rentitemprice &&
          eventrestype == other.eventrestype &&
          saleempid == other.saleempid &&
          infoempid == other.infoempid &&
          status == other.status &&
          excratetype == other.excratetype &&
          tableno == other.tableno &&
          lastchange == other.lastchange &&
          firstuser == other.firstuser &&
          contactclientid == other.contactclientid &&
          remarknote == other.remarknote &&
          resdate == other.resdate &&
          sourceid == other.sourceid &&
          ressegmentid == other.ressegmentid &&
          useextprice == other.useextprice &&
          citime == other.citime &&
          lockuserid == other.lockuserid &&
          resdefinitid == other.resdefinitid &&
          marketid == other.marketid &&
          agencysubid == other.agencysubid &&
          rescountryid == other.rescountryid &&
          invtransdate == other.invtransdate &&
          invtranstime == other.invtranstime &&
          invoiceno == other.invoiceno &&
          invuserid == other.invuserid &&
          isemplocked == other.isemplocked &&
          cotime == other.cotime &&
          emplockuserid == other.emplockuserid &&
          menucode == other.menucode &&
          pkgfreeamount == other.pkgfreeamount &&
          warnnote == other.warnnote &&
          memshipid == other.memshipid &&
          optiondate == other.optiondate &&
          advpaycurrid == other.advpaycurrid &&
          excratetypeid == other.excratetypeid &&
          menucodeid == other.menucodeid &&
          pricecurrid == other.pricecurrid &&
          isprivate == other.isprivate &&
          statusdesc == other.statusdesc &&
          startdt == other.startdt &&
          enddt == other.enddt &&
          discamount == other.discamount &&
          netprice == other.netprice &&
          netpricehomecurr == other.netpricehomecurr &&
          balance == other.balance &&
          balancehomecurr == other.balancehomecurr &&
          eventtype == other.eventtype &&
          eventloc == other.eventloc &&
          eventlocid == other.eventlocid &&
          location == other.location &&
          locplancode == other.locplancode &&
          empcode == other.empcode &&
          empname == other.empname &&
          duration == other.duration &&
          eventservice == other.eventservice &&
          eventservicedesc == other.eventservicedesc &&
          eventmenuid == other.eventmenuid &&
          eventmenu == other.eventmenu &&
          eventmenudesc == other.eventmenudesc &&
          setuptime == other.setuptime &&
          setdowntime == other.setdowntime &&
          roomno == other.roomno &&
          agency == other.agency &&
          isbanquet == other.isbanquet &&
          isdefbanquet == other.isdefbanquet &&
          isdef == other.isdef &&
          isspares == other.isspares &&
          isdefspa == other.isdefspa &&
          islocres == other.islocres &&
          isdeflocres == other.isdeflocres &&
          saleempcode == other.saleempcode &&
          saleempname == other.saleempname &&
          infoempcode == other.infoempcode &&
          infoempname == other.infoempname &&
          producttypeid == other.producttypeid &&
          producttype == other.producttype &&
          agencysub == other.agencysub &&
          resmarket == other.resmarket &&
          ressource == other.ressource &&
          ressegment == other.ressegment &&
          resdefinit == other.resdefinit &&
          rescountry == other.rescountry &&
          totalminstd == other.totalminstd &&
          totalmin == other.totalmin &&
          iscustomenu == other.iscustomenu &&
          foliodebit == other.foliodebit &&
          foliocredit == other.foliocredit &&
          hotelname == other.hotelname &&
          advpaycurrcode == other.advpaycurrcode &&
          agencycode == other.agencycode &&
          agencysubcode == other.agencysubcode &&
          clientcode == other.clientcode &&
          clientname == other.clientname &&
          eventdecorcode == other.eventdecorcode &&
          eventmusiccode == other.eventmusiccode &&
          excratetypecode == other.excratetypecode &&
          pricecurrcode == other.pricecurrcode &&
          resdefinitcode == other.resdefinitcode &&
          ressegmentcode == other.ressegmentcode &&
          transno == other.transno &&
          langid == other.langid &&
          pricecurrdesc == other.pricecurrdesc &&
          excratetypedesc == other.excratetypedesc &&
          langcode == other.langcode &&
          langdesc == other.langdesc &&
          ressegmentdesc == other.ressegmentdesc &&
          blockid == other.blockid &&
          blockcode == other.blockcode &&
          blockdesc == other.blockdesc &&
          prvtypecode == other.prvtypecode &&
          prvtypedesc == other.prvtypedesc &&
          agencydesc == other.agencydesc &&
          loccode == other.loccode &&
          locdesc == other.locdesc &&
          advpaycurrdesc == other.advpaycurrdesc &&
          locplandesc == other.locplandesc &&
          agencysubdesc == other.agencysubdesc &&
          resdefinitdesc == other.resdefinitdesc &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      reservno.hashCode ^
      startdate.hashCode ^
      starttime.hashCode ^
      enddate.hashCode ^
      endtime.hashCode ^
      description.hashCode ^
      totalpax.hashCode ^
      totalprice.hashCode ^
      note.hashCode ^
      pricecurr.hashCode ^
      excrate.hashCode ^
      advpaydate.hashCode ^
      paytype.hashCode ^
      needinvoice.hashCode ^
      advpaycurr.hashCode ^
      advpaynote.hashCode ^
      transdate.hashCode ^
      transtime.hashCode ^
      agencyid.hashCode ^
      contact.hashCode ^
      resmasterno.hashCode ^
      eventtypeid.hashCode ^
      advpayamount.hashCode ^
      advpaytype.hashCode ^
      empid.hashCode ^
      eventserviceid.hashCode ^
      foliono.hashCode ^
      locationid.hashCode ^
      eventtimeid.hashCode ^
      totalchd.hashCode ^
      totalbaby.hashCode ^
      exppax.hashCode ^
      expchd.hashCode ^
      expbaby.hashCode ^
      tel.hashCode ^
      locplanid.hashCode ^
      bridename.hashCode ^
      groomname.hashCode ^
      haswedding.hashCode ^
      eventlocstd.hashCode ^
      weddingtime.hashCode ^
      eventmusicid.hashCode ^
      animintroid.hashCode ^
      animfirstdanceid.hashCode ^
      eventdecorid.hashCode ^
      clientid.hashCode ^
      brideclientid.hashCode ^
      groomclientid.hashCode ^
      animintronote.hashCode ^
      animfirstdancenote.hashCode ^
      animnote.hashCode ^
      musicnote.hashCode ^
      decornote.hashCode ^
      subtotal.hashCode ^
      freeamount.hashCode ^
      discrate.hashCode ^
      ispricelocked.hashCode ^
      animcakeid.hashCode ^
      animcakenote.hashCode ^
      serviceprice.hashCode ^
      locprice.hashCode ^
      empprice.hashCode ^
      menuprice.hashCode ^
      saleprprice.hashCode ^
      consumpitemprice.hashCode ^
      rentitemprice.hashCode ^
      eventrestype.hashCode ^
      saleempid.hashCode ^
      infoempid.hashCode ^
      status.hashCode ^
      excratetype.hashCode ^
      tableno.hashCode ^
      lastchange.hashCode ^
      firstuser.hashCode ^
      contactclientid.hashCode ^
      remarknote.hashCode ^
      resdate.hashCode ^
      sourceid.hashCode ^
      ressegmentid.hashCode ^
      useextprice.hashCode ^
      citime.hashCode ^
      lockuserid.hashCode ^
      resdefinitid.hashCode ^
      marketid.hashCode ^
      agencysubid.hashCode ^
      rescountryid.hashCode ^
      invtransdate.hashCode ^
      invtranstime.hashCode ^
      invoiceno.hashCode ^
      invuserid.hashCode ^
      isemplocked.hashCode ^
      cotime.hashCode ^
      emplockuserid.hashCode ^
      menucode.hashCode ^
      pkgfreeamount.hashCode ^
      warnnote.hashCode ^
      memshipid.hashCode ^
      optiondate.hashCode ^
      advpaycurrid.hashCode ^
      excratetypeid.hashCode ^
      menucodeid.hashCode ^
      pricecurrid.hashCode ^
      isprivate.hashCode ^
      statusdesc.hashCode ^
      startdt.hashCode ^
      enddt.hashCode ^
      discamount.hashCode ^
      netprice.hashCode ^
      netpricehomecurr.hashCode ^
      balance.hashCode ^
      balancehomecurr.hashCode ^
      eventtype.hashCode ^
      eventloc.hashCode ^
      eventlocid.hashCode ^
      location.hashCode ^
      locplancode.hashCode ^
      empcode.hashCode ^
      empname.hashCode ^
      duration.hashCode ^
      eventservice.hashCode ^
      eventservicedesc.hashCode ^
      eventmenuid.hashCode ^
      eventmenu.hashCode ^
      eventmenudesc.hashCode ^
      setuptime.hashCode ^
      setdowntime.hashCode ^
      roomno.hashCode ^
      agency.hashCode ^
      isbanquet.hashCode ^
      isdefbanquet.hashCode ^
      isdef.hashCode ^
      isspares.hashCode ^
      isdefspa.hashCode ^
      islocres.hashCode ^
      isdeflocres.hashCode ^
      saleempcode.hashCode ^
      saleempname.hashCode ^
      infoempcode.hashCode ^
      infoempname.hashCode ^
      producttypeid.hashCode ^
      producttype.hashCode ^
      agencysub.hashCode ^
      resmarket.hashCode ^
      ressource.hashCode ^
      ressegment.hashCode ^
      resdefinit.hashCode ^
      rescountry.hashCode ^
      totalminstd.hashCode ^
      totalmin.hashCode ^
      iscustomenu.hashCode ^
      foliodebit.hashCode ^
      foliocredit.hashCode ^
      hotelname.hashCode ^
      advpaycurrcode.hashCode ^
      agencycode.hashCode ^
      agencysubcode.hashCode ^
      clientcode.hashCode ^
      clientname.hashCode ^
      eventdecorcode.hashCode ^
      eventmusiccode.hashCode ^
      excratetypecode.hashCode ^
      pricecurrcode.hashCode ^
      resdefinitcode.hashCode ^
      ressegmentcode.hashCode ^
      transno.hashCode ^
      langid.hashCode ^
      pricecurrdesc.hashCode ^
      excratetypedesc.hashCode ^
      langcode.hashCode ^
      langdesc.hashCode ^
      ressegmentdesc.hashCode ^
      blockid.hashCode ^
      blockcode.hashCode ^
      blockdesc.hashCode ^
      prvtypecode.hashCode ^
      prvtypedesc.hashCode ^
      agencydesc.hashCode ^
      loccode.hashCode ^
      locdesc.hashCode ^
      advpaycurrdesc.hashCode ^
      locplandesc.hashCode ^
      agencysubdesc.hashCode ^
      resdefinitdesc.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Event{${super.toString()}, reservno: $reservno, startdate: $startdate, starttime: $starttime, enddate: $enddate, endtime: $endtime, description: $description, totalpax: $totalpax, totalprice: $totalprice, note: $note, pricecurr: $pricecurr, excrate: $excrate, advpaydate: $advpaydate, paytype: $paytype, needinvoice: $needinvoice, advpaycurr: $advpaycurr, advpaynote: $advpaynote, transdate: $transdate, transtime: $transtime, agencyid: $agencyid, contact: $contact, resmasterno: $resmasterno, eventtypeid: $eventtypeid, advpayamount: $advpayamount, advpaytype: $advpaytype, empid: $empid, eventserviceid: $eventserviceid, foliono: $foliono, locationid: $locationid, eventtimeid: $eventtimeid, totalchd: $totalchd, totalbaby: $totalbaby, exppax: $exppax, expchd: $expchd, expbaby: $expbaby, tel: $tel, locplanid: $locplanid, bridename: $bridename, groomname: $groomname, haswedding: $haswedding, eventlocstd: $eventlocstd, weddingtime: $weddingtime, eventmusicid: $eventmusicid, animintroid: $animintroid, animfirstdanceid: $animfirstdanceid, eventdecorid: $eventdecorid, clientid: $clientid, brideclientid: $brideclientid, groomclientid: $groomclientid, animintronote: $animintronote, animfirstdancenote: $animfirstdancenote, animnote: $animnote, musicnote: $musicnote, decornote: $decornote, subtotal: $subtotal, freeamount: $freeamount, discrate: $discrate, ispricelocked: $ispricelocked, animcakeid: $animcakeid, animcakenote: $animcakenote, serviceprice: $serviceprice, locprice: $locprice, empprice: $empprice, menuprice: $menuprice, saleprprice: $saleprprice, consumpitemprice: $consumpitemprice, rentitemprice: $rentitemprice, eventrestype: $eventrestype, saleempid: $saleempid, infoempid: $infoempid, status: $status, excratetype: $excratetype, tableno: $tableno, lastchange: $lastchange, firstuser: $firstuser, contactclientid: $contactclientid, remarknote: $remarknote, resdate: $resdate, sourceid: $sourceid, ressegmentid: $ressegmentid, useextprice: $useextprice, citime: $citime, lockuserid: $lockuserid, resdefinitid: $resdefinitid, marketid: $marketid, agencysubid: $agencysubid, rescountryid: $rescountryid, invtransdate: $invtransdate, invtranstime: $invtranstime, invoiceno: $invoiceno, invuserid: $invuserid, isemplocked: $isemplocked, cotime: $cotime, emplockuserid: $emplockuserid, menucode: $menucode, pkgfreeamount: $pkgfreeamount, warnnote: $warnnote, memshipid: $memshipid, optiondate: $optiondate, advpaycurrid: $advpaycurrid, excratetypeid: $excratetypeid, menucodeid: $menucodeid, pricecurrid: $pricecurrid, isprivate: $isprivate, statusdesc: $statusdesc, startdt: $startdt, enddt: $enddt, discamount: $discamount, netprice: $netprice, netpricehomecurr: $netpricehomecurr, balance: $balance, balancehomecurr: $balancehomecurr, eventtype: $eventtype, eventloc: $eventloc, eventlocid: $eventlocid, location: $location, locplancode: $locplancode, empcode: $empcode, empname: $empname, duration: $duration, eventservice: $eventservice, eventservicedesc: $eventservicedesc, eventmenuid: $eventmenuid, eventmenu: $eventmenu, eventmenudesc: $eventmenudesc, setuptime: $setuptime, setdowntime: $setdowntime, roomno: $roomno, agency: $agency, isbanquet: $isbanquet, isdefbanquet: $isdefbanquet, isdef: $isdef, isspares: $isspares, isdefspa: $isdefspa, islocres: $islocres, isdeflocres: $isdeflocres, saleempcode: $saleempcode, saleempname: $saleempname, infoempcode: $infoempcode, infoempname: $infoempname, producttypeid: $producttypeid, producttype: $producttype, agencysub: $agencysub, resmarket: $resmarket, ressource: $ressource, ressegment: $ressegment, resdefinit: $resdefinit, rescountry: $rescountry, totalminstd: $totalminstd, totalmin: $totalmin, iscustomenu: $iscustomenu, foliodebit: $foliodebit, foliocredit: $foliocredit, hotelname: $hotelname, advpaycurrcode: $advpaycurrcode, agencycode: $agencycode, agencysubcode: $agencysubcode, clientcode: $clientcode, clientname: $clientname, eventdecorcode: $eventdecorcode, eventmusiccode: $eventmusiccode, excratetypecode: $excratetypecode, pricecurrcode: $pricecurrcode, resdefinitcode: $resdefinitcode, ressegmentcode: $ressegmentcode, transno: $transno, langid: $langid, jsonMap: $jsonMap}';
  }
}
