import 'package:hotech_flutter_utilities/Constants.dart';

class Loginfo {
  bool accountNonExpired;
  bool accountNonLocked;
  int authlevel;
  int authlevelfr;
  int authlevelso;
  int authlevelsr;
  List<String> authorities;
  String code;
  bool credentialsNonExpired;
  int currentHotelrefno;
  int currentid;
  int defaultHotelrefno;
  String description;
  String email;
  String empdepartcode;
  int empdepartid;
  List<int> emphotelids;
  String empposcode;
  int empposid;
  bool enabled;
  String firstname;
  String gid;
  bool hasmultihotel;
  String hotelgidstr;
  int hotelmid;
  String hotelname;
  int hotelrefno;
  double hotelng;
  double hotelat;
  String mobiletel;
  int id;
  String insdatetime;
  int insuserid;
  bool isactive;
  bool isbanquet;
  bool isdef;
  bool isempself;
  bool isfinreqemp;
  bool ishead;
  bool ishk;
  bool islocres;
  bool isposonly;
  bool isspainfoemp;
  bool isspares;
  bool isspasaleemp;
  bool issuperhotel;
  bool issuperuser;
  bool ists;
  bool iswaiter;
  String langcode;
  int langid;
  String langshort;
  String lastname;
  String logintype;
  int mid;
  String pass;
  String password;
  String refcode;
  int refid;
  bool selfish;
  String shortcode;
  String updatetime;
  int updtl;
  String usergroupidstr;
  String usergroups;
  int userid;
  String username;
  int ver;
  String xcode;

  Loginfo({
    this.accountNonExpired,
    this.accountNonLocked,
    this.authlevel,
    this.authlevelfr,
    this.authlevelso,
    this.authlevelsr,
    this.authorities,
    this.code,
    this.credentialsNonExpired,
    this.currentHotelrefno,
    this.currentid,
    this.defaultHotelrefno,
    this.description,
    this.email,
    this.empdepartcode,
    this.empdepartid,
    this.emphotelids,
    this.empposcode,
    this.empposid,
    this.enabled,
    this.firstname,
    this.gid,
    this.hasmultihotel,
    this.hotelgidstr,
    this.hotelmid,
    this.hotelname,
    this.hotelrefno,
    this.hotelng,
    this.hotelat,
    this.mobiletel,
    this.id,
    this.insdatetime,
    this.insuserid,
    this.isactive,
    this.isbanquet,
    this.isdef,
    this.isempself,
    this.isfinreqemp,
    this.ishead,
    this.ishk,
    this.islocres,
    this.isposonly,
    this.isspainfoemp,
    this.isspares,
    this.isspasaleemp,
    this.issuperhotel,
    this.issuperuser,
    this.ists,
    this.iswaiter,
    this.langcode,
    this.langid,
    this.langshort,
    this.lastname,
    this.logintype,
    this.mid,
    this.pass,
    this.password,
    this.refcode,
    this.refid,
    this.selfish,
    this.shortcode,
    this.updatetime,
    this.updtl,
    this.usergroupidstr,
    this.usergroups,
    this.userid,
    this.username,
    this.ver,
    this.xcode,
  });

  factory Loginfo.fromJson(Map<String, dynamic> json) {
    return Loginfo(
      accountNonExpired: json[DBConst.FDN_ACCOUNTNONEXPIRED],
      accountNonLocked: json[DBConst.FDN_ACCOUNTNONLOCKED],
      authlevel: json[DBConst.FDN_AUTHLEVEL],
      authlevelfr: json[DBConst.FDN_AUTHLEVELFR],
      authlevelso: json[DBConst.FDN_AUTHLEVELSO],
      authlevelsr: json[DBConst.FDN_AUTHLEVELSR],
      authorities: json[DBConst.FDN_AUTHORITIES] != null ? (json[DBConst.FDN_AUTHORITIES] as List).cast<String>() : null,
      code: json[DBConst.FDN_CODE],
      credentialsNonExpired: json[DBConst.FDN_CREDENTIALSNONEXPIRED],
      currentHotelrefno: json[DBConst.FDN_CURRENTHOTELREFNO],
      currentid: json[DBConst.FDN_CURRENTID],
      defaultHotelrefno: json[DBConst.FDN_DEFAULTHOTELREFNO],
      description: json[DBConst.FDN_DESCRIPTION],
      email: json[DBConst.FDN_EMAIL],
      empdepartcode: json[DBConst.FDN_EMPDEPARTCODE],
      empdepartid: json[DBConst.FDN_EMPDEPARTID],
      emphotelids: (json[DBConst.FDN_EMPHOTELIDS] as List).cast<int>(),
      empposcode: json[DBConst.FDN_EMPPOSCODE],
      empposid: json[DBConst.FDN_EMPPOSID],
      enabled: json[DBConst.FDN_ENABLED],
      firstname: json[DBConst.FDN_FIRSTNAME],
      gid: json[DBConst.FDN_GID],
      hasmultihotel: json[DBConst.FDN_HASMULTIHOTEL],
      hotelgidstr: json[DBConst.FDN_HOTELGIDSTR],
      hotelmid: json[DBConst.FDN_HOTELMID],
      hotelname: json[DBConst.FDN_HOTELNAME],
      hotelrefno: json[DBConst.FDN_HOTELREFNO],
      hotelng: json[DBConst.FDN_HOTELNG],
      hotelat: json[DBConst.FDN_HOTELAT],
      mobiletel: json[DBConst.FDN_MOBILETEL],
      id: json[DBConst.FDN_ID],
      insdatetime: json[DBConst.FDN_INSDATETIME],
      insuserid: json[DBConst.FDN_INSUSERID],
      isactive: json[DBConst.FDN_ISACTIVE],
      isbanquet: json[DBConst.FDN_ISBANQUET],
      isdef: json[DBConst.FDN_ISDEF],
      isempself: json[DBConst.FDN_ISEMPSELF],
      isfinreqemp: json[DBConst.FDN_ISFINREQEMP],
      ishead: json[DBConst.FDN_ISHEAD],
      ishk: json[DBConst.FDN_ISHK],
      islocres: json[DBConst.FDN_ISLOCRES],
      isposonly: json[DBConst.FDN_ISPOSONLY],
      isspainfoemp: json[DBConst.FDN_ISSPAINFOEMP],
      isspares: json[DBConst.FDN_ISSPARES],
      isspasaleemp: json[DBConst.FDN_ISSPASALEEMP],
      issuperhotel: json[DBConst.FDN_ISSUPERHOTEL],
      issuperuser: json[DBConst.FDN_ISSUPERUSER],
      ists: json[DBConst.FDN_ISTS],
      iswaiter: json[DBConst.FDN_ISWAITER],
      langcode: json[DBConst.FDN_LANGCODE],
      langid: json[DBConst.FDN_LANGID],
      langshort: json[DBConst.FDN_LANGSHORT],
      lastname: json[DBConst.FDN_LASTNAME],
      logintype: json[DBConst.FDN_LOGINTYPE],
      mid: json[DBConst.FDN_MID],
      pass: json[DBConst.FDN_PASS],
      password: json[DBConst.FDN_PASSWORD],
      refcode: json[DBConst.FDN_REFCODE],
      refid: json[DBConst.FDN_REFID],
      selfish: json[DBConst.FDN_SELFISH],
      shortcode: json[DBConst.FDN_SHORTCODE],
      updatetime: json[DBConst.FDN_UPDATETIME],
      updtl: json[DBConst.FDN_UPDTL],
      usergroupidstr: json[DBConst.FDN_USERGROUPIDSTR],
      usergroups: json[DBConst.FDN_USERGROUPS],
      userid: json[DBConst.FDN_USERID],
      username: json[DBConst.FDN_USERNAME],
      ver: json[DBConst.FDN_VER],
      xcode: json[DBConst.FDN_XCODE],
    );
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Loginfo &&
          runtimeType == other.runtimeType &&
          accountNonExpired == other.accountNonExpired &&
          accountNonLocked == other.accountNonLocked &&
          authlevel == other.authlevel &&
          authlevelfr == other.authlevelfr &&
          authlevelso == other.authlevelso &&
          authlevelsr == other.authlevelsr &&
          authorities == other.authorities &&
          code == other.code &&
          credentialsNonExpired == other.credentialsNonExpired &&
          currentHotelrefno == other.currentHotelrefno &&
          currentid == other.currentid &&
          defaultHotelrefno == other.defaultHotelrefno &&
          description == other.description &&
          email == other.email &&
          empdepartcode == other.empdepartcode &&
          empdepartid == other.empdepartid &&
          emphotelids == other.emphotelids &&
          empposcode == other.empposcode &&
          empposid == other.empposid &&
          enabled == other.enabled &&
          firstname == other.firstname &&
          gid == other.gid &&
          hasmultihotel == other.hasmultihotel &&
          hotelgidstr == other.hotelgidstr &&
          hotelmid == other.hotelmid &&
          hotelname == other.hotelname &&
          hotelrefno == other.hotelrefno &&
          hotelng == other.hotelng &&
          hotelat == other.hotelat &&
          mobiletel == other.mobiletel &&
          id == other.id &&
          insdatetime == other.insdatetime &&
          insuserid == other.insuserid &&
          isactive == other.isactive &&
          isbanquet == other.isbanquet &&
          isdef == other.isdef &&
          isempself == other.isempself &&
          isfinreqemp == other.isfinreqemp &&
          ishead == other.ishead &&
          ishk == other.ishk &&
          islocres == other.islocres &&
          isposonly == other.isposonly &&
          isspainfoemp == other.isspainfoemp &&
          isspares == other.isspares &&
          isspasaleemp == other.isspasaleemp &&
          issuperhotel == other.issuperhotel &&
          issuperuser == other.issuperuser &&
          ists == other.ists &&
          iswaiter == other.iswaiter &&
          langcode == other.langcode &&
          langid == other.langid &&
          langshort == other.langshort &&
          lastname == other.lastname &&
          logintype == other.logintype &&
          mid == other.mid &&
          pass == other.pass &&
          password == other.password &&
          refcode == other.refcode &&
          refid == other.refid &&
          selfish == other.selfish &&
          shortcode == other.shortcode &&
          updatetime == other.updatetime &&
          updtl == other.updtl &&
          usergroupidstr == other.usergroupidstr &&
          usergroups == other.usergroups &&
          userid == other.userid &&
          username == other.username &&
          ver == other.ver &&
          xcode == other.xcode;

  @override
  int get hashCode =>
      accountNonExpired.hashCode ^
      accountNonLocked.hashCode ^
      authlevel.hashCode ^
      authlevelfr.hashCode ^
      authlevelso.hashCode ^
      authlevelsr.hashCode ^
      authorities.hashCode ^
      code.hashCode ^
      credentialsNonExpired.hashCode ^
      currentHotelrefno.hashCode ^
      currentid.hashCode ^
      defaultHotelrefno.hashCode ^
      description.hashCode ^
      email.hashCode ^
      empdepartcode.hashCode ^
      empdepartid.hashCode ^
      emphotelids.hashCode ^
      empposcode.hashCode ^
      empposid.hashCode ^
      enabled.hashCode ^
      firstname.hashCode ^
      gid.hashCode ^
      hasmultihotel.hashCode ^
      hotelgidstr.hashCode ^
      hotelmid.hashCode ^
      hotelname.hashCode ^
      hotelrefno.hashCode ^
      hotelng.hashCode ^
      hotelat.hashCode ^
      mobiletel.hashCode ^
      id.hashCode ^
      insdatetime.hashCode ^
      insuserid.hashCode ^
      isactive.hashCode ^
      isbanquet.hashCode ^
      isdef.hashCode ^
      isempself.hashCode ^
      isfinreqemp.hashCode ^
      ishead.hashCode ^
      ishk.hashCode ^
      islocres.hashCode ^
      isposonly.hashCode ^
      isspainfoemp.hashCode ^
      isspares.hashCode ^
      isspasaleemp.hashCode ^
      issuperhotel.hashCode ^
      issuperuser.hashCode ^
      ists.hashCode ^
      iswaiter.hashCode ^
      langcode.hashCode ^
      langid.hashCode ^
      langshort.hashCode ^
      lastname.hashCode ^
      logintype.hashCode ^
      mid.hashCode ^
      pass.hashCode ^
      password.hashCode ^
      refcode.hashCode ^
      refid.hashCode ^
      selfish.hashCode ^
      shortcode.hashCode ^
      updatetime.hashCode ^
      updtl.hashCode ^
      usergroupidstr.hashCode ^
      usergroups.hashCode ^
      userid.hashCode ^
      username.hashCode ^
      ver.hashCode ^
      xcode.hashCode;

  @override
  String toString() {
    return 'Loginfo{accountNonExpired: $accountNonExpired, accountNonLocked: $accountNonLocked, authlevel: $authlevel, authlevelfr: $authlevelfr, authlevelso: $authlevelso, authlevelsr: $authlevelsr, authorities: $authorities, code: $code, credentialsNonExpired: $credentialsNonExpired, currentHotelrefno: $currentHotelrefno, currentid: $currentid, defaultHotelrefno: $defaultHotelrefno, description: $description, email: $email, empdepartcode: $empdepartcode, empdepartid: $empdepartid, emphotelids: $emphotelids, empposcode: $empposcode, empposid: $empposid, enabled: $enabled, firstname: $firstname, gid: $gid, hasmultihotel: $hasmultihotel, hotelgidstr: $hotelgidstr, hotelmid: $hotelmid, hotelname: $hotelname, hotelrefno: $hotelrefno, hotelng: $hotelng, hotelat: $hotelat, mobiletel: $mobiletel, id: $id, insdatetime: $insdatetime, insuserid: $insuserid, isactive: $isactive, isbanquet: $isbanquet, isdef: $isdef, isempself: $isempself, isfinreqemp: $isfinreqemp, ishead: $ishead, ishk: $ishk, islocres: $islocres, isposonly: $isposonly, isspainfoemp: $isspainfoemp, isspares: $isspares, isspasaleemp: $isspasaleemp, issuperhotel: $issuperhotel, issuperuser: $issuperuser, ists: $ists, iswaiter: $iswaiter, langcode: $langcode, langid: $langid, langshort: $langshort, lastname: $lastname, logintype: $logintype, mid: $mid, pass: $pass, password: $password, refcode: $refcode, refid: $refid, selfish: $selfish, shortcode: $shortcode, updatetime: $updatetime, updtl: $updtl, usergroupidstr: $usergroupidstr, usergroups: $usergroups, userid: $userid, username: $username, ver: $ver, xcode: $xcode}';
  }
}
