import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Posline extends BaseModelSync {
  int foliono;
  String transdate;
  double excrate;
  String gidstr;
  String department;
  int departmentid;
  String hotelname;
  double taxtotal;
  String salegroup;
  int salegroupid;
  double taxrate;
  double total;
  String salegrp;
  int salegrpid;
  double linediscamount;
  String salegrpdesc;
  String sliptype;
  double linetotaldisced;
  String barcode;
  String stockcodedesc;
  double posmaindiscrate;
  double posmainservrate;
  double posmainsubtotal;
  double posmaindiscamount;
  int transno;
  double price;
  int orderno;
  double linetotal;
  bool istemp;
  double quantity;
  double linediscrate;
  int xreasonid;
  String stockcode;
  bool isprinted;
  int courseno;
  bool isprintedslip;
  int stockcodeid;
  String description;
  int linecounter;
  String updatetime;
  Map<String, dynamic> jsonMap;

  Posline({
    this.foliono,
    this.transdate,
    this.excrate,
    this.gidstr,
    this.department,
    this.departmentid,
    this.hotelname,
    this.taxtotal,
    this.salegroup,
    this.salegroupid,
    this.taxrate,
    this.total,
    this.salegrp,
    this.salegrpid,
    this.linediscamount,
    this.salegrpdesc,
    this.sliptype,
    this.linetotaldisced,
    this.barcode,
    this.stockcodedesc,
    this.posmaindiscrate,
    this.posmainservrate,
    this.posmainsubtotal,
    this.posmaindiscamount,
    this.transno,
    this.price,
    this.orderno,
    this.linetotal,
    this.istemp,
    this.quantity,
    this.linediscrate,
    this.xreasonid,
    this.stockcode,
    this.isprinted,
    this.courseno,
    this.isprintedslip,
    this.stockcodeid,
    this.description,
    this.linecounter,
    this.updatetime,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Posline.fromJson(Map<String, dynamic> json) => new Posline(
        foliono: json[DBConst.FDN_FOLIONO],
        transdate: json[DBConst.FDN_TRANSDATE],
        excrate: json[DBConst.FDN_EXCRATE],
        gidstr: json[DBConst.FDN_GIDSTR],
        department: json[DBConst.FDN_DEPARTMENT],
        departmentid: json[DBConst.FDN_DEPARTMENTID],
        hotelname: json[DBConst.FDN_HOTELNAME],
        taxtotal: json[DBConst.FDN_TAXTOTAL],
        salegroup: json[DBConst.FDN_SALEGROUP],
        salegroupid: json[DBConst.FDN_SALEGROUPID],
        taxrate: json[DBConst.FDN_TAXRATE],
        total: json[DBConst.FDN_TOTAL],
        salegrp: json[DBConst.FDN_SALEGRP],
        salegrpid: json[DBConst.FDN_SALEGRPID],
        linediscamount: json[DBConst.FDN_LINEDISCAMOUNT],
        salegrpdesc: json[DBConst.FDN_SALEGRPDESC],
        sliptype: json[DBConst.FDN_SLIPTYPE],
        linetotaldisced: json[DBConst.FDN_LINETOTALDISCED],
        barcode: json[DBConst.FDN_BARCODE],
        stockcodedesc: json[DBConst.FDN_STOCKCODEDESC],
        posmaindiscrate: json[DBConst.FDN_POSMAINDISCRATE],
        posmainservrate: json[DBConst.FDN_POSMAINSERVRATE],
        posmainsubtotal: json[DBConst.FDN_POSMAINSUBTOTAL],
        posmaindiscamount: json[DBConst.FDN_POSMAINDISCAMOUNT],
        transno: json[DBConst.FDN_TRANSNO],
        price: json[DBConst.FDN_PRICE],
        orderno: json[DBConst.FDN_ORDERNO],
        linetotal: json[DBConst.FDN_LINETOTAL],
        istemp: json[DBConst.FDN_ISTEMP],
        quantity: json[DBConst.FDN_QUANTITY],
        linediscrate: json[DBConst.FDN_LINEDISCRATE],
        xreasonid: json[DBConst.FDN_XREASONID],
        stockcode: json[DBConst.FDN_STOCKCODE],
        isprinted: json[DBConst.FDN_ISPRINTED],
        courseno: json[DBConst.FDN_COURSENO],
        isprintedslip: json[DBConst.FDN_ISPRINTEDSLIP],
        stockcodeid: json[DBConst.FDN_STOCKCODEID],
        description: json[DBConst.FDN_DESCRIPTION],
        linecounter: json[DBConst.FDN_LINECOUNTER],
        updatetime: json[DBConst.FDN_UPDATETIME],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_FOLIONO: foliono,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_EXCRATE: excrate,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_DEPARTMENT: department,
      DBConst.FDN_DEPARTMENTID: departmentid,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_TAXTOTAL: taxtotal,
      DBConst.FDN_SALEGROUP: salegroup,
      DBConst.FDN_SALEGROUPID: salegroupid,
      DBConst.FDN_TAXRATE: taxrate,
      DBConst.FDN_TOTAL: total,
      DBConst.FDN_SALEGRP: salegrp,
      DBConst.FDN_SALEGRPID: salegrpid,
      DBConst.FDN_LINEDISCAMOUNT: linediscamount,
      DBConst.FDN_SALEGRPDESC: salegrpdesc,
      DBConst.FDN_SLIPTYPE: sliptype,
      DBConst.FDN_LINETOTALDISCED: linetotaldisced,
      DBConst.FDN_BARCODE: barcode,
      DBConst.FDN_STOCKCODEDESC: stockcodedesc,
      DBConst.FDN_POSMAINDISCRATE: posmaindiscrate,
      DBConst.FDN_POSMAINSERVRATE: posmainservrate,
      DBConst.FDN_POSMAINSUBTOTAL: posmainsubtotal,
      DBConst.FDN_POSMAINDISCAMOUNT: posmaindiscamount,
      DBConst.FDN_TRANSNO: transno,
      DBConst.FDN_PRICE: price,
      DBConst.FDN_ORDERNO: orderno,
      DBConst.FDN_LINETOTAL: linetotal,
      DBConst.FDN_ISTEMP: istemp,
      DBConst.FDN_QUANTITY: quantity,
      DBConst.FDN_LINEDISCRATE: linediscrate,
      DBConst.FDN_XREASONID: xreasonid,
      DBConst.FDN_STOCKCODE: stockcode,
      DBConst.FDN_ISPRINTED: isprinted,
      DBConst.FDN_COURSENO: courseno,
      DBConst.FDN_ISPRINTEDSLIP: isprintedslip,
      DBConst.FDN_STOCKCODEID: stockcodeid,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_LINECOUNTER: linecounter,
      DBConst.FDN_UPDATETIME: updatetime,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Posline &&
          runtimeType == other.runtimeType &&
          foliono == other.foliono &&
          transdate == other.transdate &&
          excrate == other.excrate &&
          gidstr == other.gidstr &&
          department == other.department &&
          departmentid == other.departmentid &&
          hotelname == other.hotelname &&
          taxtotal == other.taxtotal &&
          salegroup == other.salegroup &&
          salegroupid == other.salegroupid &&
          taxrate == other.taxrate &&
          total == other.total &&
          salegrp == other.salegrp &&
          salegrpid == other.salegrpid &&
          linediscamount == other.linediscamount &&
          salegrpdesc == other.salegrpdesc &&
          sliptype == other.sliptype &&
          linetotaldisced == other.linetotaldisced &&
          barcode == other.barcode &&
          stockcodedesc == other.stockcodedesc &&
          posmaindiscrate == other.posmaindiscrate &&
          posmainservrate == other.posmainservrate &&
          posmainsubtotal == other.posmainsubtotal &&
          posmaindiscamount == other.posmaindiscamount &&
          transno == other.transno &&
          price == other.price &&
          orderno == other.orderno &&
          linetotal == other.linetotal &&
          istemp == other.istemp &&
          quantity == other.quantity &&
          linediscrate == other.linediscrate &&
          xreasonid == other.xreasonid &&
          stockcode == other.stockcode &&
          isprinted == other.isprinted &&
          courseno == other.courseno &&
          isprintedslip == other.isprintedslip &&
          stockcodeid == other.stockcodeid &&
          description == other.description &&
          linecounter == other.linecounter &&
          updatetime == other.updatetime &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      foliono.hashCode ^
      transdate.hashCode ^
      excrate.hashCode ^
      gidstr.hashCode ^
      department.hashCode ^
      departmentid.hashCode ^
      hotelname.hashCode ^
      taxtotal.hashCode ^
      salegroup.hashCode ^
      salegroupid.hashCode ^
      taxrate.hashCode ^
      total.hashCode ^
      salegrp.hashCode ^
      salegrpid.hashCode ^
      linediscamount.hashCode ^
      salegrpdesc.hashCode ^
      sliptype.hashCode ^
      linetotaldisced.hashCode ^
      barcode.hashCode ^
      stockcodedesc.hashCode ^
      posmaindiscrate.hashCode ^
      posmainservrate.hashCode ^
      posmainsubtotal.hashCode ^
      posmaindiscamount.hashCode ^
      transno.hashCode ^
      price.hashCode ^
      orderno.hashCode ^
      linetotal.hashCode ^
      istemp.hashCode ^
      quantity.hashCode ^
      linediscrate.hashCode ^
      xreasonid.hashCode ^
      stockcode.hashCode ^
      isprinted.hashCode ^
      courseno.hashCode ^
      isprintedslip.hashCode ^
      stockcodeid.hashCode ^
      description.hashCode ^
      linecounter.hashCode ^
      updatetime.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Posline{foliono: $foliono, transdate: $transdate, excrate: $excrate, gidstr: $gidstr, department: $department, departmentid: $departmentid, hotelname: $hotelname, taxtotal: $taxtotal, salegroup: $salegroup, salegroupid: $salegroupid, taxrate: $taxrate, total: $total, salegrp: $salegrp, salegrpid: $salegrpid, linediscamount: $linediscamount, salegrpdesc: $salegrpdesc, sliptype: $sliptype, linetotaldisced: $linetotaldisced, barcode: $barcode, stockcodedesc: $stockcodedesc, posmaindiscrate: $posmaindiscrate, posmainservrate: $posmainservrate, posmainsubtotal: $posmainsubtotal, posmaindiscamount: $posmaindiscamount, transno: $transno, price: $price, orderno: $orderno, linetotal: $linetotal, istemp: $istemp, quantity: $quantity, linediscrate: $linediscrate, xreasonid: $xreasonid, stockcode: $stockcode, isprinted: $isprinted, courseno: $courseno, isprintedslip: $isprintedslip, stockcodeid: $stockcodeid, description: $description, linecounter: $linecounter, updatetime: $updatetime, jsonMap: $jsonMap}';
  }
}
