import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Posmain extends BaseModelSync {
  String roomno;
  String gidstr;
  String departmentdesc;
  String hotelname;
  String departmentcode;
  String acccode;
  String accdesc;
  String taxocode;
  String taxodesc;
  String departname;
  String empname;
  String empcode;
  String cctypecode;
  String cctypedesc;
  double total;
  String paycurrcode;
  String paycurrdesc;
  double currtotal;
  double linediscamount;
  double grosstotal;
  String insdate;
  String instime;
  double vat0Amount;
  double vat1Amount;
  double vat8Amount;
  double vat18Amount;
  String prvtypecode;
  String prvtypedesc;
  double totaldiscamount;
  double vat8Total;
  double vat18Total;
  double vat0Total;
  double vat1Total;
  double paymentleft;
  double paymentotal;
  String postatus;
  String xreason;
  String postatuscode;
  String postatusdesc;
  int reservno;
  int foliono;
  String invtitle;
  String taxoffice;
  String taxnumber;
  bool isprivate;
  String fullname;
  int totalpax;
  double excrate;
  int accid;
  String department;
  int departmentid;
  bool needinvoice;
  bool isactive;
  String paycurr;
  String invoiceno;
  int taxoid;
  int empid;
  int cctypeid;
  int paycurrid;
  double discrate;
  double discamount;
  double subtotal;
  int subno;
  int prvtypeid;
  bool isclosed;
  String invtransdate;
  String invtranstime;
  int invuserid;
  String opendate;
  String closedate;
  String opentime;
  String waiter;
  String sliptype;
  String slipno;
  String accno;
  double servrate;
  String closetime;
  int foliopax;
  double crcardpayment;
  double servamount;
  double cashpayment;
  double boardpayment;
  int currlineno;
  int postatusid;
  String invaddress;
  bool isdropped;
  bool isprintedftr;
  bool isprintedhdr;
  int lastcourseno;
  String tableno;
  String note;
  String transdate;
  int transno;
  String transtime;
  String updatetime;
  Map<String, dynamic> jsonMap;

  Posmain({
    this.roomno,
    this.gidstr,
    this.departmentdesc,
    this.hotelname,
    this.departmentcode,
    this.acccode,
    this.accdesc,
    this.taxocode,
    this.taxodesc,
    this.departname,
    this.empname,
    this.empcode,
    this.cctypecode,
    this.cctypedesc,
    this.total,
    this.paycurrcode,
    this.paycurrdesc,
    this.currtotal,
    this.linediscamount,
    this.grosstotal,
    this.insdate,
    this.instime,
    this.vat0Amount,
    this.vat1Amount,
    this.vat8Amount,
    this.vat18Amount,
    this.prvtypecode,
    this.prvtypedesc,
    this.totaldiscamount,
    this.vat8Total,
    this.vat18Total,
    this.vat0Total,
    this.vat1Total,
    this.paymentleft,
    this.paymentotal,
    this.postatus,
    this.xreason,
    this.postatuscode,
    this.postatusdesc,
    this.reservno,
    this.foliono,
    this.invtitle,
    this.taxoffice,
    this.taxnumber,
    this.isprivate,
    this.fullname,
    this.totalpax,
    this.excrate,
    this.accid,
    this.department,
    this.departmentid,
    this.needinvoice,
    this.isactive,
    this.paycurr,
    this.invoiceno,
    this.taxoid,
    this.empid,
    this.cctypeid,
    this.paycurrid,
    this.discrate,
    this.discamount,
    this.subtotal,
    this.subno,
    this.prvtypeid,
    this.isclosed,
    this.invtransdate,
    this.invtranstime,
    this.invuserid,
    this.opendate,
    this.closedate,
    this.opentime,
    this.waiter,
    this.sliptype,
    this.slipno,
    this.accno,
    this.servrate,
    this.closetime,
    this.foliopax,
    this.crcardpayment,
    this.servamount,
    this.cashpayment,
    this.boardpayment,
    this.currlineno,
    this.postatusid,
    this.invaddress,
    this.isdropped,
    this.isprintedftr,
    this.isprintedhdr,
    this.lastcourseno,
    this.tableno,
    this.note,
    this.transdate,
    this.transno,
    this.transtime,
    this.updatetime,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Posmain.fromJson(Map<String, dynamic> json) => new Posmain(
        roomno: json[DBConst.FDN_ROOMNO],
        gidstr: json[DBConst.FDN_GIDSTR],
        departmentdesc: json[DBConst.FDN_DEPARTMENTDESC],
        hotelname: json[DBConst.FDN_HOTELNAME],
        departmentcode: json[DBConst.FDN_DEPARTMENTCODE],
        acccode: json[DBConst.FDN_ACCCODE],
        accdesc: json[DBConst.FDN_ACCDESC],
        taxocode: json[DBConst.FDN_TAXOCODE],
        taxodesc: json[DBConst.FDN_TAXODESC],
        departname: json[DBConst.FDN_DEPARTNAME],
        empname: json[DBConst.FDN_EMPNAME],
        empcode: json[DBConst.FDN_EMPCODE],
        cctypecode: json[DBConst.FDN_CCTYPECODE],
        cctypedesc: json[DBConst.FDN_CCTYPEDESC],
        total: json[DBConst.FDN_TOTAL],
        paycurrcode: json[DBConst.FDN_PAYCURRCODE],
        paycurrdesc: json[DBConst.FDN_PAYCURRDESC],
        currtotal: json[DBConst.FDN_CURRTOTAL],
        linediscamount: json[DBConst.FDN_LINEDISCAMOUNT],
        grosstotal: json[DBConst.FDN_GROSSTOTAL],
        insdate: json[DBConst.FDN_INSDATE],
        instime: json[DBConst.FDN_INSTIME],
        vat0Amount: json[DBConst.FDN_VAT0AMOUNT],
        vat1Amount: json[DBConst.FDN_VAT1AMOUNT],
        vat8Amount: json[DBConst.FDN_VAT8AMOUNT],
        vat18Amount: json[DBConst.FDN_VAT18AMOUNT],
        prvtypecode: json[DBConst.FDN_PRVTYPECODE],
        prvtypedesc: json[DBConst.FDN_PRVTYPEDESC],
        totaldiscamount: json[DBConst.FDN_TOTALDISCAMOUNT],
        vat8Total: json[DBConst.FDN_VAT8TOTAL],
        vat18Total: json[DBConst.FDN_VAT18TOTAL],
        vat0Total: json[DBConst.FDN_VAT0TOTAL],
        vat1Total: json[DBConst.FDN_VAT1TOTAL],
        paymentleft: json[DBConst.FDN_PAYMENTLEFT],
        paymentotal: json[DBConst.FDN_PAYMENTOTAL],
        postatus: json[DBConst.FDN_POSTATUS],
        xreason: json[DBConst.FDN_XREASON],
        postatuscode: json[DBConst.FDN_POSTATUSCODE],
        postatusdesc: json[DBConst.FDN_POSTATUSDESC],
        reservno: json[DBConst.FDN_RESERVNO],
        foliono: json[DBConst.FDN_FOLIONO],
        invtitle: json[DBConst.FDN_INVTITLE],
        taxoffice: json[DBConst.FDN_TAXOFFICE],
        taxnumber: json[DBConst.FDN_TAXNUMBER],
        isprivate: json[DBConst.FDN_ISPRIVATE],
        fullname: json[DBConst.FDN_FULLNAME],
        totalpax: json[DBConst.FDN_TOTALPAX],
        excrate: json[DBConst.FDN_EXCRATE],
        accid: json[DBConst.FDN_ACCID],
        department: json[DBConst.FDN_DEPARTMENT],
        departmentid: json[DBConst.FDN_DEPARTMENTID],
        needinvoice: json[DBConst.FDN_NEEDINVOICE],
        isactive: json[DBConst.FDN_ISACTIVE],
        paycurr: json[DBConst.FDN_PAYCURR],
        invoiceno: json[DBConst.FDN_INVOICENO],
        taxoid: json[DBConst.FDN_TAXOID],
        empid: json[DBConst.FDN_EMPID],
        cctypeid: json[DBConst.FDN_CCTYPEID],
        paycurrid: json[DBConst.FDN_PAYCURRID],
        discrate: json[DBConst.FDN_DISCRATE],
        discamount: json[DBConst.FDN_DISCAMOUNT],
        subtotal: json[DBConst.FDN_SUBTOTAL],
        subno: json[DBConst.FDN_SUBNO],
        prvtypeid: json[DBConst.FDN_PRVTYPEID],
        isclosed: json[DBConst.FDN_ISCLOSED],
        invtransdate: json[DBConst.FDN_INVTRANSDATE],
        invtranstime: json[DBConst.FDN_INVTRANSTIME],
        invuserid: json[DBConst.FDN_INVUSERID],
        opendate: json[DBConst.FDN_OPENDATE],
        closedate: json[DBConst.FDN_CLOSEDATE],
        opentime: json[DBConst.FDN_OPENTIME],
        waiter: json[DBConst.FDN_WAITER],
        sliptype: json[DBConst.FDN_SLIPTYPE],
        slipno: json[DBConst.FDN_SLIPNO],
        accno: json[DBConst.FDN_ACCNO],
        servrate: json[DBConst.FDN_SERVRATE],
        closetime: json[DBConst.FDN_CLOSETIME],
        foliopax: json[DBConst.FDN_FOLIOPAX],
        crcardpayment: json[DBConst.FDN_CRCARDPAYMENT],
        servamount: json[DBConst.FDN_SERVAMOUNT],
        cashpayment: json[DBConst.FDN_CASHPAYMENT],
        boardpayment: json[DBConst.FDN_BOARDPAYMENT],
        currlineno: json[DBConst.FDN_CURRLINENO],
        postatusid: json[DBConst.FDN_POSTATUSID],
        invaddress: json[DBConst.FDN_INVADDRESS],
        isdropped: json[DBConst.FDN_ISDROPPED],
        isprintedftr: json[DBConst.FDN_ISPRINTEDFTR],
        isprintedhdr: json[DBConst.FDN_ISPRINTEDHDR],
        lastcourseno: json[DBConst.FDN_LASTCOURSENO],
        tableno: json[DBConst.FDN_TABLENO],
        note: json[DBConst.FDN_NOTE],
        transdate: json[DBConst.FDN_TRANSDATE],
        transno: json[DBConst.FDN_TRANSNO],
        transtime: json[DBConst.FDN_TRANSTIME],
        updatetime: json[DBConst.FDN_UPDATETIME],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ROOMNO: roomno,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_DEPARTMENTDESC: departmentdesc,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_DEPARTMENTCODE: departmentcode,
      DBConst.FDN_ACCCODE: acccode,
      DBConst.FDN_ACCDESC: accdesc,
      DBConst.FDN_TAXOCODE: taxocode,
      DBConst.FDN_TAXODESC: taxodesc,
      DBConst.FDN_DEPARTNAME: departname,
      DBConst.FDN_EMPNAME: empname,
      DBConst.FDN_EMPCODE: empcode,
      DBConst.FDN_CCTYPECODE: cctypecode,
      DBConst.FDN_CCTYPEDESC: cctypedesc,
      DBConst.FDN_TOTAL: total,
      DBConst.FDN_PAYCURRCODE: paycurrcode,
      DBConst.FDN_PAYCURRDESC: paycurrdesc,
      DBConst.FDN_CURRTOTAL: currtotal,
      DBConst.FDN_LINEDISCAMOUNT: linediscamount,
      DBConst.FDN_GROSSTOTAL: grosstotal,
      DBConst.FDN_INSDATE: insdate,
      DBConst.FDN_INSTIME: instime,
      DBConst.FDN_VAT0AMOUNT: vat0Amount,
      DBConst.FDN_VAT1AMOUNT: vat1Amount,
      DBConst.FDN_VAT8AMOUNT: vat8Amount,
      DBConst.FDN_VAT18AMOUNT: vat18Amount,
      DBConst.FDN_PRVTYPECODE: prvtypecode,
      DBConst.FDN_PRVTYPEDESC: prvtypedesc,
      DBConst.FDN_TOTALDISCAMOUNT: totaldiscamount,
      DBConst.FDN_VAT8TOTAL: vat8Total,
      DBConst.FDN_VAT18TOTAL: vat18Total,
      DBConst.FDN_VAT0TOTAL: vat0Total,
      DBConst.FDN_VAT1TOTAL: vat1Total,
      DBConst.FDN_PAYMENTLEFT: paymentleft,
      DBConst.FDN_PAYMENTOTAL: paymentotal,
      DBConst.FDN_POSTATUS: postatus,
      DBConst.FDN_XREASON: xreason,
      DBConst.FDN_POSTATUSCODE: postatuscode,
      DBConst.FDN_POSTATUSDESC: postatusdesc,
      DBConst.FDN_RESERVNO: reservno,
      DBConst.FDN_FOLIONO: foliono,
      DBConst.FDN_INVTITLE: invtitle,
      DBConst.FDN_TAXOFFICE: taxoffice,
      DBConst.FDN_TAXNUMBER: taxnumber,
      DBConst.FDN_ISPRIVATE: isprivate,
      DBConst.FDN_FULLNAME: fullname,
      DBConst.FDN_TOTALPAX: totalpax,
      DBConst.FDN_EXCRATE: excrate,
      DBConst.FDN_ACCID: accid,
      DBConst.FDN_DEPARTMENT: department,
      DBConst.FDN_DEPARTMENTID: departmentid,
      DBConst.FDN_NEEDINVOICE: needinvoice,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_PAYCURR: paycurr,
      DBConst.FDN_INVOICENO: invoiceno,
      DBConst.FDN_TAXOID: taxoid,
      DBConst.FDN_EMPID: empid,
      DBConst.FDN_CCTYPEID: cctypeid,
      DBConst.FDN_PAYCURRID: paycurrid,
      DBConst.FDN_DISCRATE: discrate,
      DBConst.FDN_DISCAMOUNT: discamount,
      DBConst.FDN_SUBTOTAL: subtotal,
      DBConst.FDN_SUBNO: subno,
      DBConst.FDN_PRVTYPEID: prvtypeid,
      DBConst.FDN_ISCLOSED: isclosed,
      DBConst.FDN_INVTRANSDATE: invtransdate,
      DBConst.FDN_INVTRANSTIME: invtranstime,
      DBConst.FDN_INVUSERID: invuserid,
      DBConst.FDN_OPENDATE: opendate,
      DBConst.FDN_CLOSEDATE: closedate,
      DBConst.FDN_OPENTIME: opentime,
      DBConst.FDN_WAITER: waiter,
      DBConst.FDN_SLIPTYPE: sliptype,
      DBConst.FDN_SLIPNO: slipno,
      DBConst.FDN_ACCNO: accno,
      DBConst.FDN_SERVRATE: servrate,
      DBConst.FDN_CLOSETIME: closetime,
      DBConst.FDN_FOLIOPAX: foliopax,
      DBConst.FDN_CRCARDPAYMENT: crcardpayment,
      DBConst.FDN_SERVAMOUNT: servamount,
      DBConst.FDN_CASHPAYMENT: cashpayment,
      DBConst.FDN_BOARDPAYMENT: boardpayment,
      DBConst.FDN_CURRLINENO: currlineno,
      DBConst.FDN_POSTATUSID: postatusid,
      DBConst.FDN_INVADDRESS: invaddress,
      DBConst.FDN_ISDROPPED: isdropped,
      DBConst.FDN_ISPRINTEDFTR: isprintedftr,
      DBConst.FDN_ISPRINTEDHDR: isprintedhdr,
      DBConst.FDN_LASTCOURSENO: lastcourseno,
      DBConst.FDN_TABLENO: tableno,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_TRANSNO: transno,
      DBConst.FDN_TRANSTIME: transtime,
      DBConst.FDN_UPDATETIME: updatetime,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Posmain &&
          runtimeType == other.runtimeType &&
          roomno == other.roomno &&
          gidstr == other.gidstr &&
          departmentdesc == other.departmentdesc &&
          hotelname == other.hotelname &&
          departmentcode == other.departmentcode &&
          acccode == other.acccode &&
          accdesc == other.accdesc &&
          taxocode == other.taxocode &&
          taxodesc == other.taxodesc &&
          departname == other.departname &&
          empname == other.empname &&
          empcode == other.empcode &&
          cctypecode == other.cctypecode &&
          cctypedesc == other.cctypedesc &&
          total == other.total &&
          paycurrcode == other.paycurrcode &&
          paycurrdesc == other.paycurrdesc &&
          currtotal == other.currtotal &&
          linediscamount == other.linediscamount &&
          grosstotal == other.grosstotal &&
          insdate == other.insdate &&
          instime == other.instime &&
          vat0Amount == other.vat0Amount &&
          vat1Amount == other.vat1Amount &&
          vat8Amount == other.vat8Amount &&
          vat18Amount == other.vat18Amount &&
          prvtypecode == other.prvtypecode &&
          prvtypedesc == other.prvtypedesc &&
          totaldiscamount == other.totaldiscamount &&
          vat8Total == other.vat8Total &&
          vat18Total == other.vat18Total &&
          vat0Total == other.vat0Total &&
          vat1Total == other.vat1Total &&
          paymentleft == other.paymentleft &&
          paymentotal == other.paymentotal &&
          postatus == other.postatus &&
          xreason == other.xreason &&
          postatuscode == other.postatuscode &&
          postatusdesc == other.postatusdesc &&
          reservno == other.reservno &&
          foliono == other.foliono &&
          invtitle == other.invtitle &&
          taxoffice == other.taxoffice &&
          taxnumber == other.taxnumber &&
          isprivate == other.isprivate &&
          fullname == other.fullname &&
          totalpax == other.totalpax &&
          excrate == other.excrate &&
          accid == other.accid &&
          department == other.department &&
          departmentid == other.departmentid &&
          needinvoice == other.needinvoice &&
          isactive == other.isactive &&
          paycurr == other.paycurr &&
          invoiceno == other.invoiceno &&
          taxoid == other.taxoid &&
          empid == other.empid &&
          cctypeid == other.cctypeid &&
          paycurrid == other.paycurrid &&
          discrate == other.discrate &&
          discamount == other.discamount &&
          subtotal == other.subtotal &&
          subno == other.subno &&
          prvtypeid == other.prvtypeid &&
          isclosed == other.isclosed &&
          invtransdate == other.invtransdate &&
          invtranstime == other.invtranstime &&
          invuserid == other.invuserid &&
          opendate == other.opendate &&
          closedate == other.closedate &&
          opentime == other.opentime &&
          waiter == other.waiter &&
          sliptype == other.sliptype &&
          slipno == other.slipno &&
          accno == other.accno &&
          servrate == other.servrate &&
          closetime == other.closetime &&
          foliopax == other.foliopax &&
          crcardpayment == other.crcardpayment &&
          servamount == other.servamount &&
          cashpayment == other.cashpayment &&
          boardpayment == other.boardpayment &&
          currlineno == other.currlineno &&
          postatusid == other.postatusid &&
          invaddress == other.invaddress &&
          isdropped == other.isdropped &&
          isprintedftr == other.isprintedftr &&
          isprintedhdr == other.isprintedhdr &&
          lastcourseno == other.lastcourseno &&
          tableno == other.tableno &&
          note == other.note &&
          transdate == other.transdate &&
          transno == other.transno &&
          transtime == other.transtime &&
          updatetime == other.updatetime &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      roomno.hashCode ^
      gidstr.hashCode ^
      departmentdesc.hashCode ^
      hotelname.hashCode ^
      departmentcode.hashCode ^
      acccode.hashCode ^
      accdesc.hashCode ^
      taxocode.hashCode ^
      taxodesc.hashCode ^
      departname.hashCode ^
      empname.hashCode ^
      empcode.hashCode ^
      cctypecode.hashCode ^
      cctypedesc.hashCode ^
      total.hashCode ^
      paycurrcode.hashCode ^
      paycurrdesc.hashCode ^
      currtotal.hashCode ^
      linediscamount.hashCode ^
      grosstotal.hashCode ^
      insdate.hashCode ^
      instime.hashCode ^
      vat0Amount.hashCode ^
      vat1Amount.hashCode ^
      vat8Amount.hashCode ^
      vat18Amount.hashCode ^
      prvtypecode.hashCode ^
      prvtypedesc.hashCode ^
      totaldiscamount.hashCode ^
      vat8Total.hashCode ^
      vat18Total.hashCode ^
      vat0Total.hashCode ^
      vat1Total.hashCode ^
      paymentleft.hashCode ^
      paymentotal.hashCode ^
      postatus.hashCode ^
      xreason.hashCode ^
      postatuscode.hashCode ^
      postatusdesc.hashCode ^
      reservno.hashCode ^
      foliono.hashCode ^
      invtitle.hashCode ^
      taxoffice.hashCode ^
      taxnumber.hashCode ^
      isprivate.hashCode ^
      fullname.hashCode ^
      totalpax.hashCode ^
      excrate.hashCode ^
      accid.hashCode ^
      department.hashCode ^
      departmentid.hashCode ^
      needinvoice.hashCode ^
      isactive.hashCode ^
      paycurr.hashCode ^
      invoiceno.hashCode ^
      taxoid.hashCode ^
      empid.hashCode ^
      cctypeid.hashCode ^
      paycurrid.hashCode ^
      discrate.hashCode ^
      discamount.hashCode ^
      subtotal.hashCode ^
      subno.hashCode ^
      prvtypeid.hashCode ^
      isclosed.hashCode ^
      invtransdate.hashCode ^
      invtranstime.hashCode ^
      invuserid.hashCode ^
      opendate.hashCode ^
      closedate.hashCode ^
      opentime.hashCode ^
      waiter.hashCode ^
      sliptype.hashCode ^
      slipno.hashCode ^
      accno.hashCode ^
      servrate.hashCode ^
      closetime.hashCode ^
      foliopax.hashCode ^
      crcardpayment.hashCode ^
      servamount.hashCode ^
      cashpayment.hashCode ^
      boardpayment.hashCode ^
      currlineno.hashCode ^
      postatusid.hashCode ^
      invaddress.hashCode ^
      isdropped.hashCode ^
      isprintedftr.hashCode ^
      isprintedhdr.hashCode ^
      lastcourseno.hashCode ^
      tableno.hashCode ^
      note.hashCode ^
      transdate.hashCode ^
      transno.hashCode ^
      transtime.hashCode ^
      updatetime.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Posmain{roomno: $roomno, gidstr: $gidstr, departmentdesc: $departmentdesc, hotelname: $hotelname, departmentcode: $departmentcode, acccode: $acccode, accdesc: $accdesc, taxocode: $taxocode, taxodesc: $taxodesc, departname: $departname, empname: $empname, empcode: $empcode, cctypecode: $cctypecode, cctypedesc: $cctypedesc, total: $total, paycurrcode: $paycurrcode, paycurrdesc: $paycurrdesc, currtotal: $currtotal, linediscamount: $linediscamount, grosstotal: $grosstotal, insdate: $insdate, instime: $instime, vat0Amount: $vat0Amount, vat1Amount: $vat1Amount, vat8Amount: $vat8Amount, vat18Amount: $vat18Amount, prvtypecode: $prvtypecode, prvtypedesc: $prvtypedesc, totaldiscamount: $totaldiscamount, vat8Total: $vat8Total, vat18Total: $vat18Total, vat0Total: $vat0Total, vat1Total: $vat1Total, paymentleft: $paymentleft, paymentotal: $paymentotal, postatus: $postatus, xreason: $xreason, postatuscode: $postatuscode, postatusdesc: $postatusdesc, reservno: $reservno, foliono: $foliono, invtitle: $invtitle, taxoffice: $taxoffice, taxnumber: $taxnumber, isprivate: $isprivate, fullname: $fullname, totalpax: $totalpax, excrate: $excrate, accid: $accid, department: $department, departmentid: $departmentid, needinvoice: $needinvoice, isactive: $isactive, paycurr: $paycurr, invoiceno: $invoiceno, taxoid: $taxoid, empid: $empid, cctypeid: $cctypeid, paycurrid: $paycurrid, discrate: $discrate, discamount: $discamount, subtotal: $subtotal, subno: $subno, prvtypeid: $prvtypeid, isclosed: $isclosed, invtransdate: $invtransdate, invtranstime: $invtranstime, invuserid: $invuserid, opendate: $opendate, closedate: $closedate, opentime: $opentime, waiter: $waiter, sliptype: $sliptype, slipno: $slipno, accno: $accno, servrate: $servrate, closetime: $closetime, foliopax: $foliopax, crcardpayment: $crcardpayment, servamount: $servamount, cashpayment: $cashpayment, boardpayment: $boardpayment, currlineno: $currlineno, postatusid: $postatusid, invaddress: $invaddress, isdropped: $isdropped, isprintedftr: $isprintedftr, isprintedhdr: $isprintedhdr, lastcourseno: $lastcourseno, tableno: $tableno, note: $note, transdate: $transdate, transno: $transno, transtime: $transtime, updatetime: $updatetime, jsonMap: $jsonMap}';
  }
}
