import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Agency extends BaseModelSync {
  String code;
  String description;
  String address1;
  String address2;
  String zip;
  String city;
  String country;
  String email;
  String web;
  String tel;
  String fax;
  String contact;
  String taxoffice;
  String taxnumber;
  double currdebit;
  double currcredit;
  double debit;
  double credit;
  String pricecurr;
  String paycurr;
  int rateday;
  String ratetype;
  int paytype;
  int payday;
  String nation;
  String boardtype;
  String masteracc;
  String acccontact;
  double comission;
  bool needinvoice;
  bool hasbreak;
  String note;
  bool isactive;
  int babyage;
  int chd1age;
  int chd2age;
  double invdiscount;
  String accplancode;
  double invrate;
  String tel2;
  String mobiletel;
  int stdid;
  int sourceid;
  int marketid;
  double invdiscount2;
  int agencytypeid;
  int rackcolorint;
  double extradisc;
  int resindustryid;
  int ressegmentid;
  int agencysubid;
  int langid;
  int rescountryid;
  double backdiscrate;
  String pass;
  int resdefinitid;
  bool isdef;
  bool isorsactive;
  String contactpos;
  String contactelno;
  int targetroom;
  int targetpax;
  double targetroomrev;
  double targetextrarev;
  int saleslevel;
  String town;
  String district;
  int chainid;
  int contmasterid;
  bool iseinvuser;
  String einvdate;
  String einvtype;
  int accstatusid;
  bool hascl;
  String logoname;
  bool needwarn;
  int paycurrid;
  int pricecurrid;
  int ratetypeid;
  int nationid;
  bool issub;
  String shortcode;
  double lat;
  double lng;

  //View Fields
  String ressource;
  String resmarket;
  String resindustrycode;
  String ressegmentcode;
  String resdefinitcode;
  String rescountrycode;
  String agencysubcode;
  String langcode;
  String agencytype;
  String chaincode;
  String stdagency;
  String address;
  String contmastercode;
  String accstatuscode;
  String accstatusdesc;
  bool ischain;
  String taxocode;
  String taxodesc;
  String agencytypecode;
  String marketcode;
  String nationcode;
  String paycurrcode;
  String pricecurrcode;
  String ratetypecode;
  String sourcecode;
  String stdcode;

  Map<String, dynamic> jsonMap;

  Agency(
      {this.code,
      this.description,
      this.address1,
      this.address2,
      this.zip,
      this.city,
      this.country,
      this.email,
      this.web,
      this.tel,
      this.fax,
      this.contact,
      this.taxoffice,
      this.taxnumber,
      this.currdebit,
      this.currcredit,
      this.debit,
      this.credit,
      this.pricecurr,
      this.paycurr,
      this.rateday,
      this.ratetype,
      this.paytype,
      this.payday,
      this.nation,
      this.boardtype,
      this.masteracc,
      this.acccontact,
      this.comission,
      this.needinvoice,
      this.hasbreak,
      this.note,
      this.isactive,
      this.babyage,
      this.chd1age,
      this.chd2age,
      this.invdiscount,
      this.accplancode,
      this.invrate,
      this.tel2,
      this.mobiletel,
      this.stdid,
      this.sourceid,
      this.marketid,
      this.invdiscount2,
      this.agencytypeid,
      this.rackcolorint,
      this.extradisc,
      this.resindustryid,
      this.ressegmentid,
      this.agencysubid,
      this.langid,
      this.rescountryid,
      this.backdiscrate,
      this.pass,
      this.resdefinitid,
      this.isdef,
      this.isorsactive,
      this.contactpos,
      this.contactelno,
      this.targetroom,
      this.targetpax,
      this.targetroomrev,
      this.targetextrarev,
      this.saleslevel,
      this.town,
      this.district,
      this.chainid,
      this.contmasterid,
      this.iseinvuser,
      this.einvdate,
      this.einvtype,
      this.accstatusid,
      this.hascl,
      this.logoname,
      this.needwarn,
      this.paycurrid,
      this.pricecurrid,
      this.ratetypeid,
      this.nationid,
      this.issub,
      this.shortcode,
      this.lat,
      this.lng,
      this.ressource,
      this.resmarket,
      this.resindustrycode,
      this.ressegmentcode,
      this.resdefinitcode,
      this.rescountrycode,
      this.agencysubcode,
      this.langcode,
      this.agencytype,
      this.chaincode,
      this.stdagency,
      this.address,
      this.contmastercode,
      this.accstatuscode,
      this.accstatusdesc,
      this.ischain,
      this.taxocode,
      this.taxodesc,
      this.agencytypecode,
      this.marketcode,
      this.nationcode,
      this.paycurrcode,
      this.pricecurrcode,
      this.ratetypecode,
      this.sourcecode,
      this.stdcode,
      this.jsonMap})
      : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Agency.fromJson(Map<String, dynamic> json) {
    return Agency(
      code: json[DBConst.FDN_CODE],
      description: json[DBConst.FDN_DESCRIPTION],
      address1: json[DBConst.FDN_ADDRESS1],
      address2: json[DBConst.FDN_ADDRESS2],
      zip: json[DBConst.FDN_ZIP],
      city: json[DBConst.FDN_CITY],
      country: json[DBConst.FDN_COUNTRY],
      email: json[DBConst.FDN_EMAIL],
      web: json[DBConst.FDN_WEB],
      tel: json[DBConst.FDN_TEL],
      fax: json[DBConst.FDN_FAX],
      contact: json[DBConst.FDN_CONTACT],
      taxoffice: json[DBConst.FDN_TAXOFFICE],
      taxnumber: json[DBConst.FDN_TAXNUMBER],
      currdebit: json[DBConst.FDN_CURRDEBIT],
      currcredit: json[DBConst.FDN_CURRCREDIT],
      debit: json[DBConst.FDN_DEBIT],
      credit: json[DBConst.FDN_CREDIT],
      pricecurr: json[DBConst.FDN_PRICECURR],
      paycurr: json[DBConst.FDN_PAYCURR],
      rateday: json[DBConst.FDN_RATEDAY],
      ratetype: json[DBConst.FDN_RATETYPE],
      paytype: json[DBConst.FDN_PAYTYPE],
      payday: json[DBConst.FDN_PAYDAY],
      nation: json[DBConst.FDN_NATION],
      boardtype: json[DBConst.FDN_BOARDTYPE],
      masteracc: json[DBConst.FDN_MASTERACC],
      acccontact: json[DBConst.FDN_ACCCONTACT],
      comission: json[DBConst.FDN_COMISSION],
      needinvoice: json[DBConst.FDN_NEEDINVOICE],
      hasbreak: json[DBConst.FDN_HASBREAK],
      note: json[DBConst.FDN_NOTE],
      isactive: json[DBConst.FDN_ISACTIVE],
      babyage: json[DBConst.FDN_BABYAGE],
      chd1age: json[DBConst.FDN_CHD1AGE],
      chd2age: json[DBConst.FDN_CHD2AGE],
      invdiscount: json[DBConst.FDN_INVDISCOUNT],
      accplancode: json[DBConst.FDN_ACCPLANCODE],
      invrate: json[DBConst.FDN_INVRATE],
      tel2: json[DBConst.FDN_TEL2],
      mobiletel: json[DBConst.FDN_MOBILETEL],
      stdid: json[DBConst.FDN_STDID],
      sourceid: json[DBConst.FDN_SOURCEID],
      marketid: json[DBConst.FDN_MARKETID],
      invdiscount2: json[DBConst.FDN_INVDISCOUNT2],
      agencytypeid: json[DBConst.FDN_AGENCYTYPEID],
      rackcolorint: json[DBConst.FDN_RACKCOLORINT],
      extradisc: json[DBConst.FDN_EXTRADISC],
      resindustryid: json[DBConst.FDN_RESINDUSTRYID],
      ressegmentid: json[DBConst.FDN_RESSEGMENTID],
      agencysubid: json[DBConst.FDN_AGENCYSUBID],
      langid: json[DBConst.FDN_LANGID],
      rescountryid: json[DBConst.FDN_RESCOUNTRYID],
      backdiscrate: json[DBConst.FDN_BACKDISCRATE],
      pass: json[DBConst.FDN_PASS],
      resdefinitid: json[DBConst.FDN_RESDEFINITID],
      isdef: json[DBConst.FDN_ISDEF],
      isorsactive: json[DBConst.FDN_ISORSACTIVE],
      contactpos: json[DBConst.FDN_CONTACTPOS],
      contactelno: json[DBConst.FDN_CONTACTELNO],
      targetroom: json[DBConst.FDN_TARGETROOM],
      targetpax: json[DBConst.FDN_TARGETPAX],
      targetroomrev: json[DBConst.FDN_TARGETROOMREV],
      targetextrarev: json[DBConst.FDN_TARGETEXTRAREV],
      saleslevel: json[DBConst.FDN_SALESLEVEL],
      town: json[DBConst.FDN_TOWN],
      district: json[DBConst.FDN_DISTRICT],
      chainid: json[DBConst.FDN_CHAINID],
      contmasterid: json[DBConst.FDN_CONTMASTERID],
      iseinvuser: json[DBConst.FDN_ISEINVUSER],
      einvdate: json[DBConst.FDN_EINVDATE],
      einvtype: json[DBConst.FDN_EINVTYPE],
      accstatusid: json[DBConst.FDN_ACCSTATUSID],
      hascl: json[DBConst.FDN_HASCL],
      logoname: json[DBConst.FDN_LOGONAME],
      needwarn: json[DBConst.FDN_NEEDWARN],
      paycurrid: json[DBConst.FDN_PAYCURRID],
      pricecurrid: json[DBConst.FDN_PRICECURRID],
      ratetypeid: json[DBConst.FDN_RATETYPEID],
      nationid: json[DBConst.FDN_NATIONID],
      issub: json[DBConst.FDN_ISSUB],
      shortcode: json[DBConst.FDN_SHORTCODE],
      lat: json[DBConst.FDN_LAT],
      lng: json[DBConst.FDN_LNG],
      ressource: json[DBConst.FDN_RESSOURCE],
      resmarket: json[DBConst.FDN_RESMARKET],
      resindustrycode: json[DBConst.FDN_RESINDUSTRYCODE],
      ressegmentcode: json[DBConst.FDN_RESSEGMENTCODE],
      resdefinitcode: json[DBConst.FDN_RESDEFINITCODE],
      rescountrycode: json[DBConst.FDN_RESCOUNTRYCODE],
      agencysubcode: json[DBConst.FDN_AGENCYSUBCODE],
      langcode: json[DBConst.FDN_LANGCODE],
      agencytype: json[DBConst.FDN_AGENCYTYPE],
      chaincode: json[DBConst.FDN_CHAINCODE],
      stdagency: json[DBConst.FDN_STDAGENCY],
      address: json[DBConst.FDN_ADDRESS],
      contmastercode: json[DBConst.FDN_CONTMASTERCODE],
      accstatuscode: json[DBConst.FDN_ACCSTATUSCODE],
      accstatusdesc: json[DBConst.FDN_ACCSTATUSDESC],
      ischain: json[DBConst.FDN_ISCHAIN],
      taxocode: json[DBConst.FDN_TAXOCODE],
      taxodesc: json[DBConst.FDN_TAXODESC],
      agencytypecode: json[DBConst.FDN_AGENCYTYPECODE],
      marketcode: json[DBConst.FDN_MARKETCODE],
      nationcode: json[DBConst.FDN_NATIONCODE],
      paycurrcode: json[DBConst.FDN_PAYCURRCODE],
      pricecurrcode: json[DBConst.FDN_PRICECURRCODE],
      ratetypecode: json[DBConst.FDN_RATETYPECODE],
      sourcecode: json[DBConst.FDN_SOURCECODE],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_CODE: code,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_ADDRESS1: address1,
      DBConst.FDN_ADDRESS2: address2,
      DBConst.FDN_ZIP: zip,
      DBConst.FDN_CITY: city,
      DBConst.FDN_COUNTRY: country,
      DBConst.FDN_EMAIL: email,
      DBConst.FDN_WEB: web,
      DBConst.FDN_TEL: tel,
      DBConst.FDN_FAX: fax,
      DBConst.FDN_CONTACT: contact,
      DBConst.FDN_TAXOFFICE: taxoffice,
      DBConst.FDN_TAXNUMBER: taxnumber,
      DBConst.FDN_CURRDEBIT: currdebit,
      DBConst.FDN_CURRCREDIT: currcredit,
      DBConst.FDN_DEBIT: debit,
      DBConst.FDN_CREDIT: credit,
      DBConst.FDN_PRICECURR: pricecurr,
      DBConst.FDN_PAYCURR: paycurr,
      DBConst.FDN_RATEDAY: rateday,
      DBConst.FDN_RATETYPE: ratetype,
      DBConst.FDN_PAYTYPE: paytype,
      DBConst.FDN_PAYDAY: payday,
      DBConst.FDN_NATION: nation,
      DBConst.FDN_BOARDTYPE: boardtype,
      DBConst.FDN_MASTERACC: masteracc,
      DBConst.FDN_ACCCONTACT: acccontact,
      DBConst.FDN_COMISSION: comission,
      DBConst.FDN_NEEDINVOICE: needinvoice,
      DBConst.FDN_HASBREAK: hasbreak,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_BABYAGE: babyage,
      DBConst.FDN_CHD1AGE: chd1age,
      DBConst.FDN_CHD2AGE: chd2age,
      DBConst.FDN_INVDISCOUNT: invdiscount,
      DBConst.FDN_ACCPLANCODE: accplancode,
      DBConst.FDN_INVRATE: invrate,
      DBConst.FDN_TEL2: tel2,
      DBConst.FDN_MOBILETEL: mobiletel,
      DBConst.FDN_STDID: stdid,
      DBConst.FDN_SOURCEID: sourceid,
      DBConst.FDN_MARKETID: marketid,
      DBConst.FDN_INVDISCOUNT2: invdiscount2,
      DBConst.FDN_AGENCYTYPEID: agencytypeid,
      DBConst.FDN_RACKCOLORINT: rackcolorint,
      DBConst.FDN_EXTRADISC: extradisc,
      DBConst.FDN_RESINDUSTRYID: resindustryid,
      DBConst.FDN_RESSEGMENTID: ressegmentid,
      DBConst.FDN_AGENCYSUBID: agencysubid,
      DBConst.FDN_LANGID: langid,
      DBConst.FDN_RESCOUNTRYID: rescountryid,
      DBConst.FDN_BACKDISCRATE: backdiscrate,
      DBConst.FDN_PASS: pass,
      DBConst.FDN_RESDEFINITID: resdefinitid,
      DBConst.FDN_ISDEF: isdef,
      DBConst.FDN_ISORSACTIVE: isorsactive,
      DBConst.FDN_CONTACTPOS: contactpos,
      DBConst.FDN_CONTACTELNO: contactelno,
      DBConst.FDN_TARGETROOM: targetroom,
      DBConst.FDN_TARGETPAX: targetpax,
      DBConst.FDN_TARGETROOMREV: targetroomrev,
      DBConst.FDN_TARGETEXTRAREV: targetextrarev,
      DBConst.FDN_SALESLEVEL: saleslevel,
      DBConst.FDN_TOWN: town,
      DBConst.FDN_DISTRICT: district,
      DBConst.FDN_CHAINID: chainid,
      DBConst.FDN_CONTMASTERID: contmasterid,
      DBConst.FDN_ISEINVUSER: iseinvuser,
      DBConst.FDN_EINVDATE: einvdate,
      DBConst.FDN_EINVTYPE: einvtype,
      DBConst.FDN_ACCSTATUSID: accstatusid,
      DBConst.FDN_HASCL: hascl,
      DBConst.FDN_LOGONAME: logoname,
      DBConst.FDN_NEEDWARN: needwarn,
      DBConst.FDN_PAYCURRID: paycurrid,
      DBConst.FDN_PRICECURRID: pricecurrid,
      DBConst.FDN_RATETYPEID: ratetypeid,
      DBConst.FDN_NATIONID: nationid,
      DBConst.FDN_ISSUB: issub,
      DBConst.FDN_SHORTCODE: shortcode,
      DBConst.FDN_LAT: lat,
      DBConst.FDN_LNG: lng,
      DBConst.FDN_RESSOURCE: ressource,
      DBConst.FDN_RESMARKET: resmarket,
      DBConst.FDN_RESINDUSTRYCODE: resindustrycode,
      DBConst.FDN_RESSEGMENTCODE: ressegmentcode,
      DBConst.FDN_RESDEFINITCODE: resdefinitcode,
      DBConst.FDN_RESCOUNTRYCODE: rescountrycode,
      DBConst.FDN_AGENCYSUBCODE: agencysubcode,
      DBConst.FDN_LANGCODE: langcode,
      DBConst.FDN_AGENCYTYPE: agencytype,
      DBConst.FDN_CHAINCODE: chaincode,
      DBConst.FDN_STDAGENCY: stdagency,
      DBConst.FDN_ADDRESS: address,
      DBConst.FDN_CONTMASTERCODE: contmastercode,
      DBConst.FDN_ACCSTATUSCODE: accstatuscode,
      DBConst.FDN_ACCSTATUSDESC: accstatusdesc,
      DBConst.FDN_ISCHAIN: ischain,
      DBConst.FDN_TAXOCODE: taxocode,
      DBConst.FDN_TAXODESC: taxodesc,
      DBConst.FDN_AGENCYTYPECODE: agencytypecode,
      DBConst.FDN_MARKETCODE: marketcode,
      DBConst.FDN_NATIONCODE: nationcode,
      DBConst.FDN_PAYCURRCODE: paycurrcode,
      DBConst.FDN_PRICECURRCODE: pricecurrcode,
      DBConst.FDN_RATETYPECODE: ratetypecode,
      DBConst.FDN_SOURCECODE: sourcecode,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Agency &&
          runtimeType == other.runtimeType &&
          code == other.code &&
          description == other.description &&
          address1 == other.address1 &&
          address2 == other.address2 &&
          zip == other.zip &&
          city == other.city &&
          country == other.country &&
          email == other.email &&
          web == other.web &&
          tel == other.tel &&
          fax == other.fax &&
          contact == other.contact &&
          taxoffice == other.taxoffice &&
          taxnumber == other.taxnumber &&
          currdebit == other.currdebit &&
          currcredit == other.currcredit &&
          debit == other.debit &&
          credit == other.credit &&
          pricecurr == other.pricecurr &&
          paycurr == other.paycurr &&
          rateday == other.rateday &&
          ratetype == other.ratetype &&
          paytype == other.paytype &&
          payday == other.payday &&
          nation == other.nation &&
          boardtype == other.boardtype &&
          masteracc == other.masteracc &&
          acccontact == other.acccontact &&
          comission == other.comission &&
          needinvoice == other.needinvoice &&
          hasbreak == other.hasbreak &&
          note == other.note &&
          isactive == other.isactive &&
          babyage == other.babyage &&
          chd1age == other.chd1age &&
          chd2age == other.chd2age &&
          invdiscount == other.invdiscount &&
          accplancode == other.accplancode &&
          invrate == other.invrate &&
          tel2 == other.tel2 &&
          mobiletel == other.mobiletel &&
          stdid == other.stdid &&
          sourceid == other.sourceid &&
          marketid == other.marketid &&
          invdiscount2 == other.invdiscount2 &&
          agencytypeid == other.agencytypeid &&
          rackcolorint == other.rackcolorint &&
          extradisc == other.extradisc &&
          resindustryid == other.resindustryid &&
          ressegmentid == other.ressegmentid &&
          agencysubid == other.agencysubid &&
          langid == other.langid &&
          rescountryid == other.rescountryid &&
          backdiscrate == other.backdiscrate &&
          pass == other.pass &&
          resdefinitid == other.resdefinitid &&
          isdef == other.isdef &&
          isorsactive == other.isorsactive &&
          contactpos == other.contactpos &&
          contactelno == other.contactelno &&
          targetroom == other.targetroom &&
          targetpax == other.targetpax &&
          targetroomrev == other.targetroomrev &&
          targetextrarev == other.targetextrarev &&
          saleslevel == other.saleslevel &&
          town == other.town &&
          district == other.district &&
          chainid == other.chainid &&
          contmasterid == other.contmasterid &&
          iseinvuser == other.iseinvuser &&
          einvdate == other.einvdate &&
          einvtype == other.einvtype &&
          accstatusid == other.accstatusid &&
          hascl == other.hascl &&
          logoname == other.logoname &&
          needwarn == other.needwarn &&
          paycurrid == other.paycurrid &&
          pricecurrid == other.pricecurrid &&
          ratetypeid == other.ratetypeid &&
          nationid == other.nationid &&
          issub == other.issub &&
          shortcode == other.shortcode &&
          lat == other.lat &&
          lng == other.lng &&
          ressource == other.ressource &&
          resmarket == other.resmarket &&
          resindustrycode == other.resindustrycode &&
          ressegmentcode == other.ressegmentcode &&
          resdefinitcode == other.resdefinitcode &&
          rescountrycode == other.rescountrycode &&
          agencysubcode == other.agencysubcode &&
          langcode == other.langcode &&
          agencytype == other.agencytype &&
          chaincode == other.chaincode &&
          stdagency == other.stdagency &&
          address == other.address &&
          contmastercode == other.contmastercode &&
          accstatuscode == other.accstatuscode &&
          accstatusdesc == other.accstatusdesc &&
          ischain == other.ischain &&
          taxocode == other.taxocode &&
          taxodesc == other.taxodesc &&
          agencytypecode == other.agencytypecode &&
          marketcode == other.marketcode &&
          nationcode == other.nationcode &&
          paycurrcode == other.paycurrcode &&
          pricecurrcode == other.pricecurrcode &&
          ratetypecode == other.ratetypecode &&
          sourcecode == other.sourcecode &&
          stdcode == other.stdcode &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      code.hashCode ^
      description.hashCode ^
      address1.hashCode ^
      address2.hashCode ^
      zip.hashCode ^
      city.hashCode ^
      country.hashCode ^
      email.hashCode ^
      web.hashCode ^
      tel.hashCode ^
      fax.hashCode ^
      contact.hashCode ^
      taxoffice.hashCode ^
      taxnumber.hashCode ^
      currdebit.hashCode ^
      currcredit.hashCode ^
      debit.hashCode ^
      credit.hashCode ^
      pricecurr.hashCode ^
      paycurr.hashCode ^
      rateday.hashCode ^
      ratetype.hashCode ^
      paytype.hashCode ^
      payday.hashCode ^
      nation.hashCode ^
      boardtype.hashCode ^
      masteracc.hashCode ^
      acccontact.hashCode ^
      comission.hashCode ^
      needinvoice.hashCode ^
      hasbreak.hashCode ^
      note.hashCode ^
      isactive.hashCode ^
      babyage.hashCode ^
      chd1age.hashCode ^
      chd2age.hashCode ^
      invdiscount.hashCode ^
      accplancode.hashCode ^
      invrate.hashCode ^
      tel2.hashCode ^
      mobiletel.hashCode ^
      stdid.hashCode ^
      sourceid.hashCode ^
      marketid.hashCode ^
      invdiscount2.hashCode ^
      agencytypeid.hashCode ^
      rackcolorint.hashCode ^
      extradisc.hashCode ^
      resindustryid.hashCode ^
      ressegmentid.hashCode ^
      agencysubid.hashCode ^
      langid.hashCode ^
      rescountryid.hashCode ^
      backdiscrate.hashCode ^
      pass.hashCode ^
      resdefinitid.hashCode ^
      isdef.hashCode ^
      isorsactive.hashCode ^
      contactpos.hashCode ^
      contactelno.hashCode ^
      targetroom.hashCode ^
      targetpax.hashCode ^
      targetroomrev.hashCode ^
      targetextrarev.hashCode ^
      saleslevel.hashCode ^
      town.hashCode ^
      district.hashCode ^
      chainid.hashCode ^
      contmasterid.hashCode ^
      iseinvuser.hashCode ^
      einvdate.hashCode ^
      einvtype.hashCode ^
      accstatusid.hashCode ^
      hascl.hashCode ^
      logoname.hashCode ^
      needwarn.hashCode ^
      paycurrid.hashCode ^
      pricecurrid.hashCode ^
      ratetypeid.hashCode ^
      nationid.hashCode ^
      issub.hashCode ^
      shortcode.hashCode ^
      lat.hashCode ^
      lng.hashCode ^
      ressource.hashCode ^
      resmarket.hashCode ^
      resindustrycode.hashCode ^
      ressegmentcode.hashCode ^
      resdefinitcode.hashCode ^
      rescountrycode.hashCode ^
      agencysubcode.hashCode ^
      langcode.hashCode ^
      agencytype.hashCode ^
      chaincode.hashCode ^
      stdagency.hashCode ^
      address.hashCode ^
      contmastercode.hashCode ^
      accstatuscode.hashCode ^
      accstatusdesc.hashCode ^
      ischain.hashCode ^
      taxocode.hashCode ^
      taxodesc.hashCode ^
      agencytypecode.hashCode ^
      marketcode.hashCode ^
      nationcode.hashCode ^
      paycurrcode.hashCode ^
      pricecurrcode.hashCode ^
      ratetypecode.hashCode ^
      sourcecode.hashCode ^
      stdcode.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Agency{${super.toString()}, code: $code, description: $description, address1: $address1, address2: $address2, zip: $zip, city: $city, country: $country, email: $email, web: $web, tel: $tel, fax: $fax, contact: $contact, taxoffice: $taxoffice, taxnumber: $taxnumber, currdebit: $currdebit, currcredit: $currcredit, debit: $debit, credit: $credit, pricecurr: $pricecurr, paycurr: $paycurr, rateday: $rateday, ratetype: $ratetype, paytype: $paytype, payday: $payday, nation: $nation, boardtype: $boardtype, masteracc: $masteracc, acccontact: $acccontact, comission: $comission, needinvoice: $needinvoice, hasbreak: $hasbreak, note: $note, isactive: $isactive, babyage: $babyage, chd1age: $chd1age, chd2age: $chd2age, invdiscount: $invdiscount, accplancode: $accplancode, invrate: $invrate, tel2: $tel2, mobiletel: $mobiletel, stdid: $stdid, sourceid: $sourceid, marketid: $marketid, invdiscount2: $invdiscount2, agencytypeid: $agencytypeid, rackcolorint: $rackcolorint, extradisc: $extradisc, resindustryid: $resindustryid, ressegmentid: $ressegmentid, agencysubid: $agencysubid, langid: $langid, rescountryid: $rescountryid, backdiscrate: $backdiscrate, pass: $pass, resdefinitid: $resdefinitid, isdef: $isdef, isorsactive: $isorsactive, contactpos: $contactpos, contactelno: $contactelno, targetroom: $targetroom, targetpax: $targetpax, targetroomrev: $targetroomrev, targetextrarev: $targetextrarev, saleslevel: $saleslevel, town: $town, district: $district, chainid: $chainid, contmasterid: $contmasterid, iseinvuser: $iseinvuser, einvdate: $einvdate, einvtype: $einvtype, accstatusid: $accstatusid, hascl: $hascl, logoname: $logoname, needwarn: $needwarn, paycurrid: $paycurrid, pricecurrid: $pricecurrid, ratetypeid: $ratetypeid, nationid: $nationid, issub: $issub, shortcode: $shortcode, lat: $lat, lng: $lng, ressource: $ressource, resmarket: $resmarket, resindustrycode: $resindustrycode, ressegmentcode: $ressegmentcode, resdefinitcode: $resdefinitcode, rescountrycode: $rescountrycode, agencysubcode: $agencysubcode, langcode: $langcode, agencytype: $agencytype, chaincode: $chaincode, stdagency: $stdagency, address: $address, contmastercode: $contmastercode, accstatuscode: $accstatuscode, accstatusdesc: $accstatusdesc, ischain: $ischain, taxocode: $taxocode, taxodesc: $taxodesc, agencytypecode: $agencytypecode, marketcode: $marketcode, nationcode: $nationcode, paycurrcode: $paycurrcode, pricecurrcode: $pricecurrcode, ratetypecode: $ratetypecode, sourcecode: $sourcecode, stdcode: $stdcode, jsonMap: $jsonMap}';
  }
}
