import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Rafile extends BaseModelCode {
  String caption;
  String checkedUrl;
  String code;
  String description;
  String filedata;
  String filename;
  String filenameupper;
  String filetype;
  String filever;
  int folderid;
  String gid;
  int hotelrefno;
  int id;
  String insdatetime;
  bool isactive;
  bool isarchive;
  bool isorsactive;
  bool isstd;
  bool issys;
  bool istemplate;
  String keywords;
  int langid;
  int masterid;
  int mid;
  int parentid;
  bool raxlsextmenu;
  String refcode;
  int reffileid;
  int refid;
  String shortcode;
  bool showramobile;
  String templatefile;
  String tpltablename;
  String updatedate;
  String updatetime;
  int updtl;
  int ver;
  String xcode;
  String codestr;
  String gidstr;
  String hotelname;
  String langcode;
  String langdesc;
  String longdesc;

  Map<String, dynamic> jsonMap;

  Rafile({
    this.caption,
    this.checkedUrl,
    this.code,
    this.description,
    this.filedata,
    this.filename,
    this.filenameupper,
    this.filetype,
    this.filever,
    this.folderid,
    this.gid,
    this.hotelrefno,
    this.id,
    this.insdatetime,
    this.isactive,
    this.isarchive,
    this.isorsactive,
    this.isstd,
    this.issys,
    this.istemplate,
    this.keywords,
    this.langid,
    this.masterid,
    this.mid,
    this.parentid,
    this.raxlsextmenu,
    this.refcode,
    this.reffileid,
    this.refid,
    this.shortcode,
    this.showramobile,
    this.templatefile,
    this.tpltablename,
    this.updatedate,
    this.updatetime,
    this.updtl,
    this.ver,
    this.xcode,
    this.codestr,
    this.gidstr,
    this.hotelname,
    this.langcode,
    this.langdesc,
    this.longdesc,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Rafile.fromJson(Map<String, dynamic> json) {
    return Rafile(
      caption: json[DBConst.FDN_CAPTION],
      checkedUrl: json[DBConst.FDN_CHECKEDURL],
      filedata: json[DBConst.FDN_FILEDATA],
      filename: json[DBConst.FDN_FILENAME],
      filenameupper: json[DBConst.FDN_FILENAMEUPPER],
      filetype: json[DBConst.FDN_FILETYPE],
      filever: json[DBConst.FDN_FILEVER],
      folderid: json[DBConst.FDN_FOLDERID],
      gid: json[DBConst.FDN_GID],
      hotelrefno: json[DBConst.FDN_HOTELREFNO],
      id: json[DBConst.FDN_ID],
      insdatetime: json[DBConst.FDN_INSDATETIME],
      isactive: json[DBConst.FDN_ISACTIVE],
      isarchive: json[DBConst.FDN_ISARCHIVE],
      isorsactive: json[DBConst.FDN_ISORSACTIVE],
      isstd: json[DBConst.FDN_ISSTD],
      issys: json[DBConst.FDN_ISSYS],
      istemplate: json[DBConst.FDN_ISTEMPLATE],
      keywords: json[DBConst.FDN_KEYWORDS],
      langid: json[DBConst.FDN_LANGID],
      masterid: json[DBConst.FDN_MASTERID],
      mid: json[DBConst.FDN_MID],
      parentid: json[DBConst.FDN_PARENTID],
      raxlsextmenu: json[DBConst.FDN_RAXLSEXTMENU],
      refcode: json[DBConst.FDN_REFCODE],
      reffileid: json[DBConst.FDN_REFFILEID],
      refid: json[DBConst.FDN_REFID],
      showramobile: json[DBConst.FDN_SHOWRAMOBILE],
      templatefile: json[DBConst.FDN_TEMPLATEFILE],
      tpltablename: json[DBConst.FDN_TPLTABLENAME],
      updatedate: json[DBConst.FDN_UPDATEDATE],
      updatetime: json[DBConst.FDN_UPDATETIME],
      updtl: json[DBConst.FDN_UPDTL],
      ver: json[DBConst.FDN_VER],
      xcode: json[DBConst.FDN_XCODE],
      codestr: json[DBConst.FDN_CODESTR],
      gidstr: json[DBConst.FDN_GIDSTR],
      hotelname: json[DBConst.FDN_HOTELNAME],
      langcode: json[DBConst.FDN_LANGCODE],
      langdesc: json[DBConst.FDN_LANGDESC],
      longdesc: json[DBConst.FDN_LONGDESC],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_CAPTION: caption,
      DBConst.FDN_CHECKEDURL: checkedUrl,
      DBConst.FDN_FILEDATA: filedata,
      DBConst.FDN_FILENAME: filename,
      DBConst.FDN_FILENAMEUPPER: filenameupper,
      DBConst.FDN_FILETYPE: filetype,
      DBConst.FDN_FILEVER: filever,
      DBConst.FDN_FOLDERID: folderid,
      DBConst.FDN_GID: gid,
      DBConst.FDN_HOTELREFNO: hotelrefno,
      DBConst.FDN_ID: id,
      DBConst.FDN_INSDATETIME: insdatetime,
      DBConst.FDN_ISARCHIVE: isarchive,
      DBConst.FDN_ISORSACTIVE: isorsactive,
      DBConst.FDN_ISSTD: isstd,
      DBConst.FDN_ISSYS: issys,
      DBConst.FDN_ISTEMPLATE: istemplate,
      DBConst.FDN_KEYWORDS: keywords,
      DBConst.FDN_LANGID: langid,
      DBConst.FDN_MASTERID: masterid,
      DBConst.FDN_MID: mid,
      DBConst.FDN_PARENTID: parentid,
      DBConst.FDN_RAXLSEXTMENU: raxlsextmenu,
      DBConst.FDN_REFCODE: refcode,
      DBConst.FDN_REFFILEID: reffileid,
      DBConst.FDN_REFID: refid,
      DBConst.FDN_SHOWRAMOBILE: showramobile,
      DBConst.FDN_TEMPLATEFILE: templatefile,
      DBConst.FDN_TPLTABLENAME: tpltablename,
      DBConst.FDN_UPDATEDATE: updatedate,
      DBConst.FDN_UPDATETIME: updatetime,
      DBConst.FDN_UPDTL: updtl,
      DBConst.FDN_VER: ver,
      DBConst.FDN_XCODE: xcode,
      DBConst.FDN_CODESTR: codestr,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_LANGCODE: langcode,
      DBConst.FDN_LANGDESC: langdesc,
      DBConst.FDN_LONGDESC: longdesc,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Rafile &&
          runtimeType == other.runtimeType &&
          caption == other.caption &&
          checkedUrl == other.checkedUrl &&
          code == other.code &&
          description == other.description &&
          filedata == other.filedata &&
          filename == other.filename &&
          filenameupper == other.filenameupper &&
          filetype == other.filetype &&
          filever == other.filever &&
          folderid == other.folderid &&
          gid == other.gid &&
          hotelrefno == other.hotelrefno &&
          id == other.id &&
          insdatetime == other.insdatetime &&
          isactive == other.isactive &&
          isarchive == other.isarchive &&
          isorsactive == other.isorsactive &&
          isstd == other.isstd &&
          issys == other.issys &&
          istemplate == other.istemplate &&
          keywords == other.keywords &&
          langid == other.langid &&
          masterid == other.masterid &&
          mid == other.mid &&
          parentid == other.parentid &&
          raxlsextmenu == other.raxlsextmenu &&
          refcode == other.refcode &&
          reffileid == other.reffileid &&
          refid == other.refid &&
          shortcode == other.shortcode &&
          showramobile == other.showramobile &&
          templatefile == other.templatefile &&
          tpltablename == other.tpltablename &&
          updatedate == other.updatedate &&
          updatetime == other.updatetime &&
          updtl == other.updtl &&
          ver == other.ver &&
          xcode == other.xcode &&
          codestr == other.codestr &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          langcode == other.langcode &&
          langdesc == other.langdesc &&
          longdesc == other.longdesc &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      caption.hashCode ^
      checkedUrl.hashCode ^
      code.hashCode ^
      description.hashCode ^
      filedata.hashCode ^
      filename.hashCode ^
      filenameupper.hashCode ^
      filetype.hashCode ^
      filever.hashCode ^
      folderid.hashCode ^
      gid.hashCode ^
      hotelrefno.hashCode ^
      id.hashCode ^
      insdatetime.hashCode ^
      isactive.hashCode ^
      isarchive.hashCode ^
      isorsactive.hashCode ^
      isstd.hashCode ^
      issys.hashCode ^
      istemplate.hashCode ^
      keywords.hashCode ^
      langid.hashCode ^
      masterid.hashCode ^
      mid.hashCode ^
      parentid.hashCode ^
      raxlsextmenu.hashCode ^
      refcode.hashCode ^
      reffileid.hashCode ^
      refid.hashCode ^
      shortcode.hashCode ^
      showramobile.hashCode ^
      templatefile.hashCode ^
      tpltablename.hashCode ^
      updatedate.hashCode ^
      updatetime.hashCode ^
      updtl.hashCode ^
      ver.hashCode ^
      xcode.hashCode ^
      codestr.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      langcode.hashCode ^
      langdesc.hashCode ^
      longdesc.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Rafile{${super.toString()}, caption: $caption, checkedUrl: $checkedUrl, code: $code, description: $description, filedata: $filedata, filename: $filename, filenameupper: $filenameupper, filetype: $filetype, filever: $filever, folderid: $folderid, gid: $gid, hotelrefno: $hotelrefno, id: $id, insdatetime: $insdatetime, isactive: $isactive, isarchive: $isarchive, isorsactive: $isorsactive, isstd: $isstd, issys: $issys, istemplate: $istemplate, keywords: $keywords, langid: $langid, masterid: $masterid, mid: $mid, parentid: $parentid, raxlsextmenu: $raxlsextmenu, refcode: $refcode, reffileid: $reffileid, refid: $refid, shortcode: $shortcode, showramobile: $showramobile, templatefile: $templatefile, tpltablename: $tpltablename, updatedate: $updatedate, updatetime: $updatetime, updtl: $updtl, ver: $ver, xcode: $xcode, codestr: $codestr, gidstr: $gidstr, hotelname: $hotelname, langcode: $langcode, langdesc: $langdesc, longdesc: $longdesc, jsonMap: $jsonMap}';
  }
}
