import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsSlider.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class CmsSliderService extends ServiceFactory<CmsSlider> {
  static CmsSliderService instance;

  static CmsSliderService getInstance() {
    return instance != null ? instance : CmsSliderService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_CMSSLIDER;
  }
}
