import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/sysdefs/Currency.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class CurrencyService extends ServiceFactory<Currency> {
  static CurrencyService instance;

  static CurrencyService getInstance() {
    return instance != null ? instance : CurrencyService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_CURRENCY;
  }
}
