import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/sysdefs/Depart.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class DepartService extends ServiceFactory<Depart> {
  static DepartService instance;

  static DepartService getInstance() {
    return instance != null ? instance : DepartService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_DEPART;
  }
}
