import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/tools/Geoloc.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class GeolocService extends ServiceFactory<Geoloc> {
  static GeolocService instance;

  static GeolocService getInstance() {
    return instance != null ? instance : GeolocService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_GEOLOC;
  }
}
