import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

///
///Defines the data found in the Memcard table in the service
///

class Memcard extends BaseModelSync {
  int reservno;
  int roomno;
  int agencyid;
  String checkin;
  String checkout;
  double nextbonusreq;
  double nextbonustotal;
  int nextcardtypeid;
  String nextcardtypecode;
  String nextcardtypedesc;
  double clientbonustotal;
  double totalprice;
  String pricecurr;
  String empname;
  String empcode;
  String resrefcode;
  int reshotelrefno;
  String currcode;
  String currdesc;
  int clientage;
  String agencycode;
  int resrefid;
  String resmarketcode;
  double cardtypebonusmin;
  String prevcardtypecode;
  String reshotelname;
  String empdepartdesc;
  int empdepartid;
  String empdepartcode;
  String empposlvlcode;
  String empposdesc;
  int empposid;
  String empposcode;
  int empposlvlid;
  String groupname;
  String country;
  String email;
  String town;
  String tel;
  String city;
  String firstname;
  String lastname;
  String nation;
  String mobiletel;
  String birthdate;
  String gender;
  int langid;
  String gidstr;
  String hotelname;
  String acccode;
  String accdesc;
  String district;
  String tel2;
  String cardtypecode;
  String langcode;
  String langdesc;
  String cardtypedesc;
  String tridno;
  String genderdesc;
  String maritalstatus;
  String maritalstatusdesc;
  String lastci;
  String lastco;
  int totalvisit;
  int totalstay;
  double totalroomrate;
  double totalextra;
  double totalrevenue;
  String lastroom;
  double lastroomrate;
  String birthplace;
  String idtype;
  String idno;
  String nationdesc;
  bool cardtypeisext;
  bool cardtypeisstd;
  String countrydesc;
  int clientrefid;
  String clientrefcode;
  int clientmid;
  int clienthotelrefno;
  String clienthotelname;
  int masterid;
  String enddate;
  int accid;
  bool isactive;
  String startdate;
  int empid;
  String expiredate;
  int cardtypeid;
  int currid;
  bool isdelivered;
  String reqdate;
  String cardno;
  String note;

  Map<String, dynamic> jsonMap;

  Memcard({
    this.reservno,
    this.roomno,
    this.agencyid,
    this.checkin,
    this.checkout,
    this.totalprice,
    this.pricecurr,
    this.empname,
    this.empcode,
    this.resrefcode,
    this.reshotelrefno,
    this.currcode,
    this.currdesc,
    this.clientage,
    this.agencycode,
    this.resrefid,
    this.resmarketcode,
    this.cardtypebonusmin,
    this.prevcardtypecode,
    this.reshotelname,
    this.empdepartdesc,
    this.empdepartid,
    this.empdepartcode,
    this.empposlvlcode,
    this.empposdesc,
    this.empposid,
    this.empposcode,
    this.empposlvlid,
    this.groupname,
    this.country,
    this.email,
    this.town,
    this.tel,
    this.city,
    this.firstname,
    this.lastname,
    this.nation,
    this.mobiletel,
    this.birthdate,
    this.gender,
    this.langid,
    this.gidstr,
    this.hotelname,
    this.acccode,
    this.accdesc,
    this.district,
    this.tel2,
    this.cardtypecode,
    this.langcode,
    this.langdesc,
    this.cardtypedesc,
    this.tridno,
    this.genderdesc,
    this.maritalstatus,
    this.maritalstatusdesc,
    this.lastci,
    this.lastco,
    this.totalvisit,
    this.totalstay,
    this.totalroomrate,
    this.totalextra,
    this.totalrevenue,
    this.lastroom,
    this.lastroomrate,
    this.birthplace,
    this.idtype,
    this.idno,
    this.nationdesc,
    this.cardtypeisext,
    this.cardtypeisstd,
    this.countrydesc,
    this.clientrefid,
    this.clientrefcode,
    this.clientmid,
    this.clienthotelrefno,
    this.clienthotelname,
    this.masterid,
    this.enddate,
    this.accid,
    this.isactive,
    this.startdate,
    this.empid,
    this.expiredate,
    this.cardtypeid,
    this.currid,
    this.isdelivered,
    this.reqdate,
    this.cardno,
    this.note,
    this.nextbonusreq,
    this.nextbonustotal,
    this.nextcardtypeid,
    this.nextcardtypecode,
    this.nextcardtypedesc,
    this.clientbonustotal,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Memcard.fromJson(Map<String, dynamic> json) {
    return Memcard(
      reservno: json[DBConst.FDN_RESERVNO],
      roomno: json[DBConst.FDN_ROOMNO],
      agencyid: json[DBConst.FDN_AGENCYID],
      checkin: json[DBConst.FDN_CHECKIN],
      checkout: json[DBConst.FDN_CHECKOUT],
      totalprice: json[DBConst.FDN_TOTALPRICE],
      pricecurr: json[DBConst.FDN_PRICECURR],
      empname: json[DBConst.FDN_EMPNAME],
      empcode: json[DBConst.FDN_EMPCODE],
      resrefcode: json[DBConst.FDN_RESREFCODE],
      reshotelrefno: json[DBConst.FDN_RESHOTELREFNO],
      currcode: json[DBConst.FDN_CURRCODE],
      currdesc: json[DBConst.FDN_CURRDESC],
      clientage: json[DBConst.FDN_CLIENTAGE],
      agencycode: json[DBConst.FDN_AGENCYCODE],
      resrefid: json[DBConst.FDN_RESREFID],
      resmarketcode: json[DBConst.FDN_RESMARKETCODE],
      cardtypebonusmin: json[DBConst.FDN_CARDTYPEBONUSMIN],
      prevcardtypecode: json[DBConst.FDN_PREVCARDTYPECODE],
      reshotelname: json[DBConst.FDN_RESHOTELNAME],
      empdepartdesc: json[DBConst.FDN_EMPDEPARTDESC],
      empdepartid: json[DBConst.FDN_EMPDEPARTID],
      empdepartcode: json[DBConst.FDN_EMPDEPARTCODE],
      empposlvlcode: json[DBConst.FDN_EMPPOSLVLCODE],
      empposdesc: json[DBConst.FDN_EMPPOSDESC],
      empposid: json[DBConst.FDN_EMPPOSID],
      empposcode: json[DBConst.FDN_EMPPOSCODE],
      empposlvlid: json[DBConst.FDN_EMPPOSLVLID],
      groupname: json[DBConst.FDN_GROUPNAME],
      country: json[DBConst.FDN_COUNTRY],
      email: json[DBConst.FDN_EMAIL],
      town: json[DBConst.FDN_TOWN],
      tel: json[DBConst.FDN_TEL],
      city: json[DBConst.FDN_CITY],
      firstname: json[DBConst.FDN_FIRSTNAME],
      lastname: json[DBConst.FDN_LASTNAME],
      nation: json[DBConst.FDN_NATION],
      mobiletel: json[DBConst.FDN_MOBILETEL],
      birthdate: json[DBConst.FDN_BIRTHDATE],
      gender: json[DBConst.FDN_GENDER],
      langid: json[DBConst.FDN_LANGID],
      gidstr: json[DBConst.FDN_GIDSTR],
      hotelname: json[DBConst.FDN_HOTELNAME],
      acccode: json[DBConst.FDN_ACCCODE],
      accdesc: json[DBConst.FDN_ACCDESC],
      district: json[DBConst.FDN_DISTRICT],
      tel2: json[DBConst.FDN_TEL2],
      cardtypecode: json[DBConst.FDN_CARDTYPECODE],
      langcode: json[DBConst.FDN_LANGCODE],
      langdesc: json[DBConst.FDN_LANGDESC],
      cardtypedesc: json[DBConst.FDN_CARDTYPEDESC],
      tridno: json[DBConst.FDN_TRIDNO],
      genderdesc: json[DBConst.FDN_GENDERDESC],
      maritalstatus: json[DBConst.FDN_MARITALSTATUS],
      maritalstatusdesc: json[DBConst.FDN_MARITALSTATUSDESC],
      lastci: json[DBConst.FDN_LASTCI],
      lastco: json[DBConst.FDN_LASTCO],
      totalvisit: json[DBConst.FDN_TOTALVISIT],
      totalstay: json[DBConst.FDN_TOTALSTAY],
      totalroomrate: json[DBConst.FDN_TOTALROOMRATE],
      totalextra: json[DBConst.FDN_TOTALEXTRA],
      totalrevenue: json[DBConst.FDN_TOTALREVENUE],
      lastroom: json[DBConst.FDN_LASTROOM],
      lastroomrate: json[DBConst.FDN_LASTROOMRATE],
      birthplace: json[DBConst.FDN_BIRTHPLACE],
      idtype: json[DBConst.FDN_IDTYPE],
      idno: json[DBConst.FDN_IDNO],
      nationdesc: json[DBConst.FDN_NATIONDESC],
      cardtypeisext: json[DBConst.FDN_CARDTYPEISEXT],
      cardtypeisstd: json[DBConst.FDN_CARDTYPEISSTD],
      countrydesc: json[DBConst.FDN_COUNTRYDESC],
      clientrefid: json[DBConst.FDN_RESERVNO],
      clientrefcode: json[DBConst.FDN_CLIENTREFCODE],
      clientmid: json[DBConst.FDN_CLIENTMID],
      clienthotelrefno: json[DBConst.FDN_CLIENTHOTELREFNO],
      clienthotelname: json[DBConst.FDN_CLIENTHOTELNAME],
      masterid: json[DBConst.FDN_MASTERID],
      enddate: json[DBConst.FDN_ENDDATE],
      accid: json[DBConst.FDN_ACCID],
      isactive: json[DBConst.FDN_ISACTIVE],
      startdate: json[DBConst.FDN_STARTDATE],
      empid: json[DBConst.FDN_EMPID],
      expiredate: json[DBConst.FDN_EXPIREDATE],
      cardtypeid: json[DBConst.FDN_CARDTYPEID],
      currid: json[DBConst.FDN_CURRID],
      isdelivered: json[DBConst.FDN_ISDEELIVERED],
      reqdate: json[DBConst.FDN_REQDATE],
      cardno: json[DBConst.FDN_CARDNO],
      note: json[DBConst.FDN_NOTE],
      nextbonusreq: json[DBConst.FDN_NEXTBONUSREQ],
      nextbonustotal: json[DBConst.FDN_NEXTBONUSTOTAL],
      nextcardtypeid: json[DBConst.FDN_NEXTCARDTYPEID],
      nextcardtypecode: json[DBConst.FDN_NEXTCARDTYPECODE],
      nextcardtypedesc: json[DBConst.FDN_NEXTCARDTYPEDESC],
      clientbonustotal: json[DBConst.FDN_CLIENTBONUSTOTAL],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_RESERVNO: reservno,
      DBConst.FDN_ROOMNO: roomno,
      DBConst.FDN_AGENCYID: agencyid,
      DBConst.FDN_CHECKIN: checkin,
      DBConst.FDN_CHECKOUT: checkout,
      DBConst.FDN_TOTALPRICE: totalprice,
      DBConst.FDN_PRICECURR: pricecurr,
      DBConst.FDN_EMPNAME: empname,
      DBConst.FDN_EMPCODE: empcode,
      DBConst.FDN_RESREFCODE: resrefcode,
      DBConst.FDN_RESHOTELREFNO: reshotelrefno,
      DBConst.FDN_CURRCODE: currcode,
      DBConst.FDN_CURRDESC: currdesc,
      DBConst.FDN_CLIENTAGE: clientage,
      DBConst.FDN_AGENCYCODE: agencycode,
      DBConst.FDN_RESREFID: resrefid,
      DBConst.FDN_RESMARKETCODE: resmarketcode,
      DBConst.FDN_CARDTYPEBONUSMIN: cardtypebonusmin,
      DBConst.FDN_PREVCARDTYPECODE: prevcardtypecode,
      DBConst.FDN_RESHOTELNAME: reshotelname,
      DBConst.FDN_EMPDEPARTDESC: empdepartdesc,
      DBConst.FDN_EMPDEPARTID: empdepartid,
      DBConst.FDN_EMPDEPARTCODE: empdepartcode,
      DBConst.FDN_EMPPOSLVLCODE: empposlvlcode,
      DBConst.FDN_EMPPOSDESC: empposdesc,
      DBConst.FDN_EMPPOSID: empposid,
      DBConst.FDN_EMPPOSCODE: empposcode,
      DBConst.FDN_EMPPOSLVLID: empposlvlid,
      DBConst.FDN_GROUPNAME: groupname,
      DBConst.FDN_COUNTRY: country,
      DBConst.FDN_EMAIL: email,
      DBConst.FDN_TOWN: town,
      DBConst.FDN_TEL: tel,
      DBConst.FDN_CITY: city,
      DBConst.FDN_FIRSTNAME: firstname,
      DBConst.FDN_LASTNAME: lastname,
      DBConst.FDN_NATION: nation,
      DBConst.FDN_MOBILETEL: mobiletel,
      DBConst.FDN_BIRTHDATE: birthdate,
      DBConst.FDN_GENDER: gender,
      DBConst.FDN_LANGID: langid,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ACCCODE: acccode,
      DBConst.FDN_ACCDESC: accdesc,
      DBConst.FDN_DISTRICT: district,
      DBConst.FDN_TEL2: tel2,
      DBConst.FDN_CARDTYPECODE: cardtypecode,
      DBConst.FDN_LANGCODE: langcode,
      DBConst.FDN_LANGDESC: langdesc,
      DBConst.FDN_CARDTYPEDESC: cardtypedesc,
      DBConst.FDN_TRIDNO: tridno,
      DBConst.FDN_GENDERDESC: genderdesc,
      DBConst.FDN_MARITALSTATUS: maritalstatus,
      DBConst.FDN_MARITALSTATUSDESC: maritalstatusdesc,
      DBConst.FDN_LASTCI: lastci,
      DBConst.FDN_LASTCO: lastco,
      DBConst.FDN_TOTALVISIT: totalvisit,
      DBConst.FDN_TOTALSTAY: totalstay,
      DBConst.FDN_TOTALROOMRATE: totalroomrate,
      DBConst.FDN_TOTALEXTRA: totalextra,
      DBConst.FDN_TOTALREVENUE: totalrevenue,
      DBConst.FDN_LASTROOM: lastroom,
      DBConst.FDN_LASTROOMRATE: lastroomrate,
      DBConst.FDN_BIRTHPLACE: birthplace,
      DBConst.FDN_IDTYPE: idtype,
      DBConst.FDN_IDNO: idno,
      DBConst.FDN_NATIONDESC: nationdesc,
      DBConst.FDN_CARDTYPEISEXT: cardtypeisext,
      DBConst.FDN_CARDTYPEISSTD: cardtypeisstd,
      DBConst.FDN_COUNTRYDESC: countrydesc,
      DBConst.FDN_CLIENTREFID: clientrefid,
      DBConst.FDN_CLIENTREFCODE: clientrefcode,
      DBConst.FDN_CLIENTMID: clientmid,
      DBConst.FDN_CLIENTHOTELREFNO: clienthotelrefno,
      DBConst.FDN_CLIENTHOTELNAME: clienthotelname,
      DBConst.FDN_MASTERID: masterid,
      DBConst.FDN_ENDDATE: enddate,
      DBConst.FDN_ACCID: accid,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_STARTDATE: startdate,
      DBConst.FDN_EMPID: empid,
      DBConst.FDN_EXPIREDATE: expiredate,
      DBConst.FDN_CARDTYPEID: cardtypeid,
      DBConst.FDN_CURRID: currid,
      DBConst.FDN_ISDELIVERED: isdelivered,
      DBConst.FDN_REQDATE: reqdate,
      DBConst.FDN_CARDNO: cardno,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_NEXTBONUSREQ: nextbonusreq,
      DBConst.FDN_NEXTBONUSTOTAL: nextbonustotal,
      DBConst.FDN_NEXTCARDTYPEID: nextcardtypeid,
      DBConst.FDN_NEXTCARDTYPECODE: nextcardtypecode,
      DBConst.FDN_NEXTCARDTYPEDESC: nextcardtypedesc,
      DBConst.FDN_CLIENTBONUSTOTAL: clientbonustotal,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Memcard &&
          runtimeType == other.runtimeType &&
          reservno == other.reservno &&
          roomno == other.roomno &&
          agencyid == other.agencyid &&
          checkin == other.checkin &&
          checkout == other.checkout &&
          nextbonusreq == other.nextbonusreq &&
          nextbonustotal == other.nextbonustotal &&
          nextcardtypeid == other.nextcardtypeid &&
          nextcardtypecode == other.nextcardtypecode &&
          nextcardtypedesc == other.nextcardtypedesc &&
          clientbonustotal == other.clientbonustotal &&
          totalprice == other.totalprice &&
          pricecurr == other.pricecurr &&
          empname == other.empname &&
          empcode == other.empcode &&
          resrefcode == other.resrefcode &&
          reshotelrefno == other.reshotelrefno &&
          currcode == other.currcode &&
          currdesc == other.currdesc &&
          clientage == other.clientage &&
          agencycode == other.agencycode &&
          resrefid == other.resrefid &&
          resmarketcode == other.resmarketcode &&
          cardtypebonusmin == other.cardtypebonusmin &&
          prevcardtypecode == other.prevcardtypecode &&
          reshotelname == other.reshotelname &&
          empdepartdesc == other.empdepartdesc &&
          empdepartid == other.empdepartid &&
          empdepartcode == other.empdepartcode &&
          empposlvlcode == other.empposlvlcode &&
          empposdesc == other.empposdesc &&
          empposid == other.empposid &&
          empposcode == other.empposcode &&
          empposlvlid == other.empposlvlid &&
          groupname == other.groupname &&
          country == other.country &&
          email == other.email &&
          town == other.town &&
          tel == other.tel &&
          city == other.city &&
          firstname == other.firstname &&
          lastname == other.lastname &&
          nation == other.nation &&
          mobiletel == other.mobiletel &&
          birthdate == other.birthdate &&
          gender == other.gender &&
          langid == other.langid &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          acccode == other.acccode &&
          accdesc == other.accdesc &&
          district == other.district &&
          tel2 == other.tel2 &&
          cardtypecode == other.cardtypecode &&
          langcode == other.langcode &&
          langdesc == other.langdesc &&
          cardtypedesc == other.cardtypedesc &&
          tridno == other.tridno &&
          genderdesc == other.genderdesc &&
          maritalstatus == other.maritalstatus &&
          maritalstatusdesc == other.maritalstatusdesc &&
          lastci == other.lastci &&
          lastco == other.lastco &&
          totalvisit == other.totalvisit &&
          totalstay == other.totalstay &&
          totalroomrate == other.totalroomrate &&
          totalextra == other.totalextra &&
          totalrevenue == other.totalrevenue &&
          lastroom == other.lastroom &&
          lastroomrate == other.lastroomrate &&
          birthplace == other.birthplace &&
          idtype == other.idtype &&
          idno == other.idno &&
          nationdesc == other.nationdesc &&
          cardtypeisext == other.cardtypeisext &&
          cardtypeisstd == other.cardtypeisstd &&
          countrydesc == other.countrydesc &&
          clientrefid == other.clientrefid &&
          clientrefcode == other.clientrefcode &&
          clientmid == other.clientmid &&
          clienthotelrefno == other.clienthotelrefno &&
          clienthotelname == other.clienthotelname &&
          masterid == other.masterid &&
          enddate == other.enddate &&
          accid == other.accid &&
          isactive == other.isactive &&
          startdate == other.startdate &&
          empid == other.empid &&
          expiredate == other.expiredate &&
          cardtypeid == other.cardtypeid &&
          currid == other.currid &&
          isdelivered == other.isdelivered &&
          reqdate == other.reqdate &&
          cardno == other.cardno &&
          note == other.note &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      reservno.hashCode ^
      roomno.hashCode ^
      agencyid.hashCode ^
      checkin.hashCode ^
      checkout.hashCode ^
      nextbonusreq.hashCode ^
      nextbonustotal.hashCode ^
      nextcardtypeid.hashCode ^
      nextcardtypecode.hashCode ^
      nextcardtypedesc.hashCode ^
      clientbonustotal.hashCode ^
      totalprice.hashCode ^
      pricecurr.hashCode ^
      empname.hashCode ^
      empcode.hashCode ^
      resrefcode.hashCode ^
      reshotelrefno.hashCode ^
      currcode.hashCode ^
      currdesc.hashCode ^
      clientage.hashCode ^
      agencycode.hashCode ^
      resrefid.hashCode ^
      resmarketcode.hashCode ^
      cardtypebonusmin.hashCode ^
      prevcardtypecode.hashCode ^
      reshotelname.hashCode ^
      empdepartdesc.hashCode ^
      empdepartid.hashCode ^
      empdepartcode.hashCode ^
      empposlvlcode.hashCode ^
      empposdesc.hashCode ^
      empposid.hashCode ^
      empposcode.hashCode ^
      empposlvlid.hashCode ^
      groupname.hashCode ^
      country.hashCode ^
      email.hashCode ^
      town.hashCode ^
      tel.hashCode ^
      city.hashCode ^
      firstname.hashCode ^
      lastname.hashCode ^
      nation.hashCode ^
      mobiletel.hashCode ^
      birthdate.hashCode ^
      gender.hashCode ^
      langid.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      acccode.hashCode ^
      accdesc.hashCode ^
      district.hashCode ^
      tel2.hashCode ^
      cardtypecode.hashCode ^
      langcode.hashCode ^
      langdesc.hashCode ^
      cardtypedesc.hashCode ^
      tridno.hashCode ^
      genderdesc.hashCode ^
      maritalstatus.hashCode ^
      maritalstatusdesc.hashCode ^
      lastci.hashCode ^
      lastco.hashCode ^
      totalvisit.hashCode ^
      totalstay.hashCode ^
      totalroomrate.hashCode ^
      totalextra.hashCode ^
      totalrevenue.hashCode ^
      lastroom.hashCode ^
      lastroomrate.hashCode ^
      birthplace.hashCode ^
      idtype.hashCode ^
      idno.hashCode ^
      nationdesc.hashCode ^
      cardtypeisext.hashCode ^
      cardtypeisstd.hashCode ^
      countrydesc.hashCode ^
      clientrefid.hashCode ^
      clientrefcode.hashCode ^
      clientmid.hashCode ^
      clienthotelrefno.hashCode ^
      clienthotelname.hashCode ^
      masterid.hashCode ^
      enddate.hashCode ^
      accid.hashCode ^
      isactive.hashCode ^
      startdate.hashCode ^
      empid.hashCode ^
      expiredate.hashCode ^
      cardtypeid.hashCode ^
      currid.hashCode ^
      isdelivered.hashCode ^
      reqdate.hashCode ^
      cardno.hashCode ^
      note.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Memcard{reservno: $reservno, roomno: $roomno, agencyid: $agencyid, checkin: $checkin, checkout: $checkout, nextbonusreq: $nextbonusreq, nextbonustotal: $nextbonustotal, nextcardtypeid: $nextcardtypeid, nextcardtypecode: $nextcardtypecode, nextcardtypedesc: $nextcardtypedesc, clientbonustotal: $clientbonustotal, totalprice: $totalprice, pricecurr: $pricecurr, empname: $empname, empcode: $empcode, resrefcode: $resrefcode, reshotelrefno: $reshotelrefno, currcode: $currcode, currdesc: $currdesc, clientage: $clientage, agencycode: $agencycode, resrefid: $resrefid, resmarketcode: $resmarketcode, cardtypebonusmin: $cardtypebonusmin, prevcardtypecode: $prevcardtypecode, reshotelname: $reshotelname, empdepartdesc: $empdepartdesc, empdepartid: $empdepartid, empdepartcode: $empdepartcode, empposlvlcode: $empposlvlcode, empposdesc: $empposdesc, empposid: $empposid, empposcode: $empposcode, empposlvlid: $empposlvlid, groupname: $groupname, country: $country, email: $email, town: $town, tel: $tel, city: $city, firstname: $firstname, lastname: $lastname, nation: $nation, mobiletel: $mobiletel, birthdate: $birthdate, gender: $gender, langid: $langid, gidstr: $gidstr, hotelname: $hotelname, acccode: $acccode, accdesc: $accdesc, district: $district, tel2: $tel2, cardtypecode: $cardtypecode, langcode: $langcode, langdesc: $langdesc, cardtypedesc: $cardtypedesc, tridno: $tridno, genderdesc: $genderdesc, maritalstatus: $maritalstatus, maritalstatusdesc: $maritalstatusdesc, lastci: $lastci, lastco: $lastco, totalvisit: $totalvisit, totalstay: $totalstay, totalroomrate: $totalroomrate, totalextra: $totalextra, totalrevenue: $totalrevenue, lastroom: $lastroom, lastroomrate: $lastroomrate, birthplace: $birthplace, idtype: $idtype, idno: $idno, nationdesc: $nationdesc, cardtypeisext: $cardtypeisext, cardtypeisstd: $cardtypeisstd, countrydesc: $countrydesc, clientrefid: $clientrefid, clientrefcode: $clientrefcode, clientmid: $clientmid, clienthotelrefno: $clienthotelrefno, clienthotelname: $clienthotelname, masterid: $masterid, enddate: $enddate, accid: $accid, isactive: $isactive, startdate: $startdate, empid: $empid, expiredate: $expiredate, cardtypeid: $cardtypeid, currid: $currid, isdelivered: $isdelivered, reqdate: $reqdate, cardno: $cardno, note: $note, jsonMap: $jsonMap}';
  }
}
