import 'package:hotech_flutter_utilities/Constants.dart';

class LoginAuth {
  String accessToken;
  String refreshToken;
  String tokenType;
  int expiresIn;
  String scope;

  LoginAuth({
    this.accessToken,
    this.refreshToken,
    this.tokenType,
    this.expiresIn,
    this.scope,
  });

  factory LoginAuth.fromJson(Map<String, dynamic> json) {
    return LoginAuth(
      accessToken: json[DBConst.FDN_ACCESS_TOKEN],
      refreshToken: json[DBConst.FDN_REFRESH_TOKEN],
      tokenType: json[DBConst.FDN_TOKEN_TYPE],
      expiresIn: json[DBConst.FDN_EXPIRES_IN],
      scope: json[DBConst.FDN_SCOPE],
    );
  }
}