import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Sproduct extends BaseModelCode {
  String pricecurr;
  String gidstr;
  String descineng;
  String hotelname;
  String longdesc;
  String codestr;
  String currencycode;
  String currencydesc;
  String qtycode;
  String qtydesc;
  String salegroupcode;
  String salegroupdesc;
  String stockitem;
  String spgroup;
  String producttype;
  String spgroupname;
  double lastpricecost;
  double avgpricecost;
  String spgroupcode;
  String spgroupdesc;
  String setupastime;
  String durationastime;
  String setdownastime;
  String producttypedesc;
  String producttypecode;
  String groupname;
  String duration;
  String currency;
  bool isorsactive;
  String setuptime;
  String setdowntime;
  int currencyid;
  int orderno;
  String qty;
  int qtyid;
  String salegroup;
  int salegroupid;
  double taxrate;
  double saleprice;
  int spgroupid;
  int durationmin;
  String starttime;
  String ineng;
  int producttypeid;
  int courseno;
  String barcode;
  String imagefolder;
  String cookduration;
  bool useenergy;
  String cooktext;
  String thumburl;
  bool isdirectsale;
  double extprice;
  String preptext;
  String prepduration;
  int empcount;
  int setuptimemin;
  int setdowntimemin;
  int cookdurationmin;
  int prepdurationmin;
  bool isactive;
  String updatetime;

  Map<String, dynamic> jsonMap;

  Sproduct(
      {this.pricecurr,
      this.gidstr,
      this.descineng,
      this.hotelname,
      this.longdesc,
      this.codestr,
      this.currencycode,
      this.currencydesc,
      this.qtycode,
      this.qtydesc,
      this.salegroupcode,
      this.salegroupdesc,
      this.stockitem,
      this.spgroup,
      this.producttype,
      this.spgroupname,
      this.lastpricecost,
      this.avgpricecost,
      this.spgroupcode,
      this.spgroupdesc,
      this.setupastime,
      this.durationastime,
      this.setdownastime,
      this.producttypedesc,
      this.producttypecode,
      this.groupname,
      this.duration,
      this.currency,
      this.isorsactive,
      this.setuptime,
      this.setdowntime,
      this.currencyid,
      this.orderno,
      this.qty,
      this.qtyid,
      this.salegroup,
      this.salegroupid,
      this.taxrate,
      this.saleprice,
      this.spgroupid,
      this.durationmin,
      this.starttime,
      this.ineng,
      this.producttypeid,
      this.courseno,
      this.barcode,
      this.imagefolder,
      this.cookduration,
      this.useenergy,
      this.cooktext,
      this.thumburl,
      this.isdirectsale,
      this.extprice,
      this.preptext,
      this.prepduration,
      this.empcount,
      this.setuptimemin,
      this.setdowntimemin,
      this.cookdurationmin,
      this.prepdurationmin,
      this.isactive,
      this.updatetime,
      this.jsonMap})
      : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Sproduct.fromJson(Map<String, dynamic> json) {
    return Sproduct(
      pricecurr: json[DBConst.FDN_PRICECURR],
      gidstr: json[DBConst.FDN_GIDSTR],
      descineng: json[DBConst.FDN_DESCINENG],
      hotelname: json[DBConst.FDN_HOTELNAME],
      longdesc: json[DBConst.FDN_LONGDESC],
      codestr: json[DBConst.FDN_CODESTR],
      currencycode: json[DBConst.FDN_CURRENCYCODE],
      currencydesc: json[DBConst.FDN_CURRENCYDESC],
      qtycode: json[DBConst.FDN_QTYCODE],
      qtydesc: json[DBConst.FDN_QTYDESC],
      salegroupcode: json[DBConst.FDN_SALEGROUPCODE],
      salegroupdesc: json[DBConst.FDN_SALEGROUPDESC],
      stockitem: json[DBConst.FDN_STOCKITEM],
      spgroup: json[DBConst.FDN_SPGROUP],
      producttype: json[DBConst.FDN_PRODUCTTYPE],
      spgroupname: json[DBConst.FDN_SPGROUPNAME],
      lastpricecost: json[DBConst.FDN_LASTPRICECOST],
      avgpricecost: json[DBConst.FDN_AVGPRICECOST],
      spgroupcode: json[DBConst.FDN_SPGROUPCODE],
      spgroupdesc: json[DBConst.FDN_SPGROUPDESC],
      setupastime: json[DBConst.FDN_SETUPASTIME],
      durationastime: json[DBConst.FDN_DURATIONASTIME],
      setdownastime: json[DBConst.FDN_SETDOWNASTIME],
      producttypedesc: json[DBConst.FDN_PRODUCTTYPEDESC],
      producttypecode: json[DBConst.FDN_PRODUCTTYPECODE],
      groupname: json[DBConst.FDN_GROUPNAME],
      duration: json[DBConst.FDN_DURATION],
      currency: json[DBConst.FDN_CURRENCY],
      isorsactive: json[DBConst.FDN_ISORSACTIVE],
      setuptime: json[DBConst.FDN_SETUPTIME],
      setdowntime: json[DBConst.FDN_SETDOWNTIME],
      currencyid: json[DBConst.FDN_CURRENCYID],
      orderno: json[DBConst.FDN_ORDERNO],
      qty: json[DBConst.FDN_QTY],
      qtyid: json[DBConst.FDN_QTYID],
      salegroup: json[DBConst.FDN_SALEGROUP],
      salegroupid: json[DBConst.FDN_SALEGROUPID],
      taxrate: json[DBConst.FDN_TAXRATE],
      saleprice: json[DBConst.FDN_SALEPRICE],
      spgroupid: json[DBConst.FDN_SPGROUPID],
      durationmin: json[DBConst.FDN_DURATIONMIN],
      starttime: json[DBConst.FDN_STARTTIME],
      ineng: json[DBConst.FDN_INENG],
      producttypeid: json[DBConst.FDN_PRODUCTTYPEID],
      courseno: json[DBConst.FDN_COURSENO],
      barcode: json[DBConst.FDN_BARCODE],
      imagefolder: json[DBConst.FDN_IMAGEFOLDER],
      cookduration: json[DBConst.FDN_COOKDURATION],
      useenergy: json[DBConst.FDN_USEENERGY],
      cooktext: json[DBConst.FDN_COOKTEXT],
      thumburl: json[DBConst.FDN_THUMBURL],
      isdirectsale: json[DBConst.FDN_ISDIRECTSALE],
      extprice: json[DBConst.FDN_EXTPRICE],
      preptext: json[DBConst.FDN_PREPTEXT],
      prepduration: json[DBConst.FDN_PREPDURATION],
      empcount: json[DBConst.FDN_EMPCOUNT],
      setuptimemin: json[DBConst.FDN_SETUPTIMEMIN],
      setdowntimemin: json[DBConst.FDN_SETDOWNTIMEMIN],
      cookdurationmin: json[DBConst.FDN_COOKDURATIONMIN],
      prepdurationmin: json[DBConst.FDN_PREPDURATIONMIN],
      isactive: json[DBConst.FDN_ISACTIVE],
      updatetime: json[DBConst.FDN_UPDATETIME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_PRICECURR: pricecurr,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_DESCINENG: descineng,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_LONGDESC: longdesc,
      DBConst.FDN_CODESTR: codestr,
      DBConst.FDN_CURRENCYCODE: currencycode,
      DBConst.FDN_CURRENCYDESC: currencydesc,
      DBConst.FDN_QTYCODE: qtycode,
      DBConst.FDN_QTYDESC: qtydesc,
      DBConst.FDN_SALEGROUPCODE: salegroupcode,
      DBConst.FDN_SALEGROUPDESC: salegroupdesc,
      DBConst.FDN_STOCKITEM: stockitem,
      DBConst.FDN_SPGROUP: spgroup,
      DBConst.FDN_PRODUCTTYPE: producttype,
      DBConst.FDN_SPGROUPNAME: spgroupname,
      DBConst.FDN_LASTPRICECOST: lastpricecost,
      DBConst.FDN_AVGPRICECOST: avgpricecost,
      DBConst.FDN_SPGROUPCODE: spgroupcode,
      DBConst.FDN_SPGROUPDESC: spgroupdesc,
      DBConst.FDN_SETUPASTIME: setupastime,
      DBConst.FDN_DURATIONASTIME: durationastime,
      DBConst.FDN_SETDOWNASTIME: setdownastime,
      DBConst.FDN_PRODUCTTYPEDESC: producttypedesc,
      DBConst.FDN_PRODUCTTYPECODE: producttypecode,
      DBConst.FDN_GROUPNAME: groupname,
      DBConst.FDN_DURATION: duration,
      DBConst.FDN_CURRENCY: currency,
      DBConst.FDN_ISORSACTIVE: isorsactive,
      DBConst.FDN_SETUPTIME: setuptime,
      DBConst.FDN_SETDOWNTIME: setdowntime,
      DBConst.FDN_CURRENCYID: currencyid,
      DBConst.FDN_ORDERNO: orderno,
      DBConst.FDN_QTY: qty,
      DBConst.FDN_QTYID: qtyid,
      DBConst.FDN_SALEGROUP: salegroup,
      DBConst.FDN_SALEGROUPID: salegroupid,
      DBConst.FDN_TAXRATE: taxrate,
      DBConst.FDN_SALEPRICE: saleprice,
      DBConst.FDN_SPGROUPID: spgroupid,
      DBConst.FDN_DURATIONMIN: durationmin,
      DBConst.FDN_STARTTIME: starttime,
      DBConst.FDN_INENG: ineng,
      DBConst.FDN_PRODUCTTYPEID: producttypeid,
      DBConst.FDN_COURSENO: courseno,
      DBConst.FDN_BARCODE: barcode,
      DBConst.FDN_IMAGEFOLDER: imagefolder,
      DBConst.FDN_COOKDURATION: cookduration,
      DBConst.FDN_USEENERGY: useenergy,
      DBConst.FDN_COOKTEXT: cooktext,
      DBConst.FDN_THUMBURL: thumburl,
      DBConst.FDN_ISDIRECTSALE: isdirectsale,
      DBConst.FDN_EXTPRICE: extprice,
      DBConst.FDN_PREPTEXT: preptext,
      DBConst.FDN_PREPDURATION: prepduration,
      DBConst.FDN_EMPCOUNT: empcount,
      DBConst.FDN_SETUPTIMEMIN: setuptimemin,
      DBConst.FDN_SETDOWNTIMEMIN: setdowntimemin,
      DBConst.FDN_COOKDURATIONMIN: cookdurationmin,
      DBConst.FDN_PREPDURATIONMIN: prepdurationmin,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_UPDATETIME: updatetime,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == (other) &&
          other is Sproduct &&
          runtimeType == other.runtimeType &&
          pricecurr == other.pricecurr &&
          gidstr == other.gidstr &&
          descineng == other.descineng &&
          hotelname == other.hotelname &&
          longdesc == other.longdesc &&
          codestr == other.codestr &&
          currencycode == other.currencycode &&
          currencydesc == other.currencydesc &&
          qtycode == other.qtycode &&
          qtydesc == other.qtydesc &&
          salegroupcode == other.salegroupcode &&
          salegroupdesc == other.salegroupdesc &&
          stockitem == other.stockitem &&
          spgroup == other.spgroup &&
          producttype == other.producttype &&
          spgroupname == other.spgroupname &&
          lastpricecost == other.lastpricecost &&
          avgpricecost == other.avgpricecost &&
          spgroupcode == other.spgroupcode &&
          spgroupdesc == other.spgroupdesc &&
          setupastime == other.setupastime &&
          durationastime == other.durationastime &&
          setdownastime == other.setdownastime &&
          producttypedesc == other.producttypedesc &&
          producttypecode == other.producttypecode &&
          groupname == other.groupname &&
          duration == other.duration &&
          currency == other.currency &&
          isorsactive == other.isorsactive &&
          setuptime == other.setuptime &&
          setdowntime == other.setdowntime &&
          currencyid == other.currencyid &&
          orderno == other.orderno &&
          qty == other.qty &&
          qtyid == other.qtyid &&
          salegroup == other.salegroup &&
          salegroupid == other.salegroupid &&
          taxrate == other.taxrate &&
          saleprice == other.saleprice &&
          spgroupid == other.spgroupid &&
          durationmin == other.durationmin &&
          starttime == other.starttime &&
          ineng == other.ineng &&
          producttypeid == other.producttypeid &&
          courseno == other.courseno &&
          barcode == other.barcode &&
          imagefolder == other.imagefolder &&
          cookduration == other.cookduration &&
          useenergy == other.useenergy &&
          cooktext == other.cooktext &&
          thumburl == other.thumburl &&
          isdirectsale == other.isdirectsale &&
          extprice == other.extprice &&
          preptext == other.preptext &&
          prepduration == other.prepduration &&
          empcount == other.empcount &&
          setuptimemin == other.setuptimemin &&
          setdowntimemin == other.setdowntimemin &&
          cookdurationmin == other.cookdurationmin &&
          prepdurationmin == other.prepdurationmin &&
          isactive == other.isactive &&
          updatetime == other.updatetime;

  @override
  int get hashCode =>
      super.hashCode ^
      pricecurr.hashCode ^
      gidstr.hashCode ^
      descineng.hashCode ^
      hotelname.hashCode ^
      longdesc.hashCode ^
      codestr.hashCode ^
      currencycode.hashCode ^
      currencydesc.hashCode ^
      qtycode.hashCode ^
      qtydesc.hashCode ^
      salegroupcode.hashCode ^
      salegroupdesc.hashCode ^
      stockitem.hashCode ^
      spgroup.hashCode ^
      producttype.hashCode ^
      spgroupname.hashCode ^
      lastpricecost.hashCode ^
      avgpricecost.hashCode ^
      spgroupcode.hashCode ^
      spgroupdesc.hashCode ^
      setupastime.hashCode ^
      durationastime.hashCode ^
      setdownastime.hashCode ^
      producttypedesc.hashCode ^
      producttypecode.hashCode ^
      groupname.hashCode ^
      duration.hashCode ^
      currency.hashCode ^
      isorsactive.hashCode ^
      setuptime.hashCode ^
      setdowntime.hashCode ^
      currencyid.hashCode ^
      orderno.hashCode ^
      qty.hashCode ^
      qtyid.hashCode ^
      salegroup.hashCode ^
      salegroupid.hashCode ^
      starttime.hashCode ^
      ineng.hashCode ^
      producttypeid.hashCode ^
      courseno.hashCode ^
      barcode.hashCode ^
      imagefolder.hashCode ^
      cookduration.hashCode ^
      useenergy.hashCode ^
      cooktext.hashCode ^
      thumburl.hashCode ^
      isdirectsale.hashCode ^
      extprice.hashCode ^
      preptext.hashCode ^
      prepduration.hashCode ^
      empcount.hashCode ^
      setuptimemin.hashCode ^
      setdowntimemin.hashCode ^
      cookdurationmin.hashCode ^
      prepdurationmin.hashCode ^
      isactive.hashCode ^
      updatetime.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Sproduct{pricecurr: $pricecurr, gidstr: $gidstr, descineng: $descineng, hotelname: $hotelname, longdesc: $longdesc, codestr: $codestr, currencycode: $currencycode, currencydesc: $currencydesc, qtycode: $qtycode, qtydesc: $qtydesc, salegroupcode: $salegroupcode, salegroupdesc: $salegroupdesc, stockitem: $stockitem, spgroup: $spgroup, producttype: $producttype, spgroupname: $spgroupname, lastpricecost: $lastpricecost, avgpricecost: $avgpricecost, spgroupcode: $spgroupcode, spgroupdesc: $spgroupdesc, setupastime: $setupastime, durationastime: $durationastime, setdownastime: $setdownastime, producttypedesc: $producttypedesc, producttypecode: $producttypecode, groupname: $groupname, duration: $duration, currency: $currency, isorsactive: $isorsactive, setuptime: $setuptime, setdowntime: $setdowntime, currencyid: $currencyid, orderno: $orderno, qty: $qty, qtyid: $qtyid, salegroup: $salegroup, salegroupid: $salegroupid, taxrate: $taxrate, saleprice: $saleprice, spgroupid: $spgroupid, durationmin: $durationmin, starttime: $starttime, ineng: $ineng, producttypeid: $producttypeid, courseno: $courseno, barcode: $barcode, imagefolder: $imagefolder, cookduration: $cookduration, useenergy: $useenergy, cooktext: $cooktext, thumburl: $thumburl, isdirectsale: $isdirectsale, extprice: $extprice, preptext: $preptext, prepduration: $prepduration, empcount: $empcount, setuptimemin: $setuptimemin, setdowntimemin: $setdowntimemin, cookdurationmin: $cookdurationmin, prepdurationmin: $prepdurationmin, isactive: $isactive, updatetime: $updatetime, jsonMap: $jsonMap}';
  }
}
