import 'package:hotech_flutter_utilities/Constants.dart';

class TstransStatEmp {
  String code;
  int empid;
  int totalcount;
  Map<String, dynamic> jsonMap;

  TstransStatEmp({
    this.code,
    this.empid,
    this.totalcount,
    this.jsonMap,
  });

  factory TstransStatEmp.fromJson(Map<String, dynamic> json) => TstransStatEmp(
      code: json[DBConst.FDN_CODE],
      empid: json[DBConst.FDN_EMPID],
      totalcount: json[DBConst.FDN_TOTALCOUNT],
      jsonMap: json);

  Map<String, dynamic> toJson() => {
        DBConst.FDN_CODE: code,
        DBConst.FDN_EMPID: empid,
        DBConst.FDN_TOTALCOUNT: totalcount,
      };

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is TstransStatEmp &&
          runtimeType == other.runtimeType &&
          code == other.code &&
          empid == other.empid &&
          totalcount == other.totalcount &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode => code.hashCode ^ empid.hashCode ^ totalcount.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return 'ForecastDay{code: $code, empid: $empid, totalcount: $totalcount, jsonMap: $jsonMap}';
  }
}
