import 'package:hotech_flutter_utilities/Constants.dart';

class ReminderStatEmp {
  String code;
  int totalcount;
  Map<String, dynamic> jsonMap;

  ReminderStatEmp({this.code, this.totalcount, this.jsonMap});

  factory ReminderStatEmp.fromJson(Map<String, dynamic> json) => new ReminderStatEmp(
        code: json[DBConst.FDN_CODE],
        totalcount: json[DBConst.FDN_TOTALCOUNT],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() => {
        DBConst.FDN_CODE: code,
        DBConst.FDN_TOTALCOUNT: totalcount,
      };

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is ReminderStatEmp &&
          runtimeType == other.runtimeType &&
          code == other.code &&
          totalcount == other.totalcount &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode => code.hashCode ^ totalcount.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return 'ReminderStatEmp{code: $code, totalcount: $totalcount, jsonMap: $jsonMap}';
  }
}
