import 'package:http/http.dart' as http;

class ResponseType {
  static bool isSuccessful(int statusCode) {
    return statusCode == 200;
  }

  static bool isBadRequest(http.Response response) {
    return response.statusCode == 400;
  }

  static bool isUnauthorized(http.Response response) {
    return response.statusCode == 401;
  }

  static bool isServerError(http.Response response) {
    return response.statusCode == 500;
  }
}
