import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsGallery.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class CmsGalleryService extends ServiceFactory<CmsGallery> {
  static CmsGalleryService instance;

  static CmsGalleryService getInstance() {
    return instance != null ? instance : CmsGalleryService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_CMSGALLERY;
  }
}
