import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/crm/Memcard.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class MemcardService extends ServiceFactory<Memcard> {
  static MemcardService instance;

  static MemcardService getInstance() {
    return instance != null ? instance : MemcardService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_MEMCARD;
  }
}
