import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/sales/Agency.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class AgencyService extends ServiceFactory<Agency> {
  static AgencyService instance;

  static AgencyService getInstance() {
    return instance != null ? instance : AgencyService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_AGENCY;
  }
}
