import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/sales/Salegrp.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';

class SalegrpService extends ServiceFactory<Salegrp> {
  static SalegrpService instance;

  static SalegrpService getInstance() {
    return instance != null ? instance : SalegrpService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_SALEGRP;
  }
}
