import 'dart:async';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/model/task/TsDesc.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/SyncRequest.dart';
import 'package:hotech_flutter_utilities/service/SyncResponse.dart';

class TsDescService extends ServiceFactory<TsDesc> {
  static TsDescService instance;

  static TsDescService getInstance() {
    return instance != null ? instance : TsDescService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_TSDESC;
  }

  @override
  Future<SingleDataResult<SyncResponse<TsDesc>>> syncRequest(SyncRequest request) {
    return null;
  }
}
