import 'dart:async';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/model/task/TsStatus.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/SyncRequest.dart';
import 'package:hotech_flutter_utilities/service/SyncResponse.dart';

class TsStatusService extends ServiceFactory<TsStatus> {
  static TsStatusService instance;

  static TsStatusService getInstance() {
    return instance != null ? instance : TsStatusService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_TSSTATUS;
  }

  @override
  Future<SingleDataResult<SyncResponse<TsStatus>>> syncRequest(SyncRequest request) {
    return null;
  }
}
