import 'dart:async';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/model/task/Tstype.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/SyncRequest.dart';
import 'package:hotech_flutter_utilities/service/SyncResponse.dart';

class TstypeService extends ServiceFactory<Tstype> {
  static TstypeService instance;

  static TstypeService getInstance() {
    return instance != null ? instance : TstypeService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_TSTYPE;
  }

  @override
  Future<SingleDataResult<SyncResponse<Tstype>>> syncRequest(SyncRequest request) async {
    return null;
  }
}
